#!/usr/bin/env node
module.exports.tynder =
/******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ "./node_modules/fruitsconfits/modules/lib/object-parser.js":
/*!*****************************************************************!*\
  !*** ./node_modules/fruitsconfits/modules/lib/object-parser.js ***!
  \*****************************************************************/
/*! namespace exports */
/*! export getObjectParsers [provided] [no usage info] [missing usage info prevents renaming] */
/*! export objClass [provided] [no usage info] [missing usage info prevents renaming] */
/*! export objClassByNeedleFn [provided] [no usage info] [missing usage info prevents renaming] */
/*! export objClassNot [provided] [no usage info] [missing usage info prevents renaming] */
/*! export objSequence [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_require__, __webpack_require__.r, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "objSequence": () => /* binding */ objSequence,
/* harmony export */   "objClass": () => /* binding */ objClass,
/* harmony export */   "objClassNot": () => /* binding */ objClassNot,
/* harmony export */   "objClassByNeedleFn": () => /* binding */ objClassByNeedleFn,
/* harmony export */   "getObjectParsers": () => /* binding */ getObjectParsers
/* harmony export */ });
/* harmony import */ var _parser__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./parser */ "./node_modules/fruitsconfits/modules/lib/parser.js");
// Copyright (c) 2019 Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln

function objSequence(helper, comparator) {
  return needle => {
    return input => {
      const len = Math.max(0, input.end - input.start);
      let matched = true;

      if (len >= needle.length) {
        for (let i = 0; i < needle.length; i++) {
          if (!comparator(input.src[input.start + i], needle[i])) {
            matched = false;
            break;
          }
        }
      } else {
        matched = false;
      }

      return matched ? {
        succeeded: true,
        next: {
          src: input.src,
          start: input.start + needle.length,
          end: input.end,
          context: input.context,
          templateArgs: input.templateArgs,
          templateArgsPos: input.templateArgsPos
        },
        tokens: [helper(needle)]
      } : {
        succeeded: false,
        error: false,
        src: input.src,
        pos: input.start,
        // eslint-disable-next-line @typescript-eslint/restrict-template-expressions
        message: `operator "objSequence(${needle})"`
      };
    };
  };
}
function objClass(helper, comparator) {
  // NOTE: <T> version `needles` type is `T`.
  return (...needles) => {
    return input => {
      const len = Math.max(0, input.end - input.start);
      let index = -1;
      const succeeded = len > 0 ? needles.some((needle, idx) => {
        if (comparator(input.src[input.start], needle)) {
          index = idx;
          return true;
        }
      }) : false;
      return succeeded ? {
        succeeded: true,
        next: {
          src: input.src,
          start: input.start + 1,
          end: input.end,
          context: input.context,
          templateArgs: input.templateArgs,
          templateArgsPos: input.templateArgsPos
        },
        tokens: [helper(needles[index])]
      } : {
        succeeded: false,
        error: false,
        src: input.src,
        pos: input.start,
        message: `operator "objClass(${needles.join(',')})"`
      };
    };
  };
}
function objClassNot(helper, comparator) {
  // NOTE: <T> version `needles` type is `T`.
  return (...needles) => {
    return input => {
      const len = Math.max(0, input.end - input.start);

      if (len > 0) {
        for (const needle of needles) {
          let matched = true;

          if (!comparator(input.src[input.start], needle)) {
            matched = false;
            break;
          }

          if (matched) {
            return {
              succeeded: false,
              error: false,
              src: input.src,
              pos: input.start,
              message: `operator "objClassNot(${needles.join(',')})"`
            };
          }
        }
      }

      return {
        succeeded: true,
        next: {
          src: input.src,
          start: input.start + 1,
          end: input.end,
          context: input.context,
          templateArgs: input.templateArgs,
          templateArgsPos: input.templateArgsPos
        },
        tokens: [helper(input.src[input.start])]
      };
    };
  };
}
function objClassByNeedleFn(helper, comparator) {
  // NOTE: needles[i] should be one character. surrogate pair and/or ligature are accepted.
  // NOTE: <T> version `needles` type is `T`.
  return needle => {
    return input => {
      const len = Math.max(0, input.end - input.start);
      const matched = len > 0 ? needle(input.src[input.start]) : false;
      return matched ? {
        succeeded: true,
        next: {
          src: input.src,
          start: input.start + 1,
          end: input.end,
          context: input.context,
          templateArgs: input.templateArgs,
          templateArgsPos: input.templateArgsPos
        },
        tokens: [helper(input.src[input.start])]
      } : {
        succeeded: false,
        error: false,
        src: input.src,
        pos: input.start,
        message: `operator "objClassByNeedleFn"`
      };
    };
  };
} // eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types

function getObjectParsers(params) {
  const clsFn = objClassByNeedleFn(params.rawToToken, params.comparator);
  const isAny = clsFn(src => true); // TODO: reduce unneccessary call for adding types.

  return {
    seq: objSequence(params.rawToToken, params.comparator),
    cls: objClass(params.rawToToken, params.comparator),
    notCls: objClassNot(params.rawToToken, params.comparator),
    clsFn,
    classes: {
      any: isAny
    },
    cat: (0,_parser__WEBPACK_IMPORTED_MODULE_0__.transform)(params.concatTokens),
    once: (0,_parser__WEBPACK_IMPORTED_MODULE_0__.quantify)(1, 1),
    repeat: (0,_parser__WEBPACK_IMPORTED_MODULE_0__.quantify)(),
    qty: (min, max) => (0,_parser__WEBPACK_IMPORTED_MODULE_0__.quantify)(min, max),
    zeroWidth: helper => (0,_parser__WEBPACK_IMPORTED_MODULE_0__.zeroWidth)(helper),
    err: message => (0,_parser__WEBPACK_IMPORTED_MODULE_0__.zeroWidthError)(message),
    beginning: helper => (0,_parser__WEBPACK_IMPORTED_MODULE_0__.beginning)(helper),
    end: helper => (0,_parser__WEBPACK_IMPORTED_MODULE_0__.end)(helper),
    first: (...parsers) => (0,_parser__WEBPACK_IMPORTED_MODULE_0__.first)(...parsers),
    or: (...parsers) => (0,_parser__WEBPACK_IMPORTED_MODULE_0__.or)(...parsers),
    combine: (0,_parser__WEBPACK_IMPORTED_MODULE_0__.transform)(),
    erase: (0,_parser__WEBPACK_IMPORTED_MODULE_0__.transform)(tokens => []),
    trans: fn => (0,_parser__WEBPACK_IMPORTED_MODULE_0__.transform)(fn),
    ahead: (...parsers) => (0,_parser__WEBPACK_IMPORTED_MODULE_0__.lookAhead)(...parsers),
    behind: (n, helper) => (0,_parser__WEBPACK_IMPORTED_MODULE_0__.lookBehind)(n, helper),
    rules: args => (0,_parser__WEBPACK_IMPORTED_MODULE_0__.applyProductionRules)(args),
    makeProgram: _parser__WEBPACK_IMPORTED_MODULE_0__.makeProgram
  };
}

/***/ }),

/***/ "./node_modules/fruitsconfits/modules/lib/parser.js":
/*!**********************************************************!*\
  !*** ./node_modules/fruitsconfits/modules/lib/parser.js ***!
  \**********************************************************/
/*! namespace exports */
/*! export applyProductionRules [provided] [no usage info] [missing usage info prevents renaming] */
/*! export beginning [provided] [no usage info] [missing usage info prevents renaming] */
/*! export combine [provided] [no usage info] [missing usage info prevents renaming] */
/*! export end [provided] [no usage info] [missing usage info prevents renaming] */
/*! export first [provided] [no usage info] [missing usage info prevents renaming] */
/*! export formatErrorMessage [provided] [no usage info] [missing usage info prevents renaming] */
/*! export lookAhead [provided] [no usage info] [missing usage info prevents renaming] */
/*! export lookBehind [provided] [no usage info] [missing usage info prevents renaming] */
/*! export makeProgram [provided] [no usage info] [missing usage info prevents renaming] */
/*! export or [provided] [no usage info] [missing usage info prevents renaming] */
/*! export quantify [provided] [no usage info] [missing usage info prevents renaming] */
/*! export transform [provided] [no usage info] [missing usage info prevents renaming] */
/*! export zeroWidth [provided] [no usage info] [missing usage info prevents renaming] */
/*! export zeroWidthError [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_require__, __webpack_require__.r, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "formatErrorMessage": () => /* binding */ formatErrorMessage,
/* harmony export */   "zeroWidth": () => /* binding */ zeroWidth,
/* harmony export */   "zeroWidthError": () => /* binding */ zeroWidthError,
/* harmony export */   "beginning": () => /* binding */ beginning,
/* harmony export */   "end": () => /* binding */ end,
/* harmony export */   "quantify": () => /* binding */ quantify,
/* harmony export */   "first": () => /* binding */ first,
/* harmony export */   "or": () => /* binding */ or,
/* harmony export */   "transform": () => /* binding */ transform,
/* harmony export */   "combine": () => /* binding */ combine,
/* harmony export */   "lookAhead": () => /* binding */ lookAhead,
/* harmony export */   "lookBehind": () => /* binding */ lookBehind,
/* harmony export */   "applyProductionRules": () => /* binding */ applyProductionRules,
/* harmony export */   "makeProgram": () => /* binding */ makeProgram
/* harmony export */ });
/* harmony import */ var _types__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./types */ "./node_modules/fruitsconfits/modules/lib/types.js");
// Copyright (c) 2019 Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln


function getLineAndCol(src, pos) {
  let line = 1;
  let col = 1;

  for (let i = 0; i <= pos; i++) {
    switch (src[i]) {
      case '\r':
        if (src[i + 1] === '\n') {
          i++;
        }

      // Fall Throught

      case '\n':
        line++;
        col = 1;
        break;

      default:
        col++;
        break;
    }
  }

  return {
    line,
    col
  };
}

function formatErrorMessage(result) {
  let msg = '';
  let src = '';

  if (typeof result.src === 'string') {
    src = result.src.slice(Math.max(result.pos - 5, 0), result.pos + 55); // NOTE: (TS>=4.0) TS2339: Property 'slice' does not exist on type 'never'.

    let ar = src.split(/\r\n|\n|\r/);
    ar = ar.slice(0, 1).concat('          ^~~~~~~~').concat(...ar.slice(1));
    src = ar.join('\n') + '\n\n';
    const lineAndCol = getLineAndCol(result.src, result.pos);
    msg = `parse failed at position:${result.pos} line:${lineAndCol.line} col:${lineAndCol.col} ${result.message ? ` ${result.message}` : ''}\n     ${src}`;
  } else {
    src = '     (object)\n          ^~~~~~~~';

    try {
      src = '     ' + // eslint-disable-next-line @typescript-eslint/no-unsafe-call, @typescript-eslint/no-unsafe-member-access
      JSON.stringify(result.src.slice(Math.max(result.pos - 10, 0), result.pos)) + '\n          ' + // eslint-disable-next-line @typescript-eslint/no-unsafe-call, @typescript-eslint/no-unsafe-member-access
      JSON.stringify(result.src.slice(result.pos, result.pos + 1)) + '\n          ' + // eslint-disable-next-line @typescript-eslint/no-unsafe-call, @typescript-eslint/no-unsafe-member-access
      JSON.stringify(result.src.slice(result.pos + 1, result.pos + 10));
      let ar = src.split(/\r\n|\n|\r/);
      ar = ar.slice(0, 2).concat('          ^~~~~~~~').concat(...ar.slice(2));
      src = ar.join('\n') + '\n\n';
    } catch (e) {// Nothing to do.
    }

    msg = `parse failed at position:${result.pos} ${result.message ? ` ${result.message}` : ''}\n     ${src}`;
  }

  return msg;
}
function zeroWidth(helper) {
  return input => {
    return {
      succeeded: true,
      next: {
        src: input.src,
        start: input.start,
        end: input.end,
        context: input.context,
        templateArgs: input.templateArgs,
        templateArgsPos: input.templateArgsPos
      },
      tokens: helper ? [helper()] : []
    };
  };
}
function zeroWidthError(message) {
  return input => {
    throw new _types__WEBPACK_IMPORTED_MODULE_0__.ParseError({
      succeeded: false,
      error: true,
      src: input.src,
      pos: input.start,
      message: message || ''
    }); // return ({
    //     succeeded: false,
    //     error: true,
    //     src: input.src,
    //     pos: input.start,
    //     message: message || '',
    // });
  };
}
function beginning(helper) {
  return input => {
    return input.start === 0 ? {
      succeeded: true,
      next: {
        src: input.src,
        start: input.start,
        end: input.end,
        context: input.context,
        templateArgs: input.templateArgs,
        templateArgsPos: input.templateArgsPos
      },
      tokens: helper ? [helper()] : []
    } : {
      succeeded: false,
      error: false,
      src: input.src,
      pos: input.start,
      message: 'operator "beginning"'
    };
  };
}
function end(helper) {
  return input => {
    return input.start === input.end ? {
      succeeded: true,
      next: {
        src: input.src,
        start: input.start,
        end: input.end,
        context: input.context,
        templateArgs: input.templateArgs,
        templateArgsPos: input.templateArgsPos
      },
      tokens: helper ? [helper()] : []
    } : {
      succeeded: false,
      error: false,
      src: input.src,
      pos: input.start,
      message: 'operator "end"'
    };
  };
} // TODO: match by callback function parser
// TODO: `nesting` parser

function quantify(min, max) {
  min = min || 0;
  return parser => {
    return input => {
      let next = input;
      const matched = [];

      for (;;) {
        const x = parser(next);

        if (x.succeeded) {
          next = x.next;
          matched.push({
            next: x.next,
            tokens: x.tokens
          });

          if (max && max === matched.length) {
            break;
          }
        } else {
          if (x.error) {
            return x;
          }

          if (matched.length >= min) {
            break;
          } else {
            return {
              succeeded: false,
              error: false,
              src: next.src,
              pos: next.start,
              message: 'operator "quantify"'
            };
          }
        }
      }

      if (matched.length > 0) {
        const r = [];

        for (const x of matched) {
          r.push(...x.tokens);
        }

        return {
          succeeded: true,
          next: matched[matched.length - 1].next,
          tokens: r
        };
      } else {
        return {
          succeeded: true,
          next: {
            src: input.src,
            start: input.start,
            end: input.end,
            context: input.context,
            templateArgs: input.templateArgs,
            templateArgsPos: input.templateArgsPos
          },
          tokens: []
        };
      }
    };
  };
}
function first(...parsers) {
  return input => {
    let matched = null;
    let last = null;

    for (const parser of parsers) {
      const x = parser(input);

      if (x.succeeded) {
        matched = {
          next: x.next,
          tokens: x.tokens
        };
        break;
      }

      if (last) {
        if (x.error) {
          if (!last.error || last.pos < x.pos) {
            last = x;
          }
        } else if (last.pos < x.pos) {
          last = x;
        }
      } else {
        last = x;
      }
    }

    return matched ? {
      succeeded: true,
      next: matched.next,
      tokens: matched.tokens
    } : last ? last : {
      succeeded: false,
      error: false,
      src: input.src,
      pos: input.start,
      message: 'operator "first"'
    };
  };
}
function or(...parsers) {
  return input => {
    const matched = [];
    let last = null;

    for (const parser of parsers) {
      const x = parser(input);

      if (x.succeeded) {
        matched.push({
          next: x.next,
          tokens: x.tokens
        });
      } else {
        if (last) {
          if (x.error) {
            if (!last.error || last.pos < x.pos) {
              last = x;
            }
          } else if (last.pos < x.pos) {
            last = x;
          }
        } else {
          last = x;
        }
      }
    }

    if (matched.length > 0) {
      const z = matched.reduce((a, b) => a.next.start >= b.next.start ? a : b);
      return {
        succeeded: true,
        next: z.next,
        tokens: z.tokens
      };
    }

    return last ? last : {
      succeeded: false,
      error: false,
      src: input.src,
      pos: input.start,
      message: 'operator "or"'
    };
  };
}
function transform(trans, ctxTrans) {
  return (...parsers) => {
    return input => {
      let next = input;
      const tokens = [];

      for (const parser of parsers) {
        const x = parser(next);

        if (!x.succeeded) {
          return x;
        }

        next = x.next;
        tokens.push(...x.tokens);
      } // TODO: report errors while transforming


      const t2 = trans ? trans(tokens, input) : tokens;
      return {
        succeeded: true,
        next: ctxTrans ? {
          src: next.src,
          start: next.start,
          end: next.end,
          context: ctxTrans(next.context),
          templateArgs: next.templateArgs,
          templateArgsPos: next.templateArgsPos
        } : next,
        tokens: t2
      };
    };
  };
}
function combine(...parsers) {
  return transform()(...parsers);
}
function lookAhead(...parsers) {
  return input => {
    let next = input;

    for (const parser of parsers) {
      const x = parser(next);

      if (!x.succeeded) {
        return x;
      }

      next = x.next;
    }

    return {
      succeeded: true,
      next: input,
      tokens: []
    };
  };
}
function lookBehind(n, helper) {
  return (...parsers) => {
    return input => {
      if (input.start - n < 0) {
        return {
          succeeded: false,
          error: false,
          src: input.src,
          pos: input.start,
          message: 'lookBehind: src is too short'
        };
      }

      let next = {
        src: input.src,
        start: input.start - n,
        end: input.end,
        context: input.context,
        templateArgs: input.templateArgs,
        templateArgsPos: input.templateArgsPos
      };

      for (const parser of parsers) {
        const x = parser(next);

        if (!x.succeeded) {
          return x;
        }

        next = x.next;
      }

      return {
        succeeded: true,
        next: input,
        tokens: helper ? [helper()] : []
      };
    };
  };
}
function applyProductionRules(args) {
  return lexer => {
    return lexerInput => {
      const lexResult = lexer(lexerInput);

      if (!lexResult.succeeded) {
        return lexResult;
      }

      const input = (0,_types__WEBPACK_IMPORTED_MODULE_0__.parserInput)(lexResult.tokens, lexerInput.context);
      let next = input;
      let completed = false;

      if (args.check(next).succeeded) {
        return {
          succeeded: true,
          next: lexResult.next,
          tokens: lexResult.tokens
        };
      }

      completed: for (let i = 0; args.maxApply !== void 0 ? i < args.maxApply : true; i++) {
        let matched = false;

        rules: for (const rule of args.rules) {
          const {
            parser,
            rtol
          } = typeof rule === 'function' ? {
            parser: rule,
            rtol: false
          } : rule;
          const len = next.src.length;

          for (let s = 0; s <= len; s++) {
            const x = parser({
              src: next.src,
              start: rtol ? len - s : s,
              end: next.src.length,
              context: next.context,
              templateArgs: next.templateArgs,
              templateArgsPos: next.templateArgsPos
            });

            if (x.succeeded) {
              matched = true;
              const nextSrc = next.src.slice(0, rtol ? len - s : s);
              nextSrc.push(...x.tokens);
              nextSrc.push(...next.src.slice(x.next.start));
              next = {
                src: nextSrc,
                start: 0,
                end: nextSrc.length,
                context: x.next.context,
                templateArgs: x.next.templateArgs,
                templateArgsPos: x.next.templateArgsPos
              };

              if (args.check(next).succeeded) {
                completed = true;
                break completed;
              }

              break rules;
            }
          }
        }

        if (!matched) {
          break;
        }
      }

      if (!completed) {
        if (!args.check(next).succeeded) {
          throw new _types__WEBPACK_IMPORTED_MODULE_0__.ParseError({
            succeeded: false,
            error: true,
            src: input.src,
            pos: input.start,
            message: 'The application of production rules was not finished'
          });
        }
      }

      return {
        succeeded: true,
        next: lexResult.next,
        tokens: next.src
      };
    };
  };
}
function makeProgram(parser) {
  return input => {
    try {
      return parser(input);
    } catch (e) {
      // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
      if (e.result) {
        // eslint-disable-next-line @typescript-eslint/no-unsafe-return, @typescript-eslint/no-unsafe-member-access
        return e.result;
      } else {
        throw e;
      }
    }
  };
}

/***/ }),

/***/ "./node_modules/fruitsconfits/modules/lib/string-parser.js":
/*!*****************************************************************!*\
  !*** ./node_modules/fruitsconfits/modules/lib/string-parser.js ***!
  \*****************************************************************/
/*! namespace exports */
/*! export charClass [provided] [no usage info] [missing usage info prevents renaming] */
/*! export charClassByNeedleFn [provided] [no usage info] [missing usage info prevents renaming] */
/*! export charClassNot [provided] [no usage info] [missing usage info prevents renaming] */
/*! export charSequence [provided] [no usage info] [missing usage info prevents renaming] */
/*! export getStringParsers [provided] [no usage info] [missing usage info prevents renaming] */
/*! export templateStringsParam [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_require__, __webpack_require__.r, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "charSequence": () => /* binding */ charSequence,
/* harmony export */   "charClass": () => /* binding */ charClass,
/* harmony export */   "charClassNot": () => /* binding */ charClassNot,
/* harmony export */   "charClassByNeedleFn": () => /* binding */ charClassByNeedleFn,
/* harmony export */   "templateStringsParam": () => /* binding */ templateStringsParam,
/* harmony export */   "getStringParsers": () => /* binding */ getStringParsers
/* harmony export */ });
/* harmony import */ var _parser__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./parser */ "./node_modules/fruitsconfits/modules/lib/parser.js");
// Copyright (c) 2019 Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln

function charSequence(helper) {
  return needle => {
    return input => {
      const src = input.src.slice(input.start, input.end);
      return src.startsWith(needle) ? {
        succeeded: true,
        next: {
          src: input.src,
          start: input.start + needle.length,
          end: input.end,
          context: input.context,
          templateArgs: input.templateArgs,
          templateArgsPos: input.templateArgsPos
        },
        tokens: [helper(needle)]
      } : {
        succeeded: false,
        error: false,
        src: input.src,
        pos: input.start,
        message: `operator "charSequence(${needle})"`
      };
    };
  };
}
function charClass(helper) {
  // NOTE: needles[i] should be one character. surrogate pair and/or ligature are accepted.
  return (...needles) => {
    return input => {
      const src = input.src.slice(input.start, input.end);
      let index = -1;
      const succeeded = needles.some((needle, idx) => {
        const matched = src.startsWith(needle);

        if (matched) {
          index = idx;
          return true;
        }
      });
      return succeeded ? {
        succeeded: true,
        next: {
          src: input.src,
          start: input.start + needles[index].length,
          end: input.end,
          context: input.context,
          templateArgs: input.templateArgs,
          templateArgsPos: input.templateArgsPos
        },
        tokens: [helper(needles[index])]
      } : {
        succeeded: false,
        error: false,
        src: input.src,
        pos: input.start,
        message: `operator "charClass(${needles.join(',')})"`
      };
    };
  };
}
function charClassNot(helper) {
  // NOTE: needles[i] should be one character. surrogate pair and/or ligature are accepted.
  return (...needles) => {
    return input => {
      const src = input.src.slice(input.start, input.end);

      for (const needle of needles) {
        const matched = src.startsWith(needle);

        if (matched) {
          return {
            succeeded: false,
            error: false,
            src: input.src,
            pos: input.start,
            message: `operator "charClassNot(${needles.join(',')})"`
          };
        }
      }

      const p = input.src.codePointAt(input.start);

      if (p === void 0) {
        return {
          succeeded: false,
          error: false,
          src: input.src,
          pos: input.start,
          message: `operator "charClassNot(${needles.join(',')})"`
        };
      }

      const c = String.fromCodePoint(p);
      return {
        succeeded: true,
        next: {
          src: input.src,
          start: input.start + c.length,
          end: input.end,
          context: input.context,
          templateArgs: input.templateArgs,
          templateArgsPos: input.templateArgsPos
        },
        tokens: [helper(c)]
      };
    };
  };
}
function charClassByNeedleFn(helper) {
  // NOTE: needles[i] should be one character. surrogate pair and/or ligature are accepted.
  return needle => {
    return input => {
      const src = input.src.slice(input.start, input.end);
      const len = needle(src);
      return len >= 0 ? {
        succeeded: true,
        next: {
          src: input.src,
          start: input.start + len,
          end: input.end,
          context: input.context,
          templateArgs: input.templateArgs,
          templateArgsPos: input.templateArgsPos
        },
        tokens: [helper(src.substring(0, len))]
      } : {
        succeeded: false,
        error: false,
        src: input.src,
        pos: input.start,
        message: `operator "charClassByNeedleFn"`
      };
    };
  };
}
function templateStringsParam(criteria, conv) {
  return input => {
    const src = input.src.slice(input.start, input.start + 1);

    if (src === '\x00') {
      if (input.templateArgsPos) {
        let argIdx = -1;
        const strIdx = input.templateArgsPos.findIndex((v, i) => {
          argIdx = i;
          return v === input.start;
        });

        if (0 <= strIdx) {
          // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment, @typescript-eslint/no-non-null-assertion
          const o = input.templateArgs[argIdx];

          if (criteria(o)) {
            return {
              succeeded: true,
              next: {
                src: input.src,
                start: input.start + 1,
                end: input.end,
                context: input.context,
                templateArgs: input.templateArgs,
                templateArgsPos: input.templateArgsPos
              },
              // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
              tokens: [conv ? conv(o) : o]
            };
          }
        }
      }
    }

    return {
      succeeded: false,
      error: false,
      src: input.src,
      pos: input.start,
      message: `operator "stringTemplatesParam()"`
    };
  };
} // eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types

function getStringParsers(params) {
  const seq = charSequence(params.rawToToken);
  const cls = charClass(params.rawToToken);
  const notCls = charClassNot(params.rawToToken);
  const clsFn = charClassByNeedleFn(params.rawToToken);
  const cat = (0,_parser__WEBPACK_IMPORTED_MODULE_0__.transform)(params.concatTokens);
  const once = (0,_parser__WEBPACK_IMPORTED_MODULE_0__.quantify)(1, 1);
  const repeat = (0,_parser__WEBPACK_IMPORTED_MODULE_0__.quantify)(); // TODO: reduce unneccessary call for adding types.

  const qty = (min, max) => (0,_parser__WEBPACK_IMPORTED_MODULE_0__.quantify)(min, max);

  const combine = (0,_parser__WEBPACK_IMPORTED_MODULE_0__.transform)();
  const erase = (0,_parser__WEBPACK_IMPORTED_MODULE_0__.transform)(tokens => []);
  const isAlpha = clsFn(src => {
    const p = src.codePointAt(0);

    if (p === void 0) {
      return -1;
    }

    const c = String.fromCodePoint(p);
    return 'A' <= c && c <= 'Z' || 'a' <= c && c <= 'z' ? c.length : -1;
  });
  const isUpper = clsFn(src => {
    const p = src.codePointAt(0);

    if (p === void 0) {
      return -1;
    }

    const c = String.fromCodePoint(p);
    return 'A' <= c && c <= 'Z' ? c.length : -1;
  });
  const isLower = clsFn(src => {
    const p = src.codePointAt(0);

    if (p === void 0) {
      return -1;
    }

    const c = String.fromCodePoint(p);
    return 'a' <= c && c <= 'z' ? c.length : -1;
  });
  const isNumber = clsFn(src => {
    const p = src.codePointAt(0);

    if (p === void 0) {
      return -1;
    }

    const c = String.fromCodePoint(p);
    return '0' <= c && c <= '9' ? c.length : -1;
  });
  const isNonZeroNumber = clsFn(src => {
    const p = src.codePointAt(0);

    if (p === void 0) {
      return -1;
    }

    const c = String.fromCodePoint(p);
    return '1' <= c && c <= '9' ? c.length : -1;
  });
  const isBinNum = clsFn(src => {
    const p = src.codePointAt(0);

    if (p === void 0) {
      return -1;
    }

    const c = String.fromCodePoint(p);
    return '0' <= c && c <= '1' ? c.length : -1;
  });
  const isOctNum = clsFn(src => {
    const p = src.codePointAt(0);

    if (p === void 0) {
      return -1;
    }

    const c = String.fromCodePoint(p);
    return '0' <= c && c <= '7' ? c.length : -1;
  });
  const isHexNum = clsFn(src => {
    const p = src.codePointAt(0);

    if (p === void 0) {
      return -1;
    }

    const c = String.fromCodePoint(p);
    return 'A' <= c && c <= 'F' || 'a' <= c && c <= 'f' || '0' <= c && c <= '9' ? c.length : -1;
  });
  const isAlNum = clsFn(src => {
    const p = src.codePointAt(0);

    if (p === void 0) {
      return -1;
    }

    const c = String.fromCodePoint(p);
    return 'A' <= c && c <= 'Z' || 'a' <= c && c <= 'z' || '0' <= c && c <= '9' ? c.length : -1;
  });
  const isSpace = clsFn(src => {
    const p = src.codePointAt(0);

    if (p === void 0) {
      return -1;
    }

    const c = String.fromCodePoint(p);
    return (' \f\n\r\t\v​\u00a0\u1680​\u180e' + '\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a' + '​\u2028\u2029\u202f\u205f​\u3000\ufeff').includes(c) ? c.length : -1;
  });
  const isSpaceWithinSingleLine = clsFn(src => {
    const p = src.codePointAt(0);

    if (p === void 0) {
      return -1;
    }

    const c = String.fromCodePoint(p);
    return (' \f\t\v​\u00a0\u1680​\u180e' + '\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a' + '​\u2028\u2029\u202f\u205f​\u3000\ufeff').includes(c) ? c.length : -1;
  });
  const isControl = clsFn(src => {
    const p = src.codePointAt(0);

    if (p === void 0) {
      return -1;
    }

    const c = String.fromCodePoint(p);
    return 0x0000 <= p && p <= 0x001f || 0x007f <= p && p <= 0x009f ? c.length : -1;
  });
  const isWord = clsFn(src => {
    const p = src.codePointAt(0);

    if (p === void 0) {
      return -1;
    }

    const c = String.fromCodePoint(p);
    return (' \f\n\r\t\v​\u00a0\u1680​\u180e' + '\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a' + '​\u2028\u2029\u202f\u205f​\u3000\ufeff').includes(c) || 0x0000 <= p && p <= 0x001f || 0x007f <= p && p <= 0x009f ? -1 : c.length;
  });
  const isNewline = cls('\r\n', '\n', '\r');
  const isAny = clsFn(src => {
    const p = src.codePointAt(0);

    if (p === void 0) {
      return -1;
    }

    const c = String.fromCodePoint(p);
    return c.length;
  });
  const binSep = (0,_parser__WEBPACK_IMPORTED_MODULE_0__.first)(isBinNum, cls('_'));
  const octSep = (0,_parser__WEBPACK_IMPORTED_MODULE_0__.first)(isOctNum, cls('_'));
  const hexSep = (0,_parser__WEBPACK_IMPORTED_MODULE_0__.first)(isHexNum, cls('_'));

  const binaryIntegerNumber = (...prefixes) => combine(erase((0,_parser__WEBPACK_IMPORTED_MODULE_0__.first)(...prefixes)), cat(once(isBinNum), repeat(binSep)));

  const octalIntegerNumber = (...prefixes) => combine(erase((0,_parser__WEBPACK_IMPORTED_MODULE_0__.first)(...prefixes)), cat(once(isOctNum), repeat(octSep)));

  const hexIntegerValue = (...prefixes) => combine(erase((0,_parser__WEBPACK_IMPORTED_MODULE_0__.first)(...prefixes)), cat(once(isHexNum), repeat(hexSep)));

  const decimalIntegerNumber = combine(cat(qty(0, 1)(cls('+', '-')), (0,_parser__WEBPACK_IMPORTED_MODULE_0__.first)(combine(once(isNonZeroNumber), repeat((0,_parser__WEBPACK_IMPORTED_MODULE_0__.first)(isNumber, cls('_')))), seq('0'))));
  const bigDecimalIntegerNumber = combine(cat(decimalIntegerNumber, erase(seq('n'))));
  const floatingPointNumber = combine(cat(qty(0, 1)(cls('+', '-')), (0,_parser__WEBPACK_IMPORTED_MODULE_0__.first)(combine(once(isNonZeroNumber), repeat((0,_parser__WEBPACK_IMPORTED_MODULE_0__.first)(isNumber, cls('_')))), seq('0')), qty(0, 1)(combine(seq('.'), qty(1)((0,_parser__WEBPACK_IMPORTED_MODULE_0__.first)(isNumber, cls('_'))))), qty(0, 1)(combine(cls('E', 'e'), qty(0, 1)(cls('+', '-')), (0,_parser__WEBPACK_IMPORTED_MODULE_0__.first)(combine(once(isNonZeroNumber), repeat(isNumber)), seq('0')))))); // TODO: reduce unneccessary call for adding types.

  return {
    seq,
    cls,
    notCls,
    clsFn,
    classes: {
      alpha: isAlpha,
      upper: isUpper,
      lower: isLower,
      num: isNumber,
      nonzero: isNonZeroNumber,
      bin: isBinNum,
      oct: isOctNum,
      hex: isHexNum,
      alnum: isAlNum,
      space: isSpace,
      spaceWithinSingleLine: isSpaceWithinSingleLine,
      ctrl: isControl,
      newline: isNewline,
      word: isWord,
      any: isAny
    },
    numbers: {
      bin: binaryIntegerNumber,
      oct: octalIntegerNumber,
      hex: hexIntegerValue,
      int: decimalIntegerNumber,
      bigint: bigDecimalIntegerNumber,
      float: floatingPointNumber
    },
    isParam: templateStringsParam,
    cat,
    once,
    repeat,
    qty,
    zeroWidth: helper => (0,_parser__WEBPACK_IMPORTED_MODULE_0__.zeroWidth)(helper),
    err: message => (0,_parser__WEBPACK_IMPORTED_MODULE_0__.zeroWidthError)(message),
    beginning: helper => (0,_parser__WEBPACK_IMPORTED_MODULE_0__.beginning)(helper),
    end: helper => (0,_parser__WEBPACK_IMPORTED_MODULE_0__.end)(helper),
    first: (...parsers) => (0,_parser__WEBPACK_IMPORTED_MODULE_0__.first)(...parsers),
    or: (...parsers) => (0,_parser__WEBPACK_IMPORTED_MODULE_0__.or)(...parsers),
    combine,
    erase,
    trans: fn => (0,_parser__WEBPACK_IMPORTED_MODULE_0__.transform)(fn),
    ahead: (...parsers) => (0,_parser__WEBPACK_IMPORTED_MODULE_0__.lookAhead)(...parsers),
    behind: (n, helper) => (0,_parser__WEBPACK_IMPORTED_MODULE_0__.lookBehind)(n, helper),
    rules: args => (0,_parser__WEBPACK_IMPORTED_MODULE_0__.applyProductionRules)(args),
    makeProgram: _parser__WEBPACK_IMPORTED_MODULE_0__.makeProgram
  };
}

/***/ }),

/***/ "./node_modules/fruitsconfits/modules/lib/types.js":
/*!*********************************************************!*\
  !*** ./node_modules/fruitsconfits/modules/lib/types.js ***!
  \*********************************************************/
/*! namespace exports */
/*! export ParseError [provided] [no usage info] [missing usage info prevents renaming] */
/*! export parserInput [provided] [no usage info] [missing usage info prevents renaming] */
/*! export templateStringsParserInput [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_require__.r, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "ParseError": () => /* binding */ ParseError,
/* harmony export */   "parserInput": () => /* binding */ parserInput,
/* harmony export */   "templateStringsParserInput": () => /* binding */ templateStringsParserInput
/* harmony export */ });
// Copyright (c) 2019 Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln
class ParseError extends Error {
  constructor(result) {
    super(result.message);
    this.result = result;
  }

}
function parserInput(src, context) {
  return {
    src,
    start: 0,
    end: src.length,
    // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
    context: context,
    templateArgs: [],
    templateArgsPos: []
  };
}
function templateStringsParserInput(strings, values, context) {
  const templateArgsPos = [];
  let pos = 0;

  if (values.length) {
    for (let i = 0; i < strings.length; i++) {
      const x = strings[i];

      if (i < values.length) {
        templateArgsPos.push(pos + x.length);
        pos += x.length + 1;
      }
    }
  }

  const joined = strings.join('\x00');
  return {
    src: joined,
    start: 0,
    end: joined.length,
    // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
    context: context,
    templateArgs: values,
    templateArgsPos
  };
}

/***/ }),

/***/ "./node_modules/liyad/modules/s-exp/ast.js":
/*!*************************************************!*\
  !*** ./node_modules/liyad/modules/s-exp/ast.js ***!
  \*************************************************/
/*! namespace exports */
/*! export backquote [provided] [no usage info] [missing usage info prevents renaming] */
/*! export isBackquoted [provided] [no usage info] [missing usage info prevents renaming] */
/*! export isQuoted [provided] [no usage info] [missing usage info prevents renaming] */
/*! export isSymbol [provided] [no usage info] [missing usage info prevents renaming] */
/*! export isUnquoted [provided] [no usage info] [missing usage info prevents renaming] */
/*! export quote [provided] [no usage info] [missing usage info prevents renaming] */
/*! export splice [provided] [no usage info] [missing usage info prevents renaming] */
/*! export spread [provided] [no usage info] [missing usage info prevents renaming] */
/*! export wrapByUnquote [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_require__.r, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "quote": () => /* binding */ quote,
/* harmony export */   "isQuoted": () => /* binding */ isQuoted,
/* harmony export */   "backquote": () => /* binding */ backquote,
/* harmony export */   "isBackquoted": () => /* binding */ isBackquoted,
/* harmony export */   "wrapByUnquote": () => /* binding */ wrapByUnquote,
/* harmony export */   "isUnquoted": () => /* binding */ isUnquoted,
/* harmony export */   "spread": () => /* binding */ spread,
/* harmony export */   "splice": () => /* binding */ splice,
/* harmony export */   "isSymbol": () => /* binding */ isSymbol
/* harmony export */ });
// Copyright (c) 2018, Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln
function quote(state, x) {
  return [{
    symbol: state.config.reservedNames.quote
  }, x];
}
function isQuoted(state, x) {
  if (Array.isArray(x) && 0 < x.length) {
    const q = isSymbol(x);

    if (q && q.symbol === state.config.reservedNames.quote) {
      return true;
    }
  }

  return false;
}
function backquote(state, x) {
  return [{
    symbol: state.config.reservedNames.backquote
  }, x];
}
function isBackquoted(state, x) {
  if (Array.isArray(x) && 0 < x.length) {
    const q = isSymbol(x);

    if (q && q.symbol === state.config.reservedNames.backquote) {
      return true;
    }
  }

  return false;
}
function wrapByUnquote(state, x) {
  return [{
    symbol: state.config.reservedNames.unquote
  }, x];
}
function isUnquoted(state, x) {
  if (Array.isArray(x) && 0 < x.length) {
    const q = isSymbol(x);

    if (q && q.symbol === state.config.reservedNames.unquote) {
      return true;
    }
  }

  return false;
}
function spread(state, x) {
  return [{
    symbol: state.config.reservedNames.spread
  }, x];
}
function splice(state, x) {
  return [{
    symbol: state.config.reservedNames.splice
  }, x];
}
function isSymbol(x, name) {
  if (x && typeof x === 'object' && Object.prototype.hasOwnProperty.call(x, 'symbol')) {
    if (name !== void 0) {
      return x.symbol === name ? x : null;
    } else {
      return x;
    }
  }

  return null;
}

/***/ }),

/***/ "./node_modules/liyad/modules/s-exp/compile.js":
/*!*****************************************************!*\
  !*** ./node_modules/liyad/modules/s-exp/compile.js ***!
  \*****************************************************/
/*! namespace exports */
/*! export compileLambda [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_require__, __webpack_require__.r, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "compileLambda": () => /* binding */ compileLambda
/* harmony export */ });
/* harmony import */ var _ast__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./ast */ "./node_modules/liyad/modules/s-exp/ast.js");
/* harmony import */ var _evaluate__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./evaluate */ "./node_modules/liyad/modules/s-exp/evaluate.js");
/* harmony import */ var _errors__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./errors */ "./node_modules/liyad/modules/s-exp/errors.js");
/* harmony import */ var _compile_ops_helpers__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./compile.ops/helpers */ "./node_modules/liyad/modules/s-exp/compile.ops/helpers.js");
/* harmony import */ var _compile_ops__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./compile.ops */ "./node_modules/liyad/modules/s-exp/compile.ops/index.js");
// Copyright (c) 2018, Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln




 // tslint:disable-next-line:variable-name

function compileCore(state, formalArgs, lastIsSpread, fnBody, _$_vars) {
  function makeScope(scoped) {
    const varNamesCopy = new Map();

    for (const x of ctx.varNames.entries()) {
      varNamesCopy.set(x[0], x[1]);
    }

    scoped();
    ctx.varNames = varNamesCopy;
  }

  function compileValue(b) {
    let compFnBody = '';

    if (b === null) {
      compFnBody += '(null)';
    } else if (b === void 0) {
      compFnBody += '(void 0)';
    } else switch (typeof b) {
      case 'boolean':
      case 'number':
        compFnBody += `(${String(b)})`;
        break;

      case 'object':
        if ((0,_ast__WEBPACK_IMPORTED_MODULE_4__.isSymbol)(b)) {
          const sym = b;
          (0,_errors__WEBPACK_IMPORTED_MODULE_1__.checkUnsafeVarNamesEx)('(compiler)compileValue', ctx.varNames, sym.symbol);

          if (ctx.varNames.has(sym.symbol)) {
            compFnBody += `(${ctx.varNames.get(sym.symbol)})`;
          } else {
            _$_vars[ctx.varsCount] = sym.symbol;
            compFnBody += `(_$_vars[${String(ctx.varsCount++)}])`;
          }

          break;
        } else {}

      // FALL_THRU

      default:
        _$_vars[ctx.varsCount] = b;
        compFnBody += `(_$_vars[${String(ctx.varsCount++)}])`;
        break;
    }

    return compFnBody;
  }

  function compileToken(body, i) {
    let compFnBody = '';
    const b = body[i];

    if (Array.isArray(b)) {
      if (0 < b.length) {
        const r = (0,_compile_ops_helpers__WEBPACK_IMPORTED_MODULE_2__.applyMacros)(state, b);

        if (Array.isArray(r)) {
          if (0 < r.length) {
            if ((0,_ast__WEBPACK_IMPORTED_MODULE_4__.isSymbol)(r[0])) {
              const sym = r[0];
              const args = r.slice(1);
              (0,_errors__WEBPACK_IMPORTED_MODULE_1__.checkUnsafeVarNamesEx)('(compiler)compileToken', ops, sym.symbol);

              if (ops.has(sym.symbol)) {
                compFnBody += ops.get(sym.symbol)(r, args);
              } else {
                if (sym.symbol === state.config.reservedNames.spread) {
                  compFnBody += `...(${args.map(x => compileToken([(0,_compile_ops_helpers__WEBPACK_IMPORTED_MODULE_2__.stripQuoteOrPass)(state, x)], 0)).join(',')})`;
                } else if (state.funcMap.has(sym.symbol)) {
                  _$_vars[ctx.varsCount] = state.funcMap.get(sym.symbol).fn(state, '');
                  compFnBody += `((_$_vars[${String(ctx.varsCount++)}])(${args.map(x => compileToken([(0,_compile_ops_helpers__WEBPACK_IMPORTED_MODULE_2__.stripQuoteOrPass)(state, x)], 0)).join(',')}))`;
                } else if (ctx.varNames.has(sym.symbol)) {
                  compFnBody += `(${String(ctx.varNames.get(sym.symbol))})(${args.map(x => compileToken([(0,_compile_ops_helpers__WEBPACK_IMPORTED_MODULE_2__.stripQuoteOrPass)(state, x)], 0)).join(',')})`;
                } else {
                  _$_vars[ctx.varsCount] = (0,_compile_ops_helpers__WEBPACK_IMPORTED_MODULE_2__.resolveValueSymbol_dynamic)(state, sym.symbol);
                  compFnBody += `((_$_vars[${String(ctx.varsCount++)}])()(${args.map(x => compileToken([(0,_compile_ops_helpers__WEBPACK_IMPORTED_MODULE_2__.stripQuoteOrPass)(state, x)], 0)).join(',')}))`;
                }
              }
            } else {
              switch (typeof r[0]) {
                case 'function':
                  _$_vars[ctx.varsCount] = r[0];
                  compFnBody += `((_$_vars[${String(ctx.varsCount++)}])(${r.slice(1).map((x, idx, arr) => compileToken([(0,_compile_ops_helpers__WEBPACK_IMPORTED_MODULE_2__.stripQuoteOrPass)(state, x)], 0)).join(',')}))`;
                  break;

                default:
                  throw new Error(`[SX] compileToken: First item of list is not a function: ${JSON.stringify(r[0])}.`);
              }
            }
          } else {
            compFnBody += '([])';
          }
        } else {
          compFnBody += compileValue(b);
        }
      } else {
        compFnBody += '([])';
      }
    } else {
      compFnBody += compileValue(b);
    }

    return compFnBody;
  }

  const ctx = {
    _$_vars,
    varsCount: 1,
    varNames: new Map(),
    varNamesCount: 0,
    varDefs: 'var x0;',
    ops: new Map(),
    makeScope,
    compileToken
  };
  (0,_compile_ops__WEBPACK_IMPORTED_MODULE_3__.registerOperators)(state, ctx);
  const ops = ctx.ops;

  if (state.config.enableTailCallOptimization) {
    fnBody = (0,_evaluate__WEBPACK_IMPORTED_MODULE_0__.optimizeTailCall)(state, formalArgs, fnBody);
  } // set 'this' object


  ctx.varNames.set(state.config.reservedNames.thiz, `(this===(Function('return this')())?null:(this===void 0?null:this))`);
  const capturedScopes = (0,_evaluate__WEBPACK_IMPORTED_MODULE_0__.getCapturedScopes)(state);

  if (capturedScopes) {
    for (const x in capturedScopes) {
      if (Object.prototype.hasOwnProperty.call(capturedScopes, x)) {
        _$_vars[ctx.varsCount++] = x;
        _$_vars[ctx.varsCount] = capturedScopes[x];
        ctx.varNames.set(x, `(_$_vars[${String(ctx.varsCount)}][_$_vars[${String(ctx.varsCount - 1)}]])`);
        ctx.varsCount++;
      }
    }
  }

  const compFormalArgs = `${formalArgs.map((x, i) => {
    ctx.varNames.set(formalArgs[i].symbol, 'a' + i);
    return `${lastIsSpread && i === formalArgs.length - 1 ? '...' : ''}a${i}`;
  }).join(',')}`;
  const compFnBodyRoot = `return(${fnBody.map((x, i) => compileToken(fnBody, i)).join(',')})`;
  return `(function(${compFormalArgs}){"strict";${ctx.varDefs}${compFnBodyRoot}})`;
} // tslint:disable-next-line:variable-name


function evalCompiledLambda(_$_state, _$_vars, code) {
  // tslint:disable-next-line:no-eval
  _$_vars[0] = eval(code);
  return _$_vars[0];
}

function compileLambda(state, formalArgs, lastIsSpread, fnBody) {
  // tslint:disable-next-line:variable-name
  const _$_vars = [];
  return evalCompiledLambda(state, _$_vars, compileCore(state, formalArgs, lastIsSpread, fnBody, _$_vars));
}

/***/ }),

/***/ "./node_modules/liyad/modules/s-exp/compile.ops/helpers.js":
/*!*****************************************************************!*\
  !*** ./node_modules/liyad/modules/s-exp/compile.ops/helpers.js ***!
  \*****************************************************************/
/*! namespace exports */
/*! export applyMacros [provided] [no usage info] [missing usage info prevents renaming] */
/*! export checkUnsafeVarNames_dynamic [provided] [no usage info] [missing usage info prevents renaming] */
/*! export getScope_stateApplied [provided] [no usage info] [missing usage info prevents renaming] */
/*! export resolveValueSymbol_dynamic [provided] [no usage info] [missing usage info prevents renaming] */
/*! export stripQuote [provided] [no usage info] [missing usage info prevents renaming] */
/*! export stripQuoteOrPass [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_require__, __webpack_require__.r, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "applyMacros": () => /* binding */ applyMacros,
/* harmony export */   "stripQuote": () => /* binding */ stripQuote,
/* harmony export */   "stripQuoteOrPass": () => /* binding */ stripQuoteOrPass,
/* harmony export */   "getScope_stateApplied": () => /* binding */ getScope_stateApplied,
/* harmony export */   "resolveValueSymbol_dynamic": () => /* binding */ resolveValueSymbol_dynamic,
/* harmony export */   "checkUnsafeVarNames_dynamic": () => /* binding */ checkUnsafeVarNames_dynamic
/* harmony export */ });
/* harmony import */ var _ast__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../ast */ "./node_modules/liyad/modules/s-exp/ast.js");
/* harmony import */ var _evaluate__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../evaluate */ "./node_modules/liyad/modules/s-exp/evaluate.js");
/* harmony import */ var _errors__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../errors */ "./node_modules/liyad/modules/s-exp/errors.js");
// Copyright (c) 2018, Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln



function applyMacros(state, tok) {
  let r = tok;

  for (;;) {
    if (Array.isArray(r)) {
      if (r.length === 0) {
        break;
      }

      r = (0,_evaluate__WEBPACK_IMPORTED_MODULE_0__.resolveSplice)(state, r);
      const sym = (0,_ast__WEBPACK_IMPORTED_MODULE_2__.isSymbol)(r[0]);

      if (sym) {
        const m = (0,_evaluate__WEBPACK_IMPORTED_MODULE_0__.resolveMacro)(state, sym, r);

        if (m) {
          r = m.fn(m.actualArgs);
        } else {
          break;
        }
      } else {
        break;
      }
    } else {
      break;
    }

    (0,_errors__WEBPACK_IMPORTED_MODULE_1__.setEvaluationCount)(state);
  }

  return r;
}
function stripQuote(state, tok) {
  if (!(Array.isArray(tok) && (0,_ast__WEBPACK_IMPORTED_MODULE_2__.isSymbol)(tok[0], state.config.reservedNames.quote))) {
    throw new Error(`[SX] stripQuote: token is not quoted.`);
  }

  return tok[1];
}
function stripQuoteOrPass(state, tok) {
  if (Array.isArray(tok) && (0,_ast__WEBPACK_IMPORTED_MODULE_2__.isSymbol)(tok[0], state.config.reservedNames.quote)) {
    return tok[1];
  } else {
    return tok;
  }
}
function getScope_stateApplied(state) {
  return function () {
    return (0,_evaluate__WEBPACK_IMPORTED_MODULE_0__.getScope)(state);
  };
}
function resolveValueSymbol_dynamic(state, varName) {
  (0,_errors__WEBPACK_IMPORTED_MODULE_1__.checkUnsafeVarNames)('(compiler)resolveValueSymbol_dynamic', varName);
  return function () {
    return (0,_evaluate__WEBPACK_IMPORTED_MODULE_0__.resolveValueSymbol)(state, {
      symbol: varName
    });
  };
}
function checkUnsafeVarNames_dynamic(name) {
  return function (varName) {
    return (0,_errors__WEBPACK_IMPORTED_MODULE_1__.checkUnsafeVarNames)(name, varName);
  };
}

/***/ }),

/***/ "./node_modules/liyad/modules/s-exp/compile.ops/index.js":
/*!***************************************************************!*\
  !*** ./node_modules/liyad/modules/s-exp/compile.ops/index.js ***!
  \***************************************************************/
/*! namespace exports */
/*! export registerOperators [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_require__, __webpack_require__.r, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "registerOperators": () => /* binding */ registerOperators
/* harmony export */ });
/* harmony import */ var _ast__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../ast */ "./node_modules/liyad/modules/s-exp/ast.js");
/* harmony import */ var _errors__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../errors */ "./node_modules/liyad/modules/s-exp/errors.js");
/* harmony import */ var _helpers__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./helpers */ "./node_modules/liyad/modules/s-exp/compile.ops/helpers.js");
// Copyright (c) 2018, Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln



function registerOperators(state, ctx) {
  const {
    _$_vars,
    ops,
    makeScope,
    compileToken
  } = ctx;
  ops.set(state.config.reservedNames.quote, function (r, args) {
    let compFnBody = '';
    _$_vars[ctx.varsCount] = r[1];
    compFnBody += `(_$_vars[${String(ctx.varsCount++)}])`;
    return compFnBody;
  });
  ops.set(state.config.reservedNames.self, function (r, args) {
    let compFnBody = '';
    compFnBody += `((_$_vars[0])(${args.map(x => compileToken([(0,_helpers__WEBPACK_IMPORTED_MODULE_1__.stripQuoteOrPass)(state, x)], 0)).join(',')}))`;
    return compFnBody;
  });
  ops.set('$__if', function (r, args) {
    // S expression: ($__if condition 't-expr 'f-expr)
    //  -> (if condition is true ) S expr  : t-expr
    //  -> (if condition is false) S expr  : f-expr
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:$__if', args, 2, 3);
    compFnBody += `(${compileToken(r, 1)}?(${compileToken([(0,_helpers__WEBPACK_IMPORTED_MODULE_1__.stripQuote)(state, r[2])], 0)}):(${compileToken([(0,_helpers__WEBPACK_IMPORTED_MODULE_1__.stripQuote)(state, r[3])], 0)}))`;
    return compFnBody;
  });
  ops.set('$__if-null', function (r, args) {
    // S expression: ($__if-null condition 'null-expr)
    //  -> (if condition is not null ) S expr  : condition
    //  -> (if condition is null)      S expr  : null-expr
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:$__if-null', args, 2, 2);
    compFnBody += `((()=>{let _$_rv=${compileToken(r, 1)};return _$_rv?_$_rv:(${compileToken([(0,_helpers__WEBPACK_IMPORTED_MODULE_1__.stripQuote)(state, r[2])], 0)}});})())`;
    return compFnBody;
  });
  ops.set('$__cond', function (r, args) {
    // S expression: ($__cond 'cond1 'expr1 ... 'condN 'exprN)
    //  -> (if (eval condI) is true ) S expr  : exprI
    //  -> (if no matched)            S expr  : null
    let compFnBody = '';
    {
      (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:$__cond', args, 1);
      compFnBody += `(`;

      for (let p = 0; p < args.length; p += 2) {
        compFnBody += `${compileToken([(0,_helpers__WEBPACK_IMPORTED_MODULE_1__.stripQuote)(state, args[p])], 0)}?(${compileToken([(0,_helpers__WEBPACK_IMPORTED_MODULE_1__.stripQuote)(state, args[p + 1])], 0)}):(`;
      }

      compFnBody += `null`;

      for (let p = 0; p < args.length; p += 2) {
        compFnBody += `)`;
      }

      compFnBody += `)`;
    }
    return compFnBody;
  });
  ops.set('$__while', function (r, args) {
    // S expression: ($__while 'condition 'expr1 ... 'exprN)
    //  -> (if condition is true at least 1 or more times) S expr  : exprN
    //  -> (else)                                          S expr  : null
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:$__while', args, 1);
    compFnBody += `((()=>{let _$_rv=null;while(${compileToken([(0,_helpers__WEBPACK_IMPORTED_MODULE_1__.stripQuote)(state, r[1])], 0)}){_$_rv=${r.slice(2).map(x => compileToken([(0,_helpers__WEBPACK_IMPORTED_MODULE_1__.stripQuote)(state, x)], 0)).join(',')}}return _$_rv})())`;
    return compFnBody;
  });
  ops.set('$__do-while', function (r, args) {
    // S expression: ($__do-while 'condition 'expr1 ... 'exprN)
    //  -> (if condition is true at least 1 or more times) S expr  : exprN
    //  -> (else)                                          S expr  : null
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:$__do-until', args, 1);
    compFnBody += `((()=>{let _$_rv=null;do{_$_rv=${r.slice(2).map(x => compileToken([(0,_helpers__WEBPACK_IMPORTED_MODULE_1__.stripQuote)(state, x)], 0)).join(',')}}}while(${compileToken([(0,_helpers__WEBPACK_IMPORTED_MODULE_1__.stripQuote)(state, r[1])], 0)})return _$_rv)())`;
    return compFnBody;
  });
  ops.set('$__until', function (r, args) {
    // S expression: ($__until 'condition 'expr1 ... 'exprN)
    //  -> (if condition is true at least 1 or more times) S expr  : exprN
    //  -> (else)                                          S expr  : null
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:$__until', args, 1);
    compFnBody += `((()=>{let _$_rv=null;while(!${compileToken([(0,_helpers__WEBPACK_IMPORTED_MODULE_1__.stripQuote)(state, r[1])], 0)}){_$_rv=${r.slice(2).map(x => compileToken([(0,_helpers__WEBPACK_IMPORTED_MODULE_1__.stripQuote)(state, x)], 0)).join(',')}}return _$_rv})())`;
    return compFnBody;
  });
  ops.set('$__do-until', function (r, args) {
    // S expression: ($__do-until 'condition 'expr1 ... 'exprN)
    //  -> (if condition is true at least 1 or more times) S expr  : exprN
    //  -> (else)                                          S expr  : null
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:$__do-until', args, 1);
    compFnBody += `((()=>{let _$_rv=null;do{_$_rv=${r.slice(2).map(x => compileToken([(0,_helpers__WEBPACK_IMPORTED_MODULE_1__.stripQuote)(state, x)], 0)).join(',')}}}while(!${compileToken([(0,_helpers__WEBPACK_IMPORTED_MODULE_1__.stripQuote)(state, r[1])], 0)})return _$_rv)())`;
    return compFnBody;
  });
  ops.set('$__repeat', function (r, args) {
    // S expression: ($__repeat 'i n-times 'expr1 ... 'exprN)
    //  -> (if n > 0) S expr  : exprN
    //  -> (else)     S expr  : null
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:$__repeat', args, 2);

    if (!(0,_ast__WEBPACK_IMPORTED_MODULE_2__.isSymbol)(args[0])) {
      throw new Error(`[SX] compileToken: $__repeat : args[0] is not symbol.`);
    }

    makeScope(() => {
      const name = 'v' + ctx.varNamesCount++;
      ctx.varNames.set(args[0].symbol, name);
      compFnBody += `(((_$_n)=>{let _$_rv=null;for(let ${name}=0;${name}<_$_n;${name}++){_$_rv=${r.slice(2).map(x => compileToken([(0,_helpers__WEBPACK_IMPORTED_MODULE_1__.stripQuote)(state, x)], 0)).join(',')}}return _$_rv})(${compileToken(args, 1)}))`;
    });
    return compFnBody;
  });
  ops.set('$__for', function (r, args) {
    // S expression: ($__for 'x list 'expr1 ... 'exprN)
    //  -> (if list.length > 0) S expr  : exprN
    //  -> (else)               S expr  : null
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:$__for', args, 2);

    if (!(0,_ast__WEBPACK_IMPORTED_MODULE_2__.isSymbol)(args[0])) {
      throw new Error(`[SX] compileToken: $__for : args[0] is not symbol.`);
    }

    makeScope(() => {
      const name = 'v' + ctx.varNamesCount++;
      ctx.varNames.set(args[0].symbol, name);
      compFnBody += `(((_$_l)=>{let _$_rv=null;for(const ${name} of _$_l){_$_rv=${r.slice(2).map(x => compileToken([(0,_helpers__WEBPACK_IMPORTED_MODULE_1__.stripQuote)(state, x)], 0)).join(',')}}return _$_rv})(${compileToken(args, 1)}))`;
    });
    return compFnBody;
  });
  ops.set('$__scope', function (r, args) {
    // S expression: ($__scope isBlockLocal returnMultiple '((name value) | name ...) 'expr1 ... 'exprN)
    //  -> (if returnMultiple)  S expr  : [expr1 ... exprN]
    //  -> (else)               S expr  : exprN
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:$__scope', args, 2); // r[1]: isBlockLocal
    // r[2]: returnMultiple

    if (!Array.isArray(r[3])) {
      throw new Error(`[SX] compileToken: $__scope : args[2] is not array.`);
    }

    makeScope(() => {
      for (const x of (0,_helpers__WEBPACK_IMPORTED_MODULE_1__.stripQuote)(state, r[3])) {
        let name = '';

        if (Array.isArray(x)) {
          if (x.length < 1) {
            throw new Error(`[SX] compileToken: $__scope : args[0][?] is too short.`);
          }

          if (!(0,_ast__WEBPACK_IMPORTED_MODULE_2__.isSymbol)(x[0])) {
            throw new Error(`[SX] compileToken: $__scope : args[0][?][0] is not symbol.`);
          }

          name = x[0].symbol;
          compFnBody += `(${'v' + ctx.varNamesCount}=${compileToken(x, 1)})`;
        } else {
          if (!(0,_ast__WEBPACK_IMPORTED_MODULE_2__.isSymbol)(x)) {
            throw new Error(`[SX] compileToken: $__scope : args[0][?] is not symbol.`);
          }

          name = x.symbol;
        }

        ctx.varDefs += `var v${ctx.varNamesCount}=void 0;`;
        ctx.varNames.set(name, 'v' + ctx.varNamesCount++);
      }

      const s = `${r.slice(4).map(x => compileToken([(0,_helpers__WEBPACK_IMPORTED_MODULE_1__.stripQuote)(state, x)], 0)).join(',')}`;
      compFnBody += r[2] ? `[${s}]` : `(${s})`;
    });
    return compFnBody;
  });
  ops.set('$__try', function (r, args) {
    // S expression: ($__try 'expr 'catch-expr)
    //  ->                               S expr  : expr
    //  -> (if error is raised in expr)  S expr  : catch-expr
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:$__try', args, 1, 2);
    compFnBody += `((()=>{try{${compileToken([(0,_helpers__WEBPACK_IMPORTED_MODULE_1__.stripQuote)(state, r[1])], 0)}}catch(e${ctx.varNamesCount}){let e${ctx.varNamesCount + 1}=(_$_vars[${String(ctx.varsCount)}])();`;
    _$_vars[ctx.varsCount++] = (0,_helpers__WEBPACK_IMPORTED_MODULE_1__.getScope_stateApplied)(state);
    makeScope(() => {
      ctx.varNames.set('$error', 'e' + ctx.varNamesCount++);
      ctx.varNames.set('$parent', 'e' + ctx.varNamesCount++);
      compFnBody += `${compileToken([(0,_helpers__WEBPACK_IMPORTED_MODULE_1__.stripQuote)(state, r[2])], 0)}}})())`;
    });
    return compFnBody;
  });
  ops.set(state.config.reservedNames.raise, function (r, args) {
    // S expression: ($raise 'expr)
    //  -> S expr  : -
    let compFnBody = '';
    compFnBody += `((()=>{throw ${compileToken([(0,_helpers__WEBPACK_IMPORTED_MODULE_1__.stripQuoteOrPass)(state, r[1])], 0)}})())`;
    return compFnBody;
  });
  ops.set('$boolean', function (r, args) {
    // S expression: ($boolean any)
    //  -> S expr  : boolean
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:$boolean', args, 1, 1);
    compFnBody += `((x0=${compileToken(args, 0)}),(Array.isArray(x0)&&x0.length===0?false:boolean(x0)))`;
    return compFnBody;
  });
  ops.set('$__get', function (r, args) {
    // S expression: ($__get 'nameOrIndex1 ... 'nameOrIndexN)
    //  -> S expr  : any
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:$__get', args, 1);
    const quoted = (0,_helpers__WEBPACK_IMPORTED_MODULE_1__.stripQuote)(state, r[1]);
    const name = (0,_ast__WEBPACK_IMPORTED_MODULE_2__.isSymbol)(quoted) ? quoted.symbol : typeof quoted === 'string' ? quoted : null;

    if (typeof name !== 'string') {
      throw new Error(`[SX] compileToken: $__get : operand is not symbol: ${JSON.stringify(r[1])}.`);
    }

    let vName = '';

    if (ctx.varNames.has(name)) {
      vName = ctx.varNames.get(name);
    } else {
      _$_vars[ctx.varsCount] = (0,_helpers__WEBPACK_IMPORTED_MODULE_1__.resolveValueSymbol_dynamic)(state, name);
      vName = `_$_vars[${String(ctx.varsCount++)}]`;
    }

    const regToVars = symName => {
      _$_vars[ctx.varsCount] = symName;
      return `_$_vars[${String(ctx.varsCount++)}]`;
    };

    compFnBody += `((${vName})${r.slice(2).map((x, idx, arr) => `[${(0,_ast__WEBPACK_IMPORTED_MODULE_2__.isSymbol)(arr[idx]) ? regToVars(arr[idx].symbol) : compileToken(arr, idx)}]`).join('')})`;
    return compFnBody;
  });
  ops.set('$__let', function (r, args) {
    // S expression: ($__let 'nameStrOrSymbol expr)
    //  -> S expr  : any
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:$__let', args, 2, 2);
    const quoted = (0,_helpers__WEBPACK_IMPORTED_MODULE_1__.stripQuote)(state, r[1]);
    const name = (0,_ast__WEBPACK_IMPORTED_MODULE_2__.isSymbol)(quoted) ? quoted.symbol : typeof quoted === 'string' ? quoted : null;

    if (typeof name !== 'string') {
      throw new Error(`[SX] compileToken: $__let : operand is not rvalue: ${JSON.stringify(r[1])}.`);
    }

    if (!ctx.varNames.has(name)) {
      ctx.varDefs += `var v${ctx.varNamesCount}=void 0;`;
      ctx.varNames.set(name, 'v' + ctx.varNamesCount++);
    }

    compFnBody += `(${ctx.varNames.get(name)}=${compileToken(r, 2)})`;
    return compFnBody;
  });
  ops.set('$__set', function (r, args) {
    // S expression: ($__set 'nameOrListOfNameOrIndex expr)
    //  -> S expr  : any
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:$__set', args, 2);
    const quoted = (0,_helpers__WEBPACK_IMPORTED_MODULE_1__.stripQuote)(state, r[1]);
    const name = (0,_ast__WEBPACK_IMPORTED_MODULE_2__.isSymbol)(quoted) ? quoted.symbol : typeof quoted === 'string' ? quoted : Array.isArray(quoted) ? (0,_ast__WEBPACK_IMPORTED_MODULE_2__.isSymbol)(quoted[0]) ? quoted[0].symbol : typeof quoted[0] === 'string' ? quoted[0] : null : null;

    if (typeof name !== 'string') {
      throw new Error(`[SX] compileToken: $__set : operand is not rvalue: ${JSON.stringify(r[1])}.`);
    }

    let vName = '';

    if (ctx.varNames.has(name)) {
      vName = ctx.varNames.get(name);
    } else {
      _$_vars[ctx.varsCount] = (0,_helpers__WEBPACK_IMPORTED_MODULE_1__.resolveValueSymbol_dynamic)(state, name);
      vName = `_$_vars[${String(ctx.varsCount++)}]`;
    }

    const regToVars = symName => {
      _$_vars[ctx.varsCount] = (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkUnsafeVarNames)('compileToken:$__set', symName);
      return `_$_vars[${String(ctx.varsCount++)}]`;
    };

    let checkNameCalled = false;
    let checkNamePos = '';

    const checkName = str => {
      if (!checkNameCalled) {
        _$_vars[ctx.varsCount] = (0,_helpers__WEBPACK_IMPORTED_MODULE_1__.checkUnsafeVarNames_dynamic)('compileToken:$__set');
        checkNamePos = String(ctx.varsCount++);
        checkNameCalled = true;
      }

      return `(_$_vars[${checkNamePos}](${str}))`;
    };

    compFnBody += `((${vName})${(Array.isArray(quoted) ? quoted.slice(1) : []).map((x, idx, arr) => `[${(0,_ast__WEBPACK_IMPORTED_MODULE_2__.isSymbol)(arr[idx]) ? regToVars(arr[idx].symbol) : checkName(compileToken(arr, idx))}]`).join('')}=${compileToken(r, 2)})`;
    return compFnBody;
  });
  ops.set(state.config.reservedNames.not, function (r, args) {
    // S expression: ($not any)
    //  -> S expr  : boolean
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:$not', args, 1, 1);
    compFnBody += `(!${compileToken(args, 0)})`;
    return compFnBody;
  });
  ops.set('$__and', function (r, args) {
    // S expression: ($__and 'expr1 ... 'exprN)
    //  -> (if all of ($boolean expr1) ... ($boolean exprN) are true) S expr  : exprN
    //  -> (else)                                                     S expr  : expr-i (false left most)
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:$__and', args, 1);
    compFnBody += `(${args.map(x => compileToken([(0,_helpers__WEBPACK_IMPORTED_MODULE_1__.stripQuote)(state, x)], 0)).join('&&')})`;
    return compFnBody;
  });
  ops.set('$__or', function (r, args) {
    // S expression: ($__or 'expr1 ... 'exprN)
    //  -> (if any ($boolean expr1) ... ($boolean exprN) are true) S expr  : expr-i (where i: index of item first ($boolean expr-i) is to be true)
    //  -> (else)                                                  S expr  : expr-i (false right most)
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:$__or', args, 1);
    compFnBody += `(${args.map(x => compileToken([(0,_helpers__WEBPACK_IMPORTED_MODULE_1__.stripQuote)(state, x)], 0)).join('||')})`;
    return compFnBody;
  });
  ops.set('===', function (r, args) {
    // S expression: ($eq arg1 arg2)
    //  -> (if arg1 === arg2)  S expr  : true
    //  -> (else)              S expr  : false
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:===', args, 2, 2);
    compFnBody += `(${args.map((x, idx, arr) => compileToken(arr, idx)).join('===')})`;
    return compFnBody;
  });
  ops.set('!==', function (r, args) {
    // S expression: ($not-eq arg1 arg2)
    //  -> (if arg1 !== arg2)  S expr  : true
    //  -> (else)              S expr  : false
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:!==', args, 2, 2);
    compFnBody += `(${args.map((x, idx, arr) => compileToken(arr, idx)).join('!==')})`;
    return compFnBody;
  });
  ops.set('==', function (r, args) {
    // S expression: (== a b)
    //  -> S expr  : boolean
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:==', args, 2, 2);
    compFnBody += `(${args.map((x, idx, arr) => compileToken(arr, idx)).join('==')})`;
    return compFnBody;
  });
  ops.set('!=', function (r, args) {
    // S expression: (!= a b)
    //  -> S expr  : boolean
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:!=', args, 2, 2);
    compFnBody += `(${args.map((x, idx, arr) => compileToken(arr, idx)).join('!=')})`;
    return compFnBody;
  });
  ops.set('<', function (r, args) {
    // S expression: (< a b)
    //  -> S expr  : boolean
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:<', args, 2, 2);
    compFnBody += `(${args.map((x, idx, arr) => compileToken(arr, idx)).join('<')})`;
    return compFnBody;
  });
  ops.set('<=', function (r, args) {
    // S expression: (<= a b)
    //  -> S expr  : boolean
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:<=', args, 2, 2);
    compFnBody += `(${args.map((x, idx, arr) => compileToken(arr, idx)).join('<=')})`;
    return compFnBody;
  });
  ops.set('>', function (r, args) {
    // S expression: (> a b)
    //  -> S expr  : boolean
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:>', args, 2, 2);
    compFnBody += `(${args.map((x, idx, arr) => compileToken(arr, idx)).join('>')})`;
    return compFnBody;
  });
  ops.set('>=', function (r, args) {
    // S expression: (>= a b)
    //  -> S expr  : boolean
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:<=', args, 2, 2);
    compFnBody += `(${args.map((x, idx, arr) => compileToken(arr, idx)).join('>=')})`;
    return compFnBody;
  });
  ops.set('$concat', function (r, args) {
    // S expression: ($concat listOrString1 ... listOrStringN)
    //  -> S expr  : listOrString
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:$concat', args, 1);
    let w1 = '';

    if (Array.isArray(args[0]) && (0,_ast__WEBPACK_IMPORTED_MODULE_2__.isSymbol)(args[0][0], state.config.reservedNames.spread)) {
      const w0 = compileToken(args[0], 1);
      w1 = `(${w0}[0]).concat((${w0}.length>1?${w0}[1]:(typeof ${w0}[0]==='string'?'':[])),`;
    } else {
      w1 = `${compileToken(args, 0)}.concat(`;
    }

    compFnBody += `(${w1}${args.slice(1).map((x, idx, arr) => compileToken(arr, idx)).join(',')}))`;
    return compFnBody;
  });
  ops.set('+', function (r, args) {
    // S expression: (+ number1 ... numberN)
    //  -> S expr  : number
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:+', args, 1);
    let hasSpread = false;
    args.map((x, idx, arr) => {
      if (Array.isArray(x) && (0,_ast__WEBPACK_IMPORTED_MODULE_2__.isSymbol)(x[0], state.config.reservedNames.spread)) {
        hasSpread = true;
      }
    });

    if (hasSpread) {
      compFnBody += `((()=>{let _$_rv=[];${args.map((x, idx, arr) => `_$_rv.push(${compileToken(arr, idx)})`).join(';')};return _$_rv.reduce((x,y)=>x+y);})())`;
    } else {
      compFnBody += `(${args.map((x, idx, arr) => compileToken(arr, idx)).join('+')})`;
    }

    return compFnBody;
  });
  ops.set('-', function (r, args) {
    // S expression: (- number1 ... numberN)
    //  -> S expr  : number
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:-', args, 1);
    let hasSpread = false;
    args.map((x, idx, arr) => {
      if (Array.isArray(x) && (0,_ast__WEBPACK_IMPORTED_MODULE_2__.isSymbol)(x[0], state.config.reservedNames.spread)) {
        hasSpread = true;
      }
    });

    if (hasSpread) {
      compFnBody += `((()=>{let _$_rv=[];${args.map((x, idx, arr) => `_$_rv.push(${compileToken(arr, idx)})`).join(';')};return (_$_rv.length>1?(_$_rv.reduce((x,y)=>x-y)):(_$_rv.length>0?-_$_rv[0]:NaN));})())`;
    } else {
      compFnBody += `(${r.length > 2 ? args.map((x, idx, arr) => compileToken(arr, idx)).join('-') : `-(${String(compileToken(r, 1))})`})`;
    }

    return compFnBody;
  });
  ops.set('*', function (r, args) {
    // S expression: (* number1 ... numberN)
    //  -> S expr  : number
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:*', args, 2);
    let hasSpread = false;
    args.map((x, idx, arr) => {
      if (Array.isArray(x) && (0,_ast__WEBPACK_IMPORTED_MODULE_2__.isSymbol)(x[0], state.config.reservedNames.spread)) {
        hasSpread = true;
      }
    });

    if (hasSpread) {
      compFnBody += `((()=>{let _$_rv=[];${args.map((x, idx, arr) => `_$_rv.push(${compileToken(arr, idx)})`).join(';')};return _$_rv.reduce((x,y)=>x*y);})())`;
    } else {
      compFnBody += `(${args.map((x, idx, arr) => compileToken(arr, idx)).join('*')})`;
    }

    return compFnBody;
  });
  ops.set('**', function (r, args) {
    // S expression: (** number1 ... numberN)
    //  -> S expr  : number
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:**', args, 2);
    let hasSpread = false;
    args.map((x, idx, arr) => {
      if (Array.isArray(x) && (0,_ast__WEBPACK_IMPORTED_MODULE_2__.isSymbol)(x[0], state.config.reservedNames.spread)) {
        hasSpread = true;
      }
    });

    if (hasSpread) {
      compFnBody += `((()=>{let _$_rv=[];${args.map((x, idx, arr) => `_$_rv.push(${compileToken(arr, idx)})`).join(';')};return _$_rv.reduce((x,y)=>x**y);})())`;
    } else {
      compFnBody += `(${args.map((x, idx, arr) => compileToken(arr, idx)).join('**')})`;
    }

    return compFnBody;
  });
  ops.set('/', function (r, args) {
    // S expression: (/ number1 ... numberN)
    //  -> S expr  : number
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:/', args, 2);
    let hasSpread = false;
    args.map((x, idx, arr) => {
      if (Array.isArray(x) && (0,_ast__WEBPACK_IMPORTED_MODULE_2__.isSymbol)(x[0], state.config.reservedNames.spread)) {
        hasSpread = true;
      }
    });

    if (hasSpread) {
      compFnBody += `((()=>{let _$_rv=[];${args.map((x, idx, arr) => `_$_rv.push(${compileToken(arr, idx)})`).join(';')};return _$_rv.reduce((x,y)=>x/y);})())`;
    } else {
      compFnBody += `(${args.map((x, idx, arr) => compileToken(arr, idx)).join('/')})`;
    }

    return compFnBody;
  });
  ops.set('%', function (r, args) {
    // S expression: (% number1 ... numberN)
    //  -> S expr  : number
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:%', args, 2);
    let hasSpread = false;
    args.map((x, idx, arr) => {
      if (Array.isArray(x) && (0,_ast__WEBPACK_IMPORTED_MODULE_2__.isSymbol)(x[0], state.config.reservedNames.spread)) {
        hasSpread = true;
      }
    });

    if (hasSpread) {
      compFnBody += `((()=>{let _$_rv=[];${args.map((x, idx, arr) => `_$_rv.push(${compileToken(arr, idx)})`).join(';')};return _$_rv.reduce((x,y)=>x%y);})())`;
    } else {
      compFnBody += `(${args.map((x, idx, arr) => compileToken(arr, idx)).join('%')})`;
    }

    return compFnBody;
  });
  ops.set('<<', function (r, args) {
    // S expression: (<< number shift)
    //  -> S expr  : number
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:<<', args, 2, 2);
    compFnBody += `(${args.map((x, idx, arr) => compileToken(arr, idx)).join('<<')})`;
    return compFnBody;
  });
  ops.set('>>', function (r, args) {
    // S expression: (>> number shift)
    //  -> S expr  : number
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:>>', args, 2, 2);
    compFnBody += `(${args.map((x, idx, arr) => compileToken(arr, idx)).join('>>')})`;
    return compFnBody;
  });
  ops.set('>>>', function (r, args) {
    // S expression: (>>> number shift)
    //  -> S expr  : number
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:>>>', args, 2, 2);
    compFnBody += `(${args.map((x, idx, arr) => compileToken(arr, idx)).join('>>>')})`;
    return compFnBody;
  });
  ops.set('$bit-not', function (r, args) {
    // S expression: ($bit-not number)
    //  -> S expr  : number
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:$bit-not', args, 1, 1);
    compFnBody += `(~(${compileToken(r, 1)}))`;
    return compFnBody;
  });
  ops.set('$bit-and', function (r, args) {
    // S expression: ($bit-and numberA numberB)
    //  -> S expr  : number
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:$bit-and', args, 2, 2);
    compFnBody += `(${args.map((x, idx, arr) => compileToken(arr, idx)).join('&')})`;
    return compFnBody;
  });
  ops.set('$bit-or', function (r, args) {
    // S expression: ($bit-or numberA numberB)
    //  -> S expr  : number
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:$bit-or', args, 2, 2);
    compFnBody += `(${args.map((x, idx, arr) => compileToken(arr, idx)).join('|')})`;
    return compFnBody;
  });
  ops.set('$bit-xor', function (r, args) {
    // S expression: ($bit-xor numberA numberB)
    //  -> S expr  : number
    let compFnBody = '';
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('compileToken:$bit-xor', args, 2, 2);
    compFnBody += `(${args.map((x, idx, arr) => compileToken(arr, idx)).join('^')})`;
    return compFnBody;
  });
}

/***/ }),

/***/ "./node_modules/liyad/modules/s-exp/defaults.js":
/*!******************************************************!*\
  !*** ./node_modules/liyad/modules/s-exp/defaults.js ***!
  \******************************************************/
/*! namespace exports */
/*! export defaultConfig [provided] [no usage info] [missing usage info prevents renaming] */
/*! export defaultReservedNames [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_require__.r, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "defaultReservedNames": () => /* binding */ defaultReservedNames,
/* harmony export */   "defaultConfig": () => /* binding */ defaultConfig
/* harmony export */ });
// Copyright (c) 2018, Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln
const defaultReservedNames = {
  eval: '$eval',
  quote: '$quote',
  backquote: '$backquote',
  unquote: '$unquote',
  spread: '$spread',
  splice: '$splice',
  car: '$car',
  cdr: '$cdr',
  cons: '$cons',
  atom: '$atom',
  eq: '$eq',
  list: '$list',
  let: '$clisp-let',
  lambda: '$lambda',
  self: '$self',
  defun: '$defun',
  thiz: '$this',
  if: '$if',
  cond: '$cond',
  while: '$while',
  doWhile: '$do-while',
  until: '$until',
  doUntil: '$do-until',
  get: '$get',
  defvar: '$clisp-defvar',
  setq: '$clisp-setq',
  set: '$set',
  call: '$call',
  not: '$not',
  and: '$and',
  or: '$or',
  isSymbol: '$is-symbol',
  gensym: '$gensym',
  raise: '$raise',
  catch: '$catch',
  Template: 'Template'
};
const defaultConfig = {
  raiseOnUnresolvedSymbol: false,
  enableEvaluate: true,
  enableHereDoc: true,
  enableSpread: true,
  enableSplice: true,
  enableShorthands: true,
  enableVerbatimStringLiteral: true,
  enableTailCallOptimization: true,
  enableRegExpMatchOperators: true,
  enableCompilationOperators: true,
  stripComments: false,
  wrapExternalValue: true,
  returnMultipleRoot: false,
  maxEvalCount: 0,
  reservedNames: defaultReservedNames,
  symbols: [],
  macros: [],
  funcs: []
};

/***/ }),

/***/ "./node_modules/liyad/modules/s-exp/errors.js":
/*!****************************************************!*\
  !*** ./node_modules/liyad/modules/s-exp/errors.js ***!
  \****************************************************/
/*! namespace exports */
/*! export checkParamsLength [provided] [no usage info] [missing usage info prevents renaming] */
/*! export checkUnsafeVarNames [provided] [no usage info] [missing usage info prevents renaming] */
/*! export checkUnsafeVarNamesEx [provided] [no usage info] [missing usage info prevents renaming] */
/*! export setEvaluationCount [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_require__, __webpack_require__.r, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "setEvaluationCount": () => /* binding */ setEvaluationCount,
/* harmony export */   "checkParamsLength": () => /* binding */ checkParamsLength,
/* harmony export */   "checkUnsafeVarNames": () => /* binding */ checkUnsafeVarNames,
/* harmony export */   "checkUnsafeVarNamesEx": () => /* binding */ checkUnsafeVarNamesEx
/* harmony export */ });
/* harmony import */ var _types__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./types */ "./node_modules/liyad/modules/s-exp/types.js");
/* harmony import */ var _global_this__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./global-this */ "./node_modules/liyad/modules/s-exp/global-this.js");
// Copyright (c) 2018, Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln


function setEvaluationCount(state) {
  state.evalCount++;

  if (state.config.maxEvalCount && state.config.maxEvalCount < state.evalCount) {
    throw new _types__WEBPACK_IMPORTED_MODULE_0__.MaxEvaluationCountError();
  }
}
function checkParamsLength(name, args, min, max) {
  if (args.length < min) {
    throw new Error(`[SX] ${name}: Invalid argument length: expected: ${min} / args: ${args.length}.`);
  }

  if (max && max < args.length) {
    throw new Error(`[SX] ${name}: Invalid argument length: expected: ${max} / args: ${args.length}.`);
  }

  return args;
}
function checkUnsafeVarNames(name, varName) {
  if (varName === '__proto__' || varName === '__defineGetter__' || varName === '__defineSetter__' || varName === '__lookupGetter__' || varName === '__lookupSetter__') {
    throw new Error(`[SX] ${name}: Invalid var name ${varName}.`);
  }

  if (varName === 'prototype' || varName === 'constructor') {
    throw new Error(`[SX] ${name}: Invalid var name ${varName}.`);
  }

  if (_global_this__WEBPACK_IMPORTED_MODULE_1__.objConstructor.hasOwnProperty(varName)) {
    throw new Error(`[SX] ${name}: Invalid var name ${varName}.`);
  }

  if (varName === 'call' || varName === 'arguments' || varName === 'caller') {
    // NOTE: arguments, caller are not accessible in strict mode
    throw new Error(`[SX] ${name}: Invalid var name ${varName}.`);
  }

  return varName;
}
function checkUnsafeVarNamesEx(name, target, varName) {
  if (target === _global_this__WEBPACK_IMPORTED_MODULE_1__.globalObj || varName === '__proto__' || varName === '__defineGetter__' || varName === '__defineSetter__' || varName === '__lookupGetter__' || varName === '__lookupSetter__') {
    throw new Error(`[SX] ${name}: Invalid var name ${varName}.`);
  }

  if (varName === 'prototype' || varName === 'constructor') {
    if (target === null || target === void 0 || typeof target === 'function') {
      throw new Error(`[SX] ${name}: Invalid var name ${varName}.`);
    }
  }

  if (target === null || target === void 0 || target === _global_this__WEBPACK_IMPORTED_MODULE_1__.objConstructor) {
    if (_global_this__WEBPACK_IMPORTED_MODULE_1__.objConstructor.hasOwnProperty(varName)) {
      throw new Error(`[SX] ${name}: Invalid var name ${varName}.`);
    }
  }

  if (target === null || target === void 0 || target === _global_this__WEBPACK_IMPORTED_MODULE_1__.funConstructor) {
    // checking 'call', 'arguments', 'caller', ...
    let con = _global_this__WEBPACK_IMPORTED_MODULE_1__.funConstructor;

    while (con) {
      if (con.hasOwnProperty(varName)) {
        throw new Error(`[SX] ${name}: Invalid var name ${varName}.`);
      }

      con = con.__proto__;
    }
  }

  if (typeof target === 'function') {
    if (!target.hasOwnProperty(varName)) {
      // function's prototypes' members
      throw new Error(`[SX] ${name}: Invalid var name ${varName}.`);
    }
  }

  return varName;
}

/***/ }),

/***/ "./node_modules/liyad/modules/s-exp/evaluate.js":
/*!******************************************************!*\
  !*** ./node_modules/liyad/modules/s-exp/evaluate.js ***!
  \******************************************************/
/*! namespace exports */
/*! export collectCapturedVariables [provided] [no usage info] [missing usage info prevents renaming] */
/*! export evaluate [provided] [no usage info] [missing usage info prevents renaming] */
/*! export getCapturedScopes [provided] [no usage info] [missing usage info prevents renaming] */
/*! export getGlobalScope [provided] [no usage info] [missing usage info prevents renaming] */
/*! export getScope [provided] [no usage info] [missing usage info prevents renaming] */
/*! export installScope [provided] [no usage info] [missing usage info prevents renaming] */
/*! export matchMacroArgs [provided] [no usage info] [missing usage info prevents renaming] */
/*! export optimizeTailCall [provided] [no usage info] [missing usage info prevents renaming] */
/*! export resolveFunctionSymbol [provided] [no usage info] [missing usage info prevents renaming] */
/*! export resolveMacro [provided] [no usage info] [missing usage info prevents renaming] */
/*! export resolveSplice [provided] [no usage info] [missing usage info prevents renaming] */
/*! export resolveUnquote [provided] [no usage info] [missing usage info prevents renaming] */
/*! export resolveValueSymbol [provided] [no usage info] [missing usage info prevents renaming] */
/*! export resolveValueSymbolScope [provided] [no usage info] [missing usage info prevents renaming] */
/*! export toNumber [provided] [no usage info] [missing usage info prevents renaming] */
/*! export uninstallScope [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_require__, __webpack_require__.r, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "toNumber": () => /* binding */ toNumber,
/* harmony export */   "resolveUnquote": () => /* binding */ resolveUnquote,
/* harmony export */   "resolveSplice": () => /* binding */ resolveSplice,
/* harmony export */   "resolveMacro": () => /* binding */ resolveMacro,
/* harmony export */   "resolveFunctionSymbol": () => /* binding */ resolveFunctionSymbol,
/* harmony export */   "resolveValueSymbolScope": () => /* binding */ resolveValueSymbolScope,
/* harmony export */   "resolveValueSymbol": () => /* binding */ resolveValueSymbol,
/* harmony export */   "collectCapturedVariables": () => /* binding */ collectCapturedVariables,
/* harmony export */   "getCapturedScopes": () => /* binding */ getCapturedScopes,
/* harmony export */   "installScope": () => /* binding */ installScope,
/* harmony export */   "uninstallScope": () => /* binding */ uninstallScope,
/* harmony export */   "getScope": () => /* binding */ getScope,
/* harmony export */   "getGlobalScope": () => /* binding */ getGlobalScope,
/* harmony export */   "matchMacroArgs": () => /* binding */ matchMacroArgs,
/* harmony export */   "optimizeTailCall": () => /* binding */ optimizeTailCall,
/* harmony export */   "evaluate": () => /* binding */ evaluate
/* harmony export */ });
/* harmony import */ var _ast__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./ast */ "./node_modules/liyad/modules/s-exp/ast.js");
/* harmony import */ var _errors__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./errors */ "./node_modules/liyad/modules/s-exp/errors.js");
// Copyright (c) 2018, Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln


function toNumber(x) {
  switch (typeof x) {
    case 'object':
    case 'symbol':
    case 'function':
      return NaN;

    default:
      return Number(x);
  }
}
function resolveUnquote(state, r) {
  for (let i = 0; i < r.length; i++) {
    const symUnquote = Array.isArray(r[i]) && (0,_ast__WEBPACK_IMPORTED_MODULE_1__.isSymbol)(r[i][0], state.config.reservedNames.unquote);

    if (symUnquote) {
      r = r.slice(0, i).concat([evaluate(state, r[i][1])], r.slice(i + 1));
    }

    if (Array.isArray(r[i])) {
      r = r.slice(0);
      r[i] = resolveUnquote(state, r[i]);
    }
  }

  return resolveSplice(state, r);
}
function resolveSplice(state, r) {
  if (state.config.enableSplice) {
    for (let i = r.length - 1; i >= 0; i--) {
      const symSplice = Array.isArray(r[i]) && (0,_ast__WEBPACK_IMPORTED_MODULE_1__.isSymbol)(r[i][0], state.config.reservedNames.splice);

      if (symSplice) {
        r = r.slice(0, i).concat(r[i][1], r.slice(i + 1));
      }
    }
  }

  return r;
}
function resolveMacro(state, x, r) {
  const macroInfo = state.macroMap.get(x.symbol);
  let lastErr = null;

  if (macroInfo) {
    let m = macroInfo;
    const r1 = r.slice(1);

    while (m) {
      if (m.formalArgs) {
        const matchResult = matchMacroArgs(state, x.symbol, m.formalArgs, Boolean(m.lastIsSpread), r1);

        if (!matchResult.error) {
          return {
            fn: m.fn(state, x.symbol, matchResult.formalArgs),
            actualArgs: r.slice(0, 1).concat(matchResult.actualArgs)
          };
        }

        lastErr = matchResult.error;
        m = m.next;
      } else {
        return {
          fn: m.fn(state, x.symbol),
          actualArgs: r
        };
      }
    }

    if (lastErr) {
      throw new Error(lastErr);
    }
  }

  return false;
}
function resolveFunctionSymbol(state, x) {
  if (typeof x === 'function') {
    return x;
  }

  const funcInfo = state.funcMap.get(x.symbol);

  if (funcInfo) {
    return funcInfo.fn(state, x.symbol);
  } else {
    const v = resolveValueSymbol(state, x);

    if (typeof v === 'function') {
      return v;
    }

    if (state.config.funcSymbolResolverFallback) {
      return state.config.funcSymbolResolverFallback(state, x.symbol);
    }

    if (state.config.raiseOnUnresolvedSymbol) {
      throw new Error(`[SX] resolveFunctionSymbol: Unresolved symbol: ${x.symbol}.`);
    }

    return x.symbol;
  }
}
function resolveValueSymbolScope(state, x, nullIfNotDefined) {
  for (let i = state.scopes.length - 1; i > 0; i--) {
    const localScope = state.scopes[i];

    if (localScope && Object.prototype.hasOwnProperty.call(localScope.scope, x.symbol)) {
      return localScope.scope;
    }

    if (localScope.capturedScopes && Object.prototype.hasOwnProperty.call(localScope.capturedScopes, x.symbol)) {
      return localScope.capturedScopes[x.symbol];
    }

    if (!localScope.isBlockLocal) {
      break;
    }
  }

  const globalScope = getGlobalScope(state);

  if (Object.prototype.hasOwnProperty.call(globalScope.scope, x.symbol)) {
    return globalScope.scope;
  }

  return nullIfNotDefined ? null : getScope(state).scope;
}
function resolveValueSymbol(state, x) {
  const scope = resolveValueSymbolScope(state, x, true);

  if (scope) {
    return scope[x.symbol];
  }

  const symInfo = state.symbolMap.get(x.symbol);

  if (symInfo) {
    return symInfo.fn(state, x.symbol);
  } else {
    if (state.config.valueSymbolResolverFallback) {
      return state.config.valueSymbolResolverFallback(state, x.symbol);
    }

    if (state.config.raiseOnUnresolvedSymbol) {
      throw new Error(`[SX] resolveValueSymbol: Unresolved symbol: ${x.symbol}.`);
    }

    return x.symbol;
  }
}
function collectCapturedVariables(state, names) {
  const capturedScopes = {};

  for (const n of names) {
    const scope = resolveValueSymbolScope(state, n, true);

    if (scope === null) {
      throw new Error(`[SX] collectCapturedVariables: Unresolved symbols ${n}`);
    }

    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkUnsafeVarNamesEx)('collectCapturedVariables', capturedScopes, n.symbol);
    capturedScopes[n.symbol] = scope;
  }

  return capturedScopes;
}
function getCapturedScopes(state) {
  const a = [];

  for (let i = state.scopes.length - 1; i > 0; i--) {
    const localScope = state.scopes[i];

    if (localScope.capturedScopes) {
      a.unshift(localScope.capturedScopes);
    }

    if (!localScope.isBlockLocal) {
      break;
    }
  }

  return a.length > 0 ? Object.assign({}, ...a) : void 0;
}
function installScope(state, scope, isBlockLocal, capturedScopes) {
  state.scopes.push({
    isBlockLocal,
    scope,
    capturedScopes
  });
}
function uninstallScope(state) {
  if (state.scopes.length < 2) {
    throw new Error(`[SX] uninstallScope: Unable to pop stack.`);
  }

  return state.scopes.pop();
}
function getScope(state) {
  return state.scopes[state.scopes.length - 1];
}
function getGlobalScope(state) {
  return state.scopes[0];
}
function matchMacroArgs(state, macroName, formalArgs, lastIsSpread, actualArgs) {
  formalArgs = formalArgs.slice(0);
  actualArgs = actualArgs.slice(0);

  if (actualArgs.length + (lastIsSpread ? 1 : 0) < formalArgs.length) {
    return {
      error: `[SX] macro call (${macroName}): Actual args too short: actual ${actualArgs.length} / formal ${formalArgs.length}.`
    };
  }

  for (let i = formalArgs.length - (lastIsSpread ? 2 : 1); i >= 0; i--) {
    let nm = formalArgs[i].symbol;

    if (nm.startsWith('!')) {
      formalArgs[i].symbol = formalArgs[i].symbol.slice(1);
      nm = formalArgs[i].symbol;

      if (!(0,_ast__WEBPACK_IMPORTED_MODULE_1__.isSymbol)(actualArgs[i])) {
        return {
          error: `[SX] macro call (${macroName}): Actual arg(${i}: ${nm}) is not symbol.`
        };
      }
    } else if (nm.startsWith('<') && nm.endsWith('>')) {
      formalArgs[i].symbol = formalArgs[i].symbol.slice(1, -1);
      nm = formalArgs[i].symbol;

      if ((0,_ast__WEBPACK_IMPORTED_MODULE_1__.isSymbol)(actualArgs[i], nm)) {
        formalArgs = formalArgs.slice(0, i).concat(formalArgs.slice(i + 1));
        actualArgs = actualArgs.slice(0, i).concat(actualArgs.slice(i + 1));
      } else {
        return {
          error: `[SX] macro call (${macroName}): Actual arg(${i}: ${nm}) is not expected symbol.`
        };
      }
    } else {
      const tpos = nm.lastIndexOf(':');

      if (0 < tpos) {
        const tname = nm.slice(tpos + 1);

        switch (tname) {
          case 'number':
            if (typeof actualArgs[i] !== 'number') {
              return {
                error: `[SX] macro call (${macroName}): Actual arg(${i}: ${nm}) is not number.`
              };
            }

            break;

          case 'string':
            if (typeof actualArgs[i] !== 'string') {
              return {
                error: `[SX] macro call (${macroName}): Actual arg(${i}: ${nm}) is not string.`
              };
            }

            break;

          case 'function':
            if (!(Array.isArray(actualArgs[i]) && (0,_ast__WEBPACK_IMPORTED_MODULE_1__.isSymbol)(actualArgs[i][0]))) {
              return {
                error: `[SX] macro call (${macroName}): Actual arg(${i}: ${nm}) is not function.`
              };
            }

            break;

          case 'list':
            if (!Array.isArray(actualArgs[i])) {
              return {
                error: `[SX] macro call (${macroName}): Actual arg(${i}: ${nm}) is not list.`
              };
            }

            break;

          case 'symbol':
            if (!(0,_ast__WEBPACK_IMPORTED_MODULE_1__.isSymbol)(actualArgs[i])) {
              return {
                error: `[SX] macro call (${macroName}): Actual arg(${i}: ${nm}) is not symbol.`
              };
            }

            break;

          case 'any':
            break;

          default:
            return {
              error: `[SX] macro call (${macroName}): Formal arg(${i}: ${nm}) is unknown type ${tname}.`
            };
        }

        formalArgs[i].symbol = formalArgs[i].symbol.slice(0, tpos);
      }
    }
  }

  return {
    formalArgs,
    actualArgs
  };
}
function optimizeTailCall(state, formalArgs, fnBody) {
  // S expression: ($__lambda '(sym1 ... symN) 'expr1 ... 'exprN)
  //    formalArgs: 'sym1 ... 'symN
  //        fnBody: 'expr1 ... 'exprN
  if (Array.isArray(fnBody[fnBody.length - 1])) {
    const front = fnBody.slice(0, fnBody.length - 1);
    const tail = fnBody[fnBody.length - 1];

    if (tail && typeof tail[0] === 'object' && tail[0].symbol === state.config.reservedNames.if) {
      // S expression: ($if cond t-expr f-expr)
      if (Array.isArray(tail[3]) && typeof tail[3][0] === 'object' && tail[3][0].symbol === state.config.reservedNames.self) {
        // S expression (recursive):
        //     (                                 ;; fnBody
        //         expr1 ... exprN-1             ;; front
        //         ($if cond                     ;; tail[0] [1]
        //             t-expr                    ;;     [2]
        //             ($self                    ;;     [3]
        //                 rArgs1 ... rArgsN) )  ;; tail[4] ... [N+4]
        //     )
        //
        //  -> S exp (tail call optimization):
        //     (                                                                  ;; fnBody
        //         ($until cond                                                   ;; tail[1]
        //             ($clisp-let (tempsym1 ... tempsymN)                        ;;
        //                 expr1 ... exprN-1                                      ;; front
        //                 ($set tempsym1   rArgs1) ... ($set tempsymN   rArgsN)  ;; tail[4] ... [N+4]
        //                 ($set     sym1 tempsym1) ... ($set     symN tempsymN)  ;;
        //             )                                                          ;;
        //         )                                                              ;;
        //         expr1 ... exprN-1                                              ;; front
        //         t-expr                                                         ;; tail[2]
        //     )
        const varBaseName = `$__tempvar__$$ec${state.evalCount++}$$_`;
        const tempVarsSyms = formalArgs.map((a, idx) => ({
          symbol: `${varBaseName}_$i${idx}_${a.symbol}`
        }));
        return [[{
          symbol: state.config.reservedNames.until
        }, tail[1], [{
          symbol: state.config.reservedNames.let
        }, [...tempVarsSyms], ...front, ...tail[3].slice(1).map((x, idx) => [{
          symbol: state.config.reservedNames.set
        }, tempVarsSyms[idx], x]), ...tempVarsSyms.map((x, idx) => [{
          symbol: state.config.reservedNames.set
        }, formalArgs[idx], x])]], ...front, tail[2]];
      }
    }
  }

  return fnBody;
}
function evaluate(state, x) {
  (0,_errors__WEBPACK_IMPORTED_MODULE_0__.setEvaluationCount)(state);

  if (x === null || x === void 0) {
    return x;
  }

  let r = x;

  for (;;) {
    if (Array.isArray(r)) {
      if (r.length === 0) {
        return r;
      }

      r = resolveSplice(state, r);
      const sym = (0,_ast__WEBPACK_IMPORTED_MODULE_1__.isSymbol)(r[0]);

      if (sym) {
        const m = resolveMacro(state, sym, r);

        if (m) {
          r = m.fn(m.actualArgs);
        } else {
          break;
        }
      } else {
        break;
      }
    } else {
      break;
    }

    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.setEvaluationCount)(state);
  }

  if (Array.isArray(r)) {
    r = r.slice(0);

    if (0 < r.length) {
      const sym = (0,_ast__WEBPACK_IMPORTED_MODULE_1__.isSymbol)(r[0]);

      if (sym) {
        if (sym.symbol === state.config.reservedNames.quote) {
          return r.slice(1, 2)[0];
        }

        if (sym.symbol === state.config.reservedNames.backquote) {
          r = r.slice(1, 2)[0];

          if (Array.isArray(r)) {
            r = resolveUnquote(state, r);
          }

          return r;
        }

        if (sym.symbol === state.config.reservedNames.eval) {
          return evaluate(state, evaluate(state, r.slice(1, 2)[0]));
        }
      }

      const sprs = [];

      for (let i = 1; i < r.length; i++) {
        const symSpr = Array.isArray(r[i]) && (0,_ast__WEBPACK_IMPORTED_MODULE_1__.isSymbol)(r[i][0], state.config.reservedNames.spread);

        if (symSpr) {
          sprs.push(i);
          const a = evaluate(state, r[i][1]);
          r[i] = Array.isArray(a) ? a : [a];
        } else {
          r[i] = evaluate(state, r[i]);
        }
      }

      for (const i of sprs.reverse()) {
        r = r.slice(0, i).concat(r[i], r.slice(i + 1));
      }

      let fn;

      if (typeof r[0] === 'function') {
        fn = r[0];
      } else if (sym) {
        fn = resolveFunctionSymbol(state, sym);
      } else {
        fn = evaluate(state, r[0]);
      }

      if (typeof fn === 'function') {
        r = fn(...r.slice(1));
      } else {
        throw new Error(`[SX] evaluate: First item of list is not a function: ${JSON.stringify(r)}.`);
      }
    }
  } else if (state.config.wrapExternalValue && Object.prototype.hasOwnProperty.call(r, 'value')) {
    r = r.value;
  } else if (Object.prototype.hasOwnProperty.call(r, 'symbol')) {
    r = resolveValueSymbol(state, r);
  } else if (Object.prototype.hasOwnProperty.call(r, 'car')) {
    const car = evaluate(state, r.car);
    const cdr = evaluate(state, r.cdr);

    if (Array.isArray(cdr)) {
      const a = cdr.slice(0);
      a.unshift(car);
      r = a;
    } else {
      r = {
        car,
        cdr
      };
    }
  } else if (Object.prototype.hasOwnProperty.call(r, 'dotted')) {
    r = [evaluate(state, r.dotted)];
  } else if (Object.prototype.hasOwnProperty.call(r, 'comment')) {
    r = [];
  }

  return r;
}

/***/ }),

/***/ "./node_modules/liyad/modules/s-exp/global-this.js":
/*!*********************************************************!*\
  !*** ./node_modules/liyad/modules/s-exp/global-this.js ***!
  \*********************************************************/
/*! namespace exports */
/*! export dummyTargetObject [provided] [no usage info] [missing usage info prevents renaming] */
/*! export funConstructor [provided] [no usage info] [missing usage info prevents renaming] */
/*! export globalObj [provided] [no usage info] [missing usage info prevents renaming] */
/*! export objConstructor [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_require__.r, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "dummyTargetObject": () => /* binding */ dummyTargetObject,
/* harmony export */   "globalObj": () => /* binding */ globalObj,
/* harmony export */   "objConstructor": () => /* binding */ objConstructor,
/* harmony export */   "funConstructor": () => /* binding */ funConstructor
/* harmony export */ });
// Copyright (c) 2020 Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln
// tslint:disable: no-shadowed-variable
// tslint:disable: function-constructor
const dummyTargetObject = {}; // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment

const {
  g: globalObj,
  o: objConstructor,
  f: funConstructor
} = (() => {
  var _a, _b;

  let globalObj = null;

  try {
    // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment, @typescript-eslint/no-implied-eval
    globalObj = Function('return this')();
  } catch (e) {// Nothing to do.
  }

  if (!globalObj) {
    // Fall back (for CSP, etc...)
    if (typeof window === 'object' && window) {
      globalObj = window;
    } else if (typeof global === 'object' && global) {
      globalObj = global;
    } else if (typeof globalThis === 'object' && globalThis) {
      globalObj = globalThis;
    } else {
      globalObj = dummyTargetObject;
    }
  } // NOTE: ({}).constructor === Object
  // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment


  let objConstructor = null;

  try {
    // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
    objConstructor = (_a = {}.constructor) !== null && _a !== void 0 ? _a : Object;
  } catch (e) {// Nothing to do.
  }

  if (!objConstructor) {
    // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
    objConstructor = dummyTargetObject;
  } // NOTE: ({}).toString.constructor === Function
  // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment


  let funConstructor = null;

  try {
    // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
    funConstructor = (_b = {}.toString.constructor) !== null && _b !== void 0 ? _b : Function;
  } catch (e) {// Nothing to do.
  }

  if (!funConstructor) {
    // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
    funConstructor = dummyTargetObject;
  }

  return {
    // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
    g: globalObj,
    o: objConstructor,
    f: funConstructor
  };
})();

/***/ }),

/***/ "./node_modules/liyad/modules/s-exp/interpreters/index.js":
/*!****************************************************************!*\
  !*** ./node_modules/liyad/modules/s-exp/interpreters/index.js ***!
  \****************************************************************/
/*! namespace exports */
/*! export SExpression [provided] [no usage info] [missing usage info prevents renaming] */
/*! export SExpressionAsync [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_require__, __webpack_require__.r, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "SExpression": () => /* binding */ SExpression,
/* harmony export */   "SExpressionAsync": () => /* binding */ SExpressionAsync
/* harmony export */ });
/* harmony import */ var _parser__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../parser */ "./node_modules/liyad/modules/s-exp/parser.js");
/* harmony import */ var _evaluate__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../evaluate */ "./node_modules/liyad/modules/s-exp/evaluate.js");
/* harmony import */ var _defaults__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../defaults */ "./node_modules/liyad/modules/s-exp/defaults.js");
// Copyright (c) 2018, Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln
var __awaiter = undefined && undefined.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};





function initState(config, globals, strings, values) {
  return {
    strings: typeof strings === 'string' ? [strings] : strings,
    values: values || [],
    index: 0,
    pos: 0,
    line: 0,
    evalCount: 0,
    scopes: [{
      isBlockLocal: false,
      scope: globals
    }],
    macroMap: new Map(config.macros.map(x => [x.name, x])),
    funcMap: new Map(config.funcs.map(x => [x.name, x])),
    symbolMap: new Map(config.symbols.map(x => [x.name, x])),
    config
  };
}

function resetState(state, strings, values) {
  state.strings = typeof strings === 'string' ? [strings] : strings;
  state.values = values || [];
  state.index = 0;
  state.pos = 0;
  state.line = 0;
  state.evalCount = 0;
  return state;
}

function SExpression(conf) {
  let config = conf || Object.assign({}, _defaults__WEBPACK_IMPORTED_MODULE_2__.defaultConfig);
  let globalScope = {};
  let startup = [];

  const exec = (state, s) => {
    if (config.enableEvaluate) {
      for (let i = 0; i < s.length; i++) {
        s[i] = (0,_evaluate__WEBPACK_IMPORTED_MODULE_1__.evaluate)(state, s[i]);
      }
    }

    if (config.returnMultipleRoot) {
      return s.length === 1 ? s[0] : s;
    } else {
      return s[s.length - 1];
    }
  };

  const f = (strings, ...values) => {
    const state = initState(config, Object.assign({}, globalScope), strings, values);
    return exec(state, startup.concat((0,_parser__WEBPACK_IMPORTED_MODULE_0__.parse)(state)));
  };

  f.evaluateAST = ast => {
    const state = initState(config, Object.assign({}, globalScope), '');
    return exec(state, startup.concat(ast));
  };

  f.repl = () => {
    const state = initState(config, Object.assign({}, globalScope), '');
    exec(state, startup.slice(0));

    const fRepl = (strings, ...values) => {
      resetState(state, strings, values);
      return exec(state, (0,_parser__WEBPACK_IMPORTED_MODULE_0__.parse)(state));
    };

    fRepl.sync = fRepl;
    return fRepl;
  };

  f.setGlobals = globals => {
    globalScope = Object.assign({}, globals || {});
    return f;
  };

  f.appendGlobals = globals => {
    globalScope = Object.assign({}, globalScope, globals || {});
    return f;
  };

  f.setStartup = (strings, ...values) => {
    const state = initState(config, Object.assign({}, globalScope), strings, values);
    startup = (0,_parser__WEBPACK_IMPORTED_MODULE_0__.parse)(state);
    return f;
  };

  f.setStartupAST = ast => {
    startup = ast;
    return f;
  };

  f.appendStartup = (strings, ...values) => {
    const state = initState(config, Object.assign({}, globalScope), strings, values);
    startup = startup.concat((0,_parser__WEBPACK_IMPORTED_MODULE_0__.parse)(state));
    return f;
  };

  f.appendStartupAST = ast => {
    startup = startup.concat(ast);
    return f;
  };

  f.install = installer => {
    config = installer(config);
    return f;
  };

  return f;
}
function SExpressionAsync(conf) {
  let config = conf || Object.assign({}, _defaults__WEBPACK_IMPORTED_MODULE_2__.defaultConfig);
  let globalScope = {};
  let startup = [];

  const exec = (state, s) => __awaiter(this, void 0, void 0, function* () {
    if (config.enableEvaluate) {
      for (let i = 0; i < s.length; i++) {
        s[i] = (0,_evaluate__WEBPACK_IMPORTED_MODULE_1__.evaluate)(state, s[i]);

        if (typeof s[i] === 'object' && s[i] !== null && typeof s[i].then === 'function') {
          s[i] = yield s[i];
        }
      }
    }

    if (config.returnMultipleRoot) {
      return s.length === 1 ? s[0] : s;
    } else {
      return s[s.length - 1];
    }
  });

  const f = (strings, ...values) => __awaiter(this, void 0, void 0, function* () {
    const state = initState(config, Object.assign({}, globalScope), strings, values);
    return exec(state, startup.concat((0,_parser__WEBPACK_IMPORTED_MODULE_0__.parse)(state)));
  });

  f.evaluateAST = ast => {
    const state = initState(config, Object.assign({}, globalScope), '');
    return exec(state, startup.concat(ast));
  };

  f.repl = () => {
    const execSync = (stat, s) => {
      if (config.enableEvaluate) {
        for (let i = 0; i < s.length; i++) {
          s[i] = (0,_evaluate__WEBPACK_IMPORTED_MODULE_1__.evaluate)(stat, s[i]);
        }
      }

      if (config.returnMultipleRoot) {
        return s.length === 1 ? s[0] : s;
      } else {
        return s[s.length - 1];
      }
    };

    const state = initState(config, Object.assign({}, globalScope), '');
    exec(state, startup.slice(0));

    const fRepl = (strings, ...values) => __awaiter(this, void 0, void 0, function* () {
      resetState(state, strings, values);
      return exec(state, (0,_parser__WEBPACK_IMPORTED_MODULE_0__.parse)(state));
    });

    const fReplSync = (strings, ...values) => {
      resetState(state, strings, values);
      return execSync(state, (0,_parser__WEBPACK_IMPORTED_MODULE_0__.parse)(state));
    };

    fRepl.sync = fReplSync;
    return fRepl;
  };

  f.setGlobals = globals => {
    globalScope = Object.assign({}, globals || {});
    return f;
  };

  f.appendGlobals = globals => {
    globalScope = Object.assign({}, globalScope, globals || {});
    return f;
  };

  f.setStartup = (strings, ...values) => {
    const state = initState(config, Object.assign({}, globalScope), strings, values);
    startup = (0,_parser__WEBPACK_IMPORTED_MODULE_0__.parse)(state);
    return f;
  };

  f.setStartupAST = ast => {
    startup = ast;
    return f;
  };

  f.appendStartup = (strings, ...values) => {
    const state = initState(config, Object.assign({}, globalScope), strings, values);
    startup = startup.concat((0,_parser__WEBPACK_IMPORTED_MODULE_0__.parse)(state));
    return f;
  };

  f.appendStartupAST = ast => {
    startup = startup.concat(ast);
    return f;
  };

  f.install = installer => {
    config = installer(config);
    return f;
  };

  return f;
}

/***/ }),

/***/ "./node_modules/liyad/modules/s-exp/operators/core/core.fn.js":
/*!********************************************************************!*\
  !*** ./node_modules/liyad/modules/s-exp/operators/core/core.fn.js ***!
  \********************************************************************/
/*! namespace exports */
/*! export $$__and [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$__or [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$ambiguousEq [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$ambiguousNotEq [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$apply [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$atom [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$boolean [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$car [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$cdr [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$cons [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$consoleError [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$consoleLog [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$consoleTime [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$consoleTimeEnd [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$consoleTimeLog [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$consoleTrace [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$datetime [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$datetimeFromIso [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$datetimeLc [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$datetimeToComponents [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$datetimeToComponentsLc [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$datetimeToIsoString [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$eq [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$first [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$firstAndSecond [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$ge [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$gt [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$isFinite [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$isInteger [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$isList [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$isNaN [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$isNil [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$isNull [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$isNumber [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$isString [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$isSymbol [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$isUndefined [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$jsonParse [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$jsonStringify [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$last [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$le [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$list [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$lt [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$match [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$not [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$notEq [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$now [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$objectAssign [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$pipe [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$raise [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$rest [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$second [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$symbol [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$toNumber [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$toString [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $$typeof [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $__and [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $__call [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $__capture [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $__cond [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $__defmacro [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $__defun [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $__doUntil [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $__doWhile [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $__for [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $__gensym [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $__get [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $__globalScope [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $__if [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $__ifNull [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $__lambda [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $__let [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $__or [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $__refun [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $__repeat [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $__scope [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $__set [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $__toObject [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $__try [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $__until [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $__while [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $ambiguousEq [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $ambiguousNotEq [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $apply [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $atom [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $boolean [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $car [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $cdr [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $comp$__defun [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $comp$__lambda [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $cons [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $consoleError [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $consoleLog [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $consoleTime [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $consoleTimeEnd [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $consoleTimeLog [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $consoleTrace [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $datetime [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $datetimeFromIso [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $datetimeLc [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $datetimeToComponents [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $datetimeToComponentsLc [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $datetimeToIsoString [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $eq [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $first [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $firstAndSecond [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $ge [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $gt [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $isFinite [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $isInteger [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $isList [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $isNaN [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $isNil [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $isNull [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $isNumber [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $isString [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $isSymbol [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $isUndefined [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $jsonParse [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $jsonStringify [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $last [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $le [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $list [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $lt [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $match [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $not [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $notEq [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $now [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $objectAssign [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $pipe [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $raise [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $rest [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $second [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $symbol [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $toNumber [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $toString [provided] [no usage info] [missing usage info prevents renaming] */
/*! export $typeof [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_require__, __webpack_require__.r, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "$car": () => /* binding */ $car,
/* harmony export */   "$$car": () => /* binding */ $$car,
/* harmony export */   "$cdr": () => /* binding */ $cdr,
/* harmony export */   "$$cdr": () => /* binding */ $$cdr,
/* harmony export */   "$cons": () => /* binding */ $cons,
/* harmony export */   "$$cons": () => /* binding */ $$cons,
/* harmony export */   "$first": () => /* binding */ $first,
/* harmony export */   "$$first": () => /* binding */ $$first,
/* harmony export */   "$second": () => /* binding */ $second,
/* harmony export */   "$$second": () => /* binding */ $$second,
/* harmony export */   "$last": () => /* binding */ $last,
/* harmony export */   "$$last": () => /* binding */ $$last,
/* harmony export */   "$rest": () => /* binding */ $rest,
/* harmony export */   "$$rest": () => /* binding */ $$rest,
/* harmony export */   "$firstAndSecond": () => /* binding */ $firstAndSecond,
/* harmony export */   "$$firstAndSecond": () => /* binding */ $$firstAndSecond,
/* harmony export */   "$atom": () => /* binding */ $atom,
/* harmony export */   "$$atom": () => /* binding */ $$atom,
/* harmony export */   "$eq": () => /* binding */ $eq,
/* harmony export */   "$$eq": () => /* binding */ $$eq,
/* harmony export */   "$notEq": () => /* binding */ $notEq,
/* harmony export */   "$$notEq": () => /* binding */ $$notEq,
/* harmony export */   "$list": () => /* binding */ $list,
/* harmony export */   "$$list": () => /* binding */ $$list,
/* harmony export */   "$__scope": () => /* binding */ $__scope,
/* harmony export */   "$__globalScope": () => /* binding */ $__globalScope,
/* harmony export */   "$__capture": () => /* binding */ $__capture,
/* harmony export */   "$__lambda": () => /* binding */ $__lambda,
/* harmony export */   "$comp$__lambda": () => /* binding */ $comp$__lambda,
/* harmony export */   "$__defun": () => /* binding */ $__defun,
/* harmony export */   "$comp$__defun": () => /* binding */ $comp$__defun,
/* harmony export */   "$__refun": () => /* binding */ $__refun,
/* harmony export */   "$__defmacro": () => /* binding */ $__defmacro,
/* harmony export */   "$apply": () => /* binding */ $apply,
/* harmony export */   "$$apply": () => /* binding */ $$apply,
/* harmony export */   "$__call": () => /* binding */ $__call,
/* harmony export */   "$__try": () => /* binding */ $__try,
/* harmony export */   "$raise": () => /* binding */ $raise,
/* harmony export */   "$$raise": () => /* binding */ $$raise,
/* harmony export */   "$__if": () => /* binding */ $__if,
/* harmony export */   "$__ifNull": () => /* binding */ $__ifNull,
/* harmony export */   "$__cond": () => /* binding */ $__cond,
/* harmony export */   "$__while": () => /* binding */ $__while,
/* harmony export */   "$__doWhile": () => /* binding */ $__doWhile,
/* harmony export */   "$__until": () => /* binding */ $__until,
/* harmony export */   "$__doUntil": () => /* binding */ $__doUntil,
/* harmony export */   "$__repeat": () => /* binding */ $__repeat,
/* harmony export */   "$__for": () => /* binding */ $__for,
/* harmony export */   "$pipe": () => /* binding */ $pipe,
/* harmony export */   "$$pipe": () => /* binding */ $$pipe,
/* harmony export */   "$__get": () => /* binding */ $__get,
/* harmony export */   "$__let": () => /* binding */ $__let,
/* harmony export */   "$__set": () => /* binding */ $__set,
/* harmony export */   "$boolean": () => /* binding */ $boolean,
/* harmony export */   "$$boolean": () => /* binding */ $$boolean,
/* harmony export */   "$not": () => /* binding */ $not,
/* harmony export */   "$$not": () => /* binding */ $$not,
/* harmony export */   "$__and": () => /* binding */ $__and,
/* harmony export */   "$$__and": () => /* binding */ $$__and,
/* harmony export */   "$__or": () => /* binding */ $__or,
/* harmony export */   "$$__or": () => /* binding */ $$__or,
/* harmony export */   "$ambiguousEq": () => /* binding */ $ambiguousEq,
/* harmony export */   "$$ambiguousEq": () => /* binding */ $$ambiguousEq,
/* harmony export */   "$ambiguousNotEq": () => /* binding */ $ambiguousNotEq,
/* harmony export */   "$$ambiguousNotEq": () => /* binding */ $$ambiguousNotEq,
/* harmony export */   "$lt": () => /* binding */ $lt,
/* harmony export */   "$$lt": () => /* binding */ $$lt,
/* harmony export */   "$le": () => /* binding */ $le,
/* harmony export */   "$$le": () => /* binding */ $$le,
/* harmony export */   "$gt": () => /* binding */ $gt,
/* harmony export */   "$$gt": () => /* binding */ $$gt,
/* harmony export */   "$ge": () => /* binding */ $ge,
/* harmony export */   "$$ge": () => /* binding */ $$ge,
/* harmony export */   "$typeof": () => /* binding */ $typeof,
/* harmony export */   "$$typeof": () => /* binding */ $$typeof,
/* harmony export */   "$symbol": () => /* binding */ $symbol,
/* harmony export */   "$$symbol": () => /* binding */ $$symbol,
/* harmony export */   "$__gensym": () => /* binding */ $__gensym,
/* harmony export */   "$isSymbol": () => /* binding */ $isSymbol,
/* harmony export */   "$$isSymbol": () => /* binding */ $$isSymbol,
/* harmony export */   "$isNull": () => /* binding */ $isNull,
/* harmony export */   "$$isNull": () => /* binding */ $$isNull,
/* harmony export */   "$isNil": () => /* binding */ $isNil,
/* harmony export */   "$$isNil": () => /* binding */ $$isNil,
/* harmony export */   "$isUndefined": () => /* binding */ $isUndefined,
/* harmony export */   "$$isUndefined": () => /* binding */ $$isUndefined,
/* harmony export */   "$isList": () => /* binding */ $isList,
/* harmony export */   "$$isList": () => /* binding */ $$isList,
/* harmony export */   "$isString": () => /* binding */ $isString,
/* harmony export */   "$$isString": () => /* binding */ $$isString,
/* harmony export */   "$isNumber": () => /* binding */ $isNumber,
/* harmony export */   "$$isNumber": () => /* binding */ $$isNumber,
/* harmony export */   "$isNaN": () => /* binding */ $isNaN,
/* harmony export */   "$$isNaN": () => /* binding */ $$isNaN,
/* harmony export */   "$isFinite": () => /* binding */ $isFinite,
/* harmony export */   "$$isFinite": () => /* binding */ $$isFinite,
/* harmony export */   "$isInteger": () => /* binding */ $isInteger,
/* harmony export */   "$$isInteger": () => /* binding */ $$isInteger,
/* harmony export */   "$toString": () => /* binding */ $toString,
/* harmony export */   "$$toString": () => /* binding */ $$toString,
/* harmony export */   "$toNumber": () => /* binding */ $toNumber,
/* harmony export */   "$$toNumber": () => /* binding */ $$toNumber,
/* harmony export */   "$__toObject": () => /* binding */ $__toObject,
/* harmony export */   "$objectAssign": () => /* binding */ $objectAssign,
/* harmony export */   "$$objectAssign": () => /* binding */ $$objectAssign,
/* harmony export */   "$jsonStringify": () => /* binding */ $jsonStringify,
/* harmony export */   "$$jsonStringify": () => /* binding */ $$jsonStringify,
/* harmony export */   "$jsonParse": () => /* binding */ $jsonParse,
/* harmony export */   "$$jsonParse": () => /* binding */ $$jsonParse,
/* harmony export */   "$now": () => /* binding */ $now,
/* harmony export */   "$$now": () => /* binding */ $$now,
/* harmony export */   "$datetimeFromIso": () => /* binding */ $datetimeFromIso,
/* harmony export */   "$$datetimeFromIso": () => /* binding */ $$datetimeFromIso,
/* harmony export */   "$datetime": () => /* binding */ $datetime,
/* harmony export */   "$$datetime": () => /* binding */ $$datetime,
/* harmony export */   "$datetimeLc": () => /* binding */ $datetimeLc,
/* harmony export */   "$$datetimeLc": () => /* binding */ $$datetimeLc,
/* harmony export */   "$datetimeToIsoString": () => /* binding */ $datetimeToIsoString,
/* harmony export */   "$$datetimeToIsoString": () => /* binding */ $$datetimeToIsoString,
/* harmony export */   "$datetimeToComponents": () => /* binding */ $datetimeToComponents,
/* harmony export */   "$$datetimeToComponents": () => /* binding */ $$datetimeToComponents,
/* harmony export */   "$datetimeToComponentsLc": () => /* binding */ $datetimeToComponentsLc,
/* harmony export */   "$$datetimeToComponentsLc": () => /* binding */ $$datetimeToComponentsLc,
/* harmony export */   "$match": () => /* binding */ $match,
/* harmony export */   "$$match": () => /* binding */ $$match,
/* harmony export */   "$consoleLog": () => /* binding */ $consoleLog,
/* harmony export */   "$$consoleLog": () => /* binding */ $$consoleLog,
/* harmony export */   "$consoleError": () => /* binding */ $consoleError,
/* harmony export */   "$$consoleError": () => /* binding */ $$consoleError,
/* harmony export */   "$consoleTrace": () => /* binding */ $consoleTrace,
/* harmony export */   "$$consoleTrace": () => /* binding */ $$consoleTrace,
/* harmony export */   "$consoleTime": () => /* binding */ $consoleTime,
/* harmony export */   "$$consoleTime": () => /* binding */ $$consoleTime,
/* harmony export */   "$consoleTimeEnd": () => /* binding */ $consoleTimeEnd,
/* harmony export */   "$$consoleTimeEnd": () => /* binding */ $$consoleTimeEnd,
/* harmony export */   "$consoleTimeLog": () => /* binding */ $consoleTimeLog,
/* harmony export */   "$$consoleTimeLog": () => /* binding */ $$consoleTimeLog
/* harmony export */ });
/* harmony import */ var _types__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../../types */ "./node_modules/liyad/modules/s-exp/types.js");
/* harmony import */ var _global_this__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../../global-this */ "./node_modules/liyad/modules/s-exp/global-this.js");
/* harmony import */ var _ast__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../../ast */ "./node_modules/liyad/modules/s-exp/ast.js");
/* harmony import */ var _evaluate__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../../evaluate */ "./node_modules/liyad/modules/s-exp/evaluate.js");
/* harmony import */ var _compile__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../../compile */ "./node_modules/liyad/modules/s-exp/compile.js");
/* harmony import */ var _errors__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../../errors */ "./node_modules/liyad/modules/s-exp/errors.js");
// Copyright (c) 2018, Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln






const $car = (state, name) => (...args) => {
  // S expression: ($car '(first second ... last))
  //  -> S expr  : first
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$car', args, 1, 1);
  const car = $$first(...args);

  if (!Array.isArray(car)) {
    throw new Error(`[SX] $car: Invalid argument(s): args[0] is not array.`);
  }

  if (car.length === 0) {
    throw new Error(`[SX] $car: Invalid argument(s): args[0] is nil.`);
  }

  return car[0];
};
const $$car = $car(null, null);
const $cdr = (state, name) => (...args) => {
  // S expression: ($cdr '(first second ... last))
  //  -> S expr  : (second ... last)
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$cdr', args, 1, 1);
  const car = $$first(...args);

  if (!Array.isArray(car)) {
    throw new Error(`[SX] $cdr: Invalid argument(s): args[0] is not array.`);
  }

  if (car.length === 0) {
    throw new Error(`[SX] $cdr: Invalid argument(s): args[0] is nil.`);
  }

  return car.slice(1);
};
const $$cdr = $cdr(null, null);
const $cons = (state, name) => (...args) => {
  // S expression: ($cons arg1 '(arg2-item1 ...) ... argN)
  //  -> S expr  : (arg1 arg2-item1 ...)
  // S expression: ($cons arg1 nilOrNull ... argN)
  //  -> S expr  : (arg1)
  // S expression: ($cons arg1 arg2 ... argN)
  //  -> S expr  : arg1.arg2
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$cons', args, 2, 2);
  let {
    car,
    cdr
  } = $$firstAndSecond(...args);

  if (car === null) {
    car = [];
  }

  if (cdr === null) {
    cdr = [];
  }

  if (Array.isArray(cdr)) {
    cdr = cdr.slice(0);
    cdr.unshift(car);
    return cdr;
  } else {
    return {
      car,
      cdr
    };
  }
};
const $$cons = $cons(null, null);
const $first = (state, name) => (...args) => {
  // S expression: ($first first second ... last)
  //  -> S expr  : first
  // S expression: ($first)
  //  -> S expr  : null
  const car = args.slice(0, 1);
  return car.length === 1 ? car[0] : null;
};
const $$first = $first(null, null);
const $second = (state, name) => (...args) => {
  // S expression: ($second first second ... last)
  //  -> S expr  : second
  // S expression: ($second first)
  //  -> S expr  : null
  const cdr = args.slice(1, 2);
  return cdr.length === 1 ? cdr[0] : null;
};
const $$second = $second(null, null);
const $last = (state, name) => (...args) => {
  // S expression: ($last first second ... last)
  //  -> S expr  : last
  // S expression: ($last)
  //  -> S expr  : null
  const car = args.slice(args.length - 1, args.length);
  return car.length === 1 ? car[0] : null;
};
const $$last = $last(null, null);
const $rest = (state, name) => (...args) => {
  // S expression: ($rest first second ... last)
  //  -> S expr  : (second ... last)
  // S expression: ($rest first)
  //  -> S expr  : null
  const cdr = args.slice(1);
  return 0 < cdr.length ? cdr : null;
};
const $$rest = $rest(null, null);
const $firstAndSecond = (state, name) => (...args) => {
  // S expression: ($first-and-second first second ... last)
  //  -> S expr  : first.second
  let car = args.slice(0, 1);
  car = car.length === 1 ? car[0] : null;
  let cdr = args.slice(1, 2);
  cdr = cdr.length === 1 ? cdr[0] : null;
  return {
    car,
    cdr
  };
};
const $$firstAndSecond = $firstAndSecond(null, null);
const $atom = (state, name) => (...args) => {
  // S expression: ($atom arg1 ...)
  //  -> (if arg1 is list or dotted pair)  S expr  : false
  //  -> (if arg1 is nil or anything else) S expr  : true
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$atom', args, 1, 1);
  const car = $$first(...args);

  if (car === null || car === void 0) {
    return true;
  }

  if (Array.isArray(car)) {
    if (car.length === 0) return true;else return false;
  }

  switch (typeof car) {
    case 'number':
    case 'string':
    case 'function':
    case 'boolean':
      return true;

    case 'object':
      return (0,_ast__WEBPACK_IMPORTED_MODULE_5__.isSymbol)(car) ? true : false;
  }

  return false;
};
const $$atom = $atom(null, null);
const $eq = (state, name) => (...args) => {
  // S expression: ($eq arg1 arg2)
  //  -> (if arg1 === arg2)  S expr  : true
  //  -> (else)              S expr  : false
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$eq', args, 2, 2);
  const {
    car,
    cdr
  } = $$firstAndSecond(...args);
  return car === cdr;
};
const $$eq = $eq(null, null);
const $notEq = (state, name) => (...args) => {
  // S expression: ($not-eq arg1 arg2)
  //  -> (if arg1 !== arg2)  S expr  : true
  //  -> (else)              S expr  : false
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$notEq', args, 2, 2);
  const {
    car,
    cdr
  } = $$firstAndSecond(...args);
  return car !== cdr;
};
const $$notEq = $notEq(null, null);
const $list = (state, name) => (...args) => // S expression: ($list arg1 ... argN)
//  -> S expr  : (arg1 ... argN)
args.slice(0);
const $$list = $list(null, null); // tslint:disable-next-line:variable-name

const $__scope = (state, name, capturedScopes) => (...args) => {
  // S expression: ($__scope isBlockLocal returnMultiple '((name value) | name ...) 'expr1 ... 'exprN)
  //  -> (if returnMultiple)  S expr  : [expr1 ... exprN]
  //  -> (else)               S expr  : exprN
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$__scope', args, 3);
  const isBlockLocal = $$first(...args);
  const returnMultiple = $$second(...args);
  const {
    car,
    cdr
  } = $$firstAndSecond(...args.slice(2));
  let r = null;
  const scope = {};

  if (Array.isArray(car)) {
    for (const x of car) {
      if (Array.isArray(x)) {
        const kv = $$firstAndSecond(...x);
        const kvSym = (0,_ast__WEBPACK_IMPORTED_MODULE_5__.isSymbol)(kv.car);
        const kvName = kvSym ? kvSym.symbol : String(kv.car);
        (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkUnsafeVarNamesEx)('$__scope', scope, kvName);
        scope[kvName] = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, kv.cdr);
      } else {
        const xSym = (0,_ast__WEBPACK_IMPORTED_MODULE_5__.isSymbol)(x);
        const xName = xSym ? xSym.symbol : String(x);
        (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkUnsafeVarNamesEx)('$__scope', scope, xName);
        scope[xName] = null;
      }
    }
  }

  (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.installScope)(state, scope, isBlockLocal, capturedScopes);

  try {
    if (4 < args.length) {
      if (returnMultiple) {
        r = [];

        for (const x of args.slice(3)) {
          r.push((0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, x));
        }
      } else {
        for (const x of args.slice(3)) {
          r = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, x);
        }
      }
    } else {
      r = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, cdr);
    }
  } finally {
    (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.uninstallScope)(state);
  }

  return r;
}; // tslint:disable-next-line:variable-name

const $__globalScope = (state, name) => (...args) => {
  // S expression: ($__global returnMultiple 'expr1 ... 'exprN)
  //  -> (if returnMultiple)  S expr  : [expr1 ... exprN]
  //  -> (else)               S expr  : exprN
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$__globalScope', args, 1);
  const returnMultiple = $$first(...args);
  const cdr = $$second(...args);
  let r = null;
  (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.installScope)(state, (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.getGlobalScope)(state).scope, true);

  try {
    if (2 < args.length) {
      if (returnMultiple) {
        r = [];

        for (const x of args.slice(1)) {
          r.push((0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, x));
        }
      } else {
        for (const x of args.slice(1)) {
          r = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, x);
        }
      }
    } else {
      r = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, cdr);
    }
  } finally {
    (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.uninstallScope)(state);
  }

  return r;
}; // tslint:disable-next-line:variable-name

const $__capture = (state, name) => (...args) => {
  // S expression: ($__capture '(sym1 ... symN) 'expr1 ... 'exprN)
  //  -> S expr  : exprN
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$__capture', args, 1);
  const formalArgs = args[0];

  if (!Array.isArray(formalArgs)) {
    throw new Error(`[SX] $__lambda: Invalid argument(s): args[0] is not array.`);
  }

  let r = null;
  const capturedScopes = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.collectCapturedVariables)(state, formalArgs);
  (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.installScope)(state, {}, true, capturedScopes);

  try {
    for (const x of args.slice(1)) {
      r = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, x);
    }
  } finally {
    (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.uninstallScope)(state);
  }

  return r;
}; // tslint:disable-next-line:variable-name

const $__lambda = (state, name) => (...args) => {
  // S expression: ($__lambda '(sym1 ... symN) 'expr1 ... 'exprN)
  //  -> S expr  : fn
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$__lambda', args, 2);
  const formalArgs = args[0];

  if (!Array.isArray(formalArgs)) {
    throw new Error(`[SX] $__lambda: Invalid argument(s): args[0] is not array.`);
  }

  let lastIsSpread = false;

  for (let i = 0; i < formalArgs.length; i++) {
    const fa = formalArgs[i];

    if (i === formalArgs.length - 1 && state.config.enableSpread && Array.isArray(fa) && (0,_ast__WEBPACK_IMPORTED_MODULE_5__.isSymbol)(fa[0], state.config.reservedNames.spread)) {
      if (!(0,_ast__WEBPACK_IMPORTED_MODULE_5__.isSymbol)(fa[1])) {
        throw new Error(`[SX] $__lambda: Invalid formal argument(s): item(s) of args[${i}] is not symbol.`);
      }

      formalArgs[i] = fa[1];
      lastIsSpread = true;
    } else if (!(0,_ast__WEBPACK_IMPORTED_MODULE_5__.isSymbol)(fa)) {
      throw new Error(`[SX] $__lambda: Invalid formal argument(s): item(s) of args[${i}] is not symbol.`);
    }
  }

  let fnBody = args.slice(1);

  if (state.config.enableTailCallOptimization) {
    fnBody = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.optimizeTailCall)(state, formalArgs, fnBody);
  }

  const capturedScopes = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.getCapturedScopes)(state);

  const fn = function (...actualArgs) {
    if (actualArgs.length + (lastIsSpread ? 1 : 0) < formalArgs.length) {
      throw new Error(`[SX] func call: Actual args too short: actual ${actualArgs.length} / formal ${formalArgs.length}.`);
    } // TODO: add type checking


    return $__scope(state, name, capturedScopes)(false, false, [[state.config.reservedNames.self, fn], [state.config.reservedNames.thiz, this === _global_this__WEBPACK_IMPORTED_MODULE_1__.globalObj || this === void 0 ? null : (0,_ast__WEBPACK_IMPORTED_MODULE_5__.quote)(state, this)], ...formalArgs.map((x, index) => [x.symbol, (0,_ast__WEBPACK_IMPORTED_MODULE_5__.quote)(state, lastIsSpread && index === formalArgs.length - 1 ? actualArgs.slice(index) : actualArgs[index])])], ...fnBody);
  };

  return fn;
}; // tslint:disable-next-line:variable-name

const $comp$__lambda = (state, name) => (...args) => {
  // S expression: ($__lambda '(sym1 ... symN) 'expr1 ... 'exprN)
  //  -> S expr  : fn
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$$__lambda', args, 2);
  const formalArgs = args[0];

  if (!Array.isArray(formalArgs)) {
    throw new Error(`[SX] $$__lambda: Invalid argument(s): args[0] is not array.`);
  }

  let lastIsSpread = false;

  for (let i = 0; i < formalArgs.length; i++) {
    const fa = formalArgs[i];

    if (i === formalArgs.length - 1 && state.config.enableSpread && Array.isArray(fa) && (0,_ast__WEBPACK_IMPORTED_MODULE_5__.isSymbol)(fa[0], state.config.reservedNames.spread)) {
      if (!(0,_ast__WEBPACK_IMPORTED_MODULE_5__.isSymbol)(fa[1])) {
        throw new Error(`[SX] $$__lambda: Invalid formal argument(s): item(s) of args[${i}] is not symbol.`);
      }

      formalArgs[i] = fa[1];
      lastIsSpread = true;
    } else if (!(0,_ast__WEBPACK_IMPORTED_MODULE_5__.isSymbol)(fa)) {
      throw new Error(`[SX] $$__lambda: Invalid formal argument(s): item(s) of args[${i}] is not symbol.`);
    }
  }

  const fnBody = args.slice(1);
  return (0,_compile__WEBPACK_IMPORTED_MODULE_3__.compileLambda)(state, formalArgs, lastIsSpread, fnBody);
}; // tslint:disable-next-line:variable-name

const $__defun = (state, name) => (...args) => {
  // S expression: ($__defun 'name '(sym1 ... symN) 'expr ... 'expr)
  //  -> S expr  : fn
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$__defun', args, 3);
  const car = $$first(...args);
  const fn = $__lambda(state, name)(...args.slice(1));
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkUnsafeVarNamesEx)('$__defun', state.funcMap, car.symbol); // TODO: overloading

  state.funcMap.set(car.symbol, {
    name: car.symbol,
    fn: (st, nm) => fn
  });
  return fn;
}; // tslint:disable-next-line:variable-name

const $comp$__defun = (state, name) => (...args) => {
  // S expression: ($__defun 'name '(sym1 ... symN) 'expr ... 'expr)
  //  -> S expr  : fn
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$$__defun', args, 3);
  const car = $$first(...args);
  const fn = $comp$__lambda(state, name)(...args.slice(1));
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkUnsafeVarNamesEx)('$$__defun', state.funcMap, car.symbol); // TODO: overloading

  state.funcMap.set(car.symbol, {
    name: car.symbol,
    fn: (st, nm) => fn
  });
  return fn;
}; // tslint:disable-next-line:variable-name

const $__refun = (state, name) => (...args) => {
  // S expression: ($refun 'name)
  //  -> S expr  : fn
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$__refun', args, 1, 1);
  const car = $$first(...args);
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkUnsafeVarNamesEx)('$__refun', state.funcMap, car.symbol);
  const info = state.funcMap.get(car.symbol);

  if (!info) {
    throw new Error(`[SX] $__refun: function ${car.symbol} is not defined.`);
  }

  return info.fn(state, car.symbol);
}; // tslint:disable-next-line:variable-name

const $__defmacro = (state, name) => (...args) => {
  // S expression: ($__defmacro 'name '(sym1 ... symN) 'expr ... 'expr)
  //  -> S expr  : fn
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$__defmacro', args, 3);
  const car = $$first(...args);
  const formalArgs = args[1];

  if (!Array.isArray(formalArgs)) {
    throw new Error(`[SX] $__defmacro: Invalid argument(s): args[1] is not array.`);
  }

  let lastIsSpread = false;

  for (let i = 0; i < formalArgs.length; i++) {
    const fa = formalArgs[i];

    if (i === formalArgs.length - 1 && state.config.enableSpread && Array.isArray(fa) && (0,_ast__WEBPACK_IMPORTED_MODULE_5__.isSymbol)(fa[0], state.config.reservedNames.spread)) {
      if (!(0,_ast__WEBPACK_IMPORTED_MODULE_5__.isSymbol)(fa[1])) {
        throw new Error(`[SX] $__defmacro: Invalid formal argument(s): item(s) of args[${i}] is not symbol.`);
      }

      formalArgs[i] = fa[1];
      lastIsSpread = true;
    } else if (!(0,_ast__WEBPACK_IMPORTED_MODULE_5__.isSymbol)(fa)) {
      throw new Error(`[SX] $__defmacro: Invalid formal argument(s): item(s) of args[${i}] is not symbol.`);
    }
  }

  const fnBody = args.slice(2);
  const capturedScopes = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.getCapturedScopes)(state);

  const fn = fArgs => (...aArgs) => {
    return $__scope(state, name, capturedScopes)(false, false, [[state.config.reservedNames.self, fn], ...fArgs.map((x, index) => [x.symbol, (0,_ast__WEBPACK_IMPORTED_MODULE_5__.quote)(state, lastIsSpread && index === fArgs.length - 1 ? aArgs.slice(index) : aArgs[index])])], ...fnBody);
  };

  const m = {
    name: car.symbol,
    fn: (st, nm, fArgs) => list => fn(fArgs)(...list.slice(1)),
    formalArgs,
    lastIsSpread
  };
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkUnsafeVarNamesEx)('$__defmacro', state.macroMap, car.symbol);

  if (state.macroMap.has(car.symbol)) {
    let curr = state.macroMap.get(car.symbol);
    curr.next = m;

    if (curr && curr.formalArgs) {
      if (curr.formalArgs.length < formalArgs.length) {
        state.macroMap.set(car.symbol, m);
        m.next = curr;
      } else {
        let prev = curr;
        curr = curr.next;

        while (curr) {
          if (curr.formalArgs) {
            if (curr.formalArgs.length < formalArgs.length) {
              prev.next = m;
              m.next = curr;
              break;
            }
          }

          prev = curr;
          curr = curr.next;
        }
      }
    }
  } else {
    state.macroMap.set(car.symbol, m);
  }

  return fn;
};
const $apply = (state, name) => (...args) => {
  // S expression: ($apply fn arg1 ... argN)
  //  -> S expr  : fn'
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$apply', args, 1);
  const car = $$first(...args);

  if (typeof car !== 'function') {
    throw new Error(`[SX] $apply: Invalid argument(s): args[0] is not function.`);
  }

  return (...p) => car.apply(null, args.slice(1).concat(p));
};
const $$apply = $apply(null, null); // tslint:disable-next-line:variable-name

const $__call = (state, name) => (...args) => {
  // S expression: ($__call thisArg 'symbol arg1 ... argN)
  //  -> S expr  : fn
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$__call', args, 2);
  const {
    car,
    cdr
  } = $$firstAndSecond(...args);
  const sym = (0,_ast__WEBPACK_IMPORTED_MODULE_5__.isSymbol)(cdr);
  const xName = sym ? sym.symbol : (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, cdr);
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkUnsafeVarNamesEx)('$__call', car, xName);
  return Function.prototype.apply.call(car[xName], car, args.slice(2));
}; // tslint:disable-next-line:variable-name

const $__try = (state, name) => (...args) => {
  // S expression: ($__try 'expr 'catch-expr)
  //  ->                               S expr  : expr
  //  -> (if error is raised in expr)  S expr  : catch-expr
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$__try', args, 1, 2);
  let r = [];

  try {
    r = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, args[0]);
  } catch (e) {
    if (e instanceof _types__WEBPACK_IMPORTED_MODULE_0__.FatalError) {
      throw e;
    }

    if (1 < args.length) {
      r = $__scope(state, name)(true, false, [['$error', (0,_ast__WEBPACK_IMPORTED_MODULE_5__.quote)(state, e)], ['$parent', (0,_ast__WEBPACK_IMPORTED_MODULE_5__.quote)(state, (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.getScope)(state))]], args[1]);
    } else {
      r = null;
    }
  }

  return r;
};
const $raise = (state, name) => (...args) => {
  // S expression: ($raise 'expr)
  //  -> S expr  : -
  const car = $$first(...args);
  throw car;
};
const $$raise = $raise(null, null); // tslint:disable-next-line:variable-name

const $__if = (state, name) => (...args) => {
  // S expression: ($__if condition 't-expr 'f-expr)
  //  -> (if condition is true ) S expr  : t-expr
  //  -> (if condition is false) S expr  : f-expr
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$__if', args, 2, 3);
  const car = $$first(...args);
  let r = [];

  if ($$boolean(car)) {
    r = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, args[1]);
  } else {
    if (2 < args.length) {
      r = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, args[2]);
    } else {
      r = null;
    }
  }

  return r;
}; // tslint:disable-next-line:variable-name

const $__ifNull = (state, name) => (...args) => {
  // S expression: ($__if-null condition 'null-expr)
  //  -> (if condition is not null ) S expr  : condition
  //  -> (if condition is null)      S expr  : null-expr
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$__ifNull', args, 2, 2);
  const {
    car,
    cdr
  } = $$firstAndSecond(...args);
  let r = [];

  if (!$$ambiguousEq(car, null)) {
    r = car;
  } else {
    r = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, cdr);
  }

  return r;
}; // tslint:disable-next-line:variable-name

const $__cond = (state, name) => (...args) => {
  // S expression: ($__cond 'cond1 'expr1 ... 'condN 'exprN)
  //  -> (if (eval condI) is true ) S expr  : exprI
  //  -> (if no matched)            S expr  : null
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$__cond', args, 1);

  for (let i = 0; i < args.length - 1; i += 2) {
    const c = args[i];
    const x = args[i + 1];

    if ($$boolean((0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, c))) {
      return (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, x);
    }
  }

  return null;
}; // tslint:disable-next-line:variable-name

const $__while = (state, name) => (...args) => {
  // S expression: ($__while 'condition 'expr1 ... 'exprN)
  //  -> (if condition is true at least 1 or more times) S expr  : exprN
  //  -> (else)                                          S expr  : null
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$__while', args, 1);
  const car = $$first(...args);
  const cdr = args.slice(1);
  let r = null;

  while ($$boolean((0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, car))) {
    for (const x of cdr) {
      r = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, x);
    }
  }

  return r;
}; // tslint:disable-next-line:variable-name

const $__doWhile = (state, name) => (...args) => {
  // S expression: ($__do-while 'condition 'expr1 ... 'exprN)
  //  -> (if condition is true at least 1 or more times) S expr  : exprN
  //  -> (else)                                          S expr  : null
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$__doWhile', args, 1);
  const car = $$first(...args);
  const cdr = args.slice(1);
  let r = null;

  do {
    for (const x of cdr) {
      r = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, x);
    }
  } while ($$boolean((0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, car)));

  return r;
}; // tslint:disable-next-line:variable-name

const $__until = (state, name) => (...args) => {
  // S expression: ($__until 'condition 'expr1 ... 'exprN)
  //  -> (if condition is true at least 1 or more times) S expr  : exprN
  //  -> (else)                                          S expr  : null
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$__until', args, 1);
  const car = $$first(...args);
  const cdr = args.slice(1);
  let r = null;

  while ($$not((0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, car))) {
    for (const x of cdr) {
      r = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, x);
    }
  }

  return r;
}; // tslint:disable-next-line:variable-name

const $__doUntil = (state, name) => (...args) => {
  // S expression: ($__do-until 'condition 'expr1 ... 'exprN)
  //  -> (if condition is true at least 1 or more times) S expr  : exprN
  //  -> (else)                                          S expr  : null
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$__doUntil', args, 1);
  const car = $$first(...args);
  const cdr = args.slice(1);
  let r = null;

  do {
    for (const x of cdr) {
      r = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, x);
    }
  } while ($$not((0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, car)));

  return r;
}; // tslint:disable-next-line:variable-name

const $__repeat = (state, name) => (...args) => {
  // S expression: ($__repeat 'i n-times 'expr1 ... 'exprN)
  //  -> (if n > 0) S expr  : exprN
  //  -> (else)     S expr  : null
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$__repeat', args, 2);
  const sym = (0,_ast__WEBPACK_IMPORTED_MODULE_5__.isSymbol)($$first(...args));

  if (!sym) {
    throw new Error(`[SX] $__repeat: Invalid argument(s): item(s) of args[0] is not symbol.`);
  }

  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkUnsafeVarNamesEx)('$__repeat', {}, sym.symbol); // NOTE: pass dummy target object.

  const scope = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.resolveValueSymbolScope)(state, sym, false);
  const n = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.toNumber)($$second(...args));
  const cdr = args.slice(2);
  let r = null;

  for (let i = 0; i < n; i++) {
    scope[sym.symbol] = i;

    for (const x of cdr) {
      r = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, x);
    }
  }

  return r;
}; // tslint:disable-next-line:variable-name

const $__for = (state, name) => (...args) => {
  // S expression: ($__for 'x list 'expr1 ... 'exprN)
  //  -> (if list.length > 0) S expr  : exprN
  //  -> (else)               S expr  : null
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$__for', args, 2);
  const sym = (0,_ast__WEBPACK_IMPORTED_MODULE_5__.isSymbol)($$first(...args));

  if (!sym) {
    throw new Error(`[SX] $__for: Invalid argument(s): item(s) of args[0] is not symbol.`);
  }

  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkUnsafeVarNamesEx)('$__for', {}, sym.symbol); // NOTE: pass dummy target object.

  const scope = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.resolveValueSymbolScope)(state, sym, false);
  const list = $$second(...args);

  if (!Array.isArray(list)) {
    throw new Error(`[SX] $__for: Invalid argument(s): item(s) of args[1] is not array.`);
  }

  const cdr = args.slice(2);
  let r = null;

  for (const q of list) {
    scope[sym.symbol] = q;

    for (const x of cdr) {
      r = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, x);
    }
  }

  return r;
}; // tslint:disable-next-line:variable-name

const $pipe = (state, name) => (...args) => {
  // S expression: ($__get v fn1 ... fnN)
  //  -> S expr  : any
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$pipe', args, 1);
  let v = args[0];

  for (let i = 1; i < args.length; i++) {
    v = args[i](v);
  }

  return v;
};
const $$pipe = $pipe(null, null); // tslint:disable-next-line:variable-name

const $__get = (state, name) => (...args) => {
  // S expression: ($__get 'nameOrIndex1 ... 'nameOrIndexN)
  //  -> S expr  : any
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$__get', args, 1);
  let v = null;
  let sym = (0,_ast__WEBPACK_IMPORTED_MODULE_5__.isSymbol)(args[0]);

  if (!sym) {
    switch (typeof args[0]) {
      case 'string':
      case 'number':
        sym = {
          symbol: String(args[0])
        };
        break;

      default:
        v = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, args[0]);
        break;
    }
  }

  if (sym) {
    const scope = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.resolveValueSymbolScope)(state, sym, true);

    if (!scope) {
      throw new Error(`[SX] $__get: Invalid argument(s): args[0]: symbol "${sym.symbol}" is not defined.`);
    }

    v = scope[sym.symbol];
  }

  for (let i = 1; i < args.length; i++) {
    let q = args[i];
    let inprog = true;

    while (inprog) {
      switch (typeof q) {
        case 'function':
          v = q(v);
          inprog = false;
          break;

        case 'object':
          if (Array.isArray(q)) {
            q = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, q);
          } else {
            sym = (0,_ast__WEBPACK_IMPORTED_MODULE_5__.isSymbol)(q);

            if (sym) {
              q = sym.symbol;
            } else if (Object.prototype.hasOwnProperty.call(q, 'value')) {
              q = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, q);
            } else {
              throw new Error(`[SX] $__get: Invalid argument(s): invalid name path.`);
            }
          }

          break;

        case 'number':
          if (q < 0) {
            q = v.length + q;
          }

        // FALL_THRU

        case 'string':
          (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkUnsafeVarNamesEx)('$__get', v, q);
          v = v[q];
          inprog = false;
          break;

        default:
          throw new Error(`[SX] $__get: Invalid argument(s): invalid name path.`);
      }
    }
  }

  return v;
}; // tslint:disable-next-line:variable-name

const $__let = (state, name) => (...args) => {
  // S expression: ($__let 'nameStrOrSymbol expr)
  //  -> S expr  : any
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$__let', args, 2, 2);
  let sym = (0,_ast__WEBPACK_IMPORTED_MODULE_5__.isSymbol)($$first(...args));

  if (!sym) {
    if (typeof args[0] === 'string') {
      sym = {
        symbol: args[0]
      };
    } else {
      throw new Error(`[SX] $__let: Invalid argument(s): invalid name.`);
    }
  }

  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkUnsafeVarNamesEx)('$__let', {}, sym.symbol); // NOTE: pass dummy target object.

  const scope = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.resolveValueSymbolScope)(state, sym, false);
  scope[sym.symbol] = args[1];
  return args[1];
}; // tslint:disable-next-line:variable-name

const $__set = (state, name) => (...args) => {
  // S expression: ($__set 'nameOrListOfNameOrIndex expr)
  //  -> S expr  : any
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$__set', args, 2, 2);
  let path = [];

  if (Array.isArray(args[0])) {
    path = args[0];
  } else {
    path.push(args[0]);
  }

  let sym = (0,_ast__WEBPACK_IMPORTED_MODULE_5__.isSymbol)(path[0]);

  if (!sym) {
    if (typeof path[0] === 'string') {
      (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkUnsafeVarNamesEx)('$__set', {}, path[0]); // NOTE: pass dummy target object.

      sym = {
        symbol: path[0]
      };
    } else {
      throw new Error(`[SX] $__set: Invalid argument(s): invalid name.`);
    }
  }

  let scope = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.resolveValueSymbolScope)(state, sym, true);

  if (scope === null) {
    throw new Error(`[SX] $__set: Unresolved symbol: ${sym.symbol}.`);
  }

  let subst = false;

  for (let i = 0; i < path.length; i++) {
    let q = path[i];
    let inprog = true;
    const last = i === path.length - 1;

    while (inprog) {
      switch (typeof q) {
        case 'function':
          scope = q(scope);
          inprog = false;
          break;

        case 'object':
          if (Array.isArray(q)) {
            q = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, q);
          } else {
            sym = (0,_ast__WEBPACK_IMPORTED_MODULE_5__.isSymbol)(q);

            if (sym) {
              q = sym.symbol;
            } else if (Object.prototype.hasOwnProperty.call(q, 'value')) {
              q = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, q);
            } else {
              throw new Error(`[SX] $__set: Invalid argument(s): invalid name.`);
            }
          }

          break;

        case 'number':
          if (q < 0) {
            q = scope.length + q;
          }

        // FALL_THRU

        case 'string':
          (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkUnsafeVarNamesEx)('$__set', scope, q);

          if (last) {
            scope[q] = args[1];
            subst = true;
          } else {
            scope = scope[q];
          }

          inprog = false;
          break;

        default:
          throw new Error(`[SX] $__set: Invalid argument(s): invalid name.`);
      }
    }
  }

  if (!subst) {
    throw new Error(`[SX] $__set: Invalid argument(s): last path is not lvalue.`);
  }

  return args[1];
};
const $boolean = (state, name) => (...args) => {
  // S expression: ($boolean any)
  //  -> S expr  : boolean
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$boolean', args, 1, 1);
  const car = $$first(...args);
  if (Array.isArray(car) && car.length === 0) return false;else return Boolean(car);
};
const $$boolean = $boolean(null, null);
const $not = (state, name) => (...args) => {
  // S expression: ($not any)
  //  -> S expr  : boolean
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$not', args, 1, 1);
  return !$$boolean(...args);
};
const $$not = $not(null, null); // tslint:disable-next-line:variable-name

const $__and = (state, name) => (...args) => {
  // S expression: ($__and 'expr1 ... 'exprN)
  //  -> (if all of ($boolean expr1) ... ($boolean exprN) are true) S expr  : exprN
  //  -> (else)                                                     S expr  : expr-i (false left most)
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$__and', args, 1);
  let prev = null;

  for (let i = 0; i < args.length; i++) {
    const curr = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, args[i]);

    if (!$$boolean(curr)) {
      return curr;
    }

    prev = curr;
  }

  return prev;
}; // tslint:disable-next-line:variable-name

const $$__and = $__and(null, null); // tslint:disable-next-line:variable-name

const $__or = (state, name) => (...args) => {
  // S expression: ($__or 'expr1 ... 'exprN)
  //  -> (if any ($boolean expr1) ... ($boolean exprN) are true) S expr  : expr-i (where i: index of item first ($boolean expr-i) is to be true)
  //  -> (else)                                                  S expr  : expr-i (false right most)
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$__or', args, 1);
  let prev = null;

  for (let i = 0; i < args.length; i++) {
    const curr = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, args[i]);

    if ($$boolean(curr)) {
      return curr;
    }

    prev = curr;
  }

  return prev;
}; // tslint:disable-next-line:variable-name

const $$__or = $__or(null, null);
const $ambiguousEq = (state, name) => (...args) => {
  // S expression: (== a b)
  //  -> S expr  : boolean
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$ambiguousEq', args, 2, 2);
  let {
    car,
    cdr
  } = $$firstAndSecond(...args);
  if (Array.isArray(car) && car.length === 0) car = null;
  if (Array.isArray(cdr) && cdr.length === 0) cdr = null;
  if (car === void 0) car = null;
  if (cdr === void 0) cdr = null; // tslint:disable-next-line:triple-equals

  return car == cdr;
};
const $$ambiguousEq = $ambiguousEq(null, null);
const $ambiguousNotEq = (state, name) => (...args) => {
  // S expression: (!= a b)
  //  -> S expr  : boolean
  return !$$ambiguousEq(...args);
};
const $$ambiguousNotEq = $ambiguousNotEq(null, null);
const $lt = (state, name) => (...args) => {
  // S expression: (< a b)
  //  -> S expr  : boolean
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$lt', args, 2, 2);
  const {
    car,
    cdr
  } = $$firstAndSecond(...args);
  return (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.toNumber)(car) < (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.toNumber)(cdr);
};
const $$lt = $lt(null, null);
const $le = (state, name) => (...args) => {
  // S expression: (<= a b)
  //  -> S expr  : boolean
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$le', args, 2, 2);
  const {
    car,
    cdr
  } = $$firstAndSecond(...args);
  return (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.toNumber)(car) <= (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.toNumber)(cdr);
};
const $$le = $le(null, null);
const $gt = (state, name) => (...args) => {
  // S expression: (> a b)
  //  -> S expr  : boolean
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$gt', args, 2, 2);
  const {
    car,
    cdr
  } = $$firstAndSecond(...args);
  return (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.toNumber)(car) > (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.toNumber)(cdr);
};
const $$gt = $gt(null, null);
const $ge = (state, name) => (...args) => {
  // S expression: (>= a b)
  //  -> S expr  : boolean
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$ge', args, 2, 2);
  const {
    car,
    cdr
  } = $$firstAndSecond(...args);
  return (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.toNumber)(car) >= (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.toNumber)(cdr);
};
const $$ge = $ge(null, null);
const $typeof = (state, name) => (...args) => {
  // S expression: ($typeof x)
  //  -> S expr  : 'null' | 'bigint' | 'boolean' | 'function' | 'number' | 'string' | 'undefined' |
  //               'js-symbol' | 'list' | 'object'
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$typeof', args, 1, 1);
  const car = $$first(...args);

  if (car === null) {
    return 'null';
  }

  const tyName = typeof car;

  switch (tyName) {
    case 'object':
      if (Array.isArray(car)) {
        return 'list';
      } else {
        return 'object';
      }

    case 'symbol':
      return 'js-symbol';

    default:
      return tyName;
  }
};
const $$typeof = $typeof(null, null);
const $symbol = (state, name) => (...args) => {
  // S expression: ($symbol)
  // S expression: ($symbol name)
  //  -> S expr  : symbol
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$symbol', args, 1, 1);

  if (typeof args[0] === 'string') {
    return {
      symbol: args[0]
    };
  } else {
    throw new Error(`[SX] $symbol: Invalid argument(s): item(s) of args[0] is not string.`);
  }
};
const $$symbol = $symbol(null, null); // tslint:disable-next-line:variable-name

const $__gensym = (state, name) => (...args) => {
  // S expression: ($__gensym)
  // S expression: ($__gensym name)
  //  -> S expr  : symbol
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$__gensym', args, 0, 1);
  const varBaseName = `$__tempvar__$$ec${state.evalCount++}$$_`;
  const tempVarSym = {
    symbol: `${varBaseName}_$gensym`
  };

  if (args.length === 1) {
    const a = (0,_ast__WEBPACK_IMPORTED_MODULE_5__.isSymbol)(args[0]);

    if (a) {
      $__let(state, '')(a, tempVarSym);
    } else if (typeof args[0] === 'string') {
      $__let(state, '')({
        symbol: args[0]
      }, tempVarSym);
    } else {
      throw new Error(`[SX] $__gensym: Invalid argument(s): item(s) of args[0] is not symbol.`);
    }
  }

  return tempVarSym;
};
const $isSymbol = (state, name) => (...args) => {
  // S expression: ($is-symbol x)
  // S expression: ($is-symbol x name)
  //  -> S expr  : boolean
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$isSymbol', args, 1, 2);

  if (args.length === 1) {
    return (0,_ast__WEBPACK_IMPORTED_MODULE_5__.isSymbol)(args[0]) ? true : false;
  } else {
    if (typeof args[1] === 'string') {
      return (0,_ast__WEBPACK_IMPORTED_MODULE_5__.isSymbol)(args[0], args[1]) ? true : false;
    } else {
      throw new Error(`[SX] $isSymbol: Invalid argument(s): item(s) of args[1] is not string.`);
    }
  }
};
const $$isSymbol = $isSymbol(null, null);
const $isNull = (state, name) => (...args) => {
  // S expression: ($is-null x)
  //  -> S expr  : boolean
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$isNull', args, 1, 1);
  return $$first(...args) === null;
};
const $$isNull = $isNull(null, null);
const $isNil = (state, name) => (...args) => {
  // S expression: ($is-nil x)
  //  -> S expr  : boolean
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$isNil', args, 1, 1);
  const car = $$first(...args);
  return Array.isArray(car) && car.length === 0;
};
const $$isNil = $isNil(null, null);
const $isUndefined = (state, name) => (...args) => {
  // S expression: ($is-undefined x)
  //  -> S expr  : boolean
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$isUndefined', args, 1, 1);
  return $$first(...args) === void 0;
};
const $$isUndefined = $isUndefined(null, null);
const $isList = (state, name) => (...args) => {
  // S expression: ($is-list x)
  //  -> S expr  : boolean
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$isList', args, 1, 1);
  return Array.isArray($$first(...args));
};
const $$isList = $isList(null, null);
const $isString = (state, name) => (...args) => {
  // S expression: ($is-string x)
  //  -> S expr  : boolean
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$isString', args, 1, 1);
  return typeof $$first(...args) === 'string';
};
const $$isString = $isString(null, null);
const $isNumber = (state, name) => (...args) => {
  // S expression: ($is-number x)
  //  -> S expr  : boolean
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$isNumber', args, 1, 1);
  return typeof $$first(...args) === 'number';
};
const $$isNumber = $isNumber(null, null);
const $isNaN = (state, name) => (...args) => {
  // S expression: ($is-NaN x)
  //  -> S expr  : boolean
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$isNaN', args, 1, 1);
  return Number.isNaN($$first(...args));
};
const $$isNaN = $isNaN(null, null);
const $isFinite = (state, name) => (...args) => {
  // S expression: ($is-finate x)
  //  -> S expr  : boolean
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$isFinite', args, 1, 1);
  return Number.isFinite($$first(...args));
};
const $$isFinite = $isFinite(null, null);
const $isInteger = (state, name) => (...args) => {
  // S expression: ($is-integer x)
  //  -> S expr  : boolean
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$isInteger', args, 1, 1);
  return Number.isInteger($$first(...args));
};
const $$isInteger = $isInteger(null, null);
const $toString = (state, name) => (...args) => {
  // S expression: ($to-string x)
  //  -> S expr  : string
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$toString', args, 1, 1);
  return String($$first(...args));
};
const $$toString = $toString(null, null);
const $toNumber = (state, name) => (...args) => {
  // S expression: ($to-number x)
  //  -> S expr  : number
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$toNumber', args, 1, 1);
  return (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.toNumber)($$first(...args));
};
const $$toNumber = $toNumber(null, null); // tslint:disable-next-line:variable-name

const $__toObject = (state, name) => (...args) => {
  // S expression: ($__# '(name value...)...)
  //  -> JSON    : {name: value, ...}
  const r = {};

  for (const x of args) {
    if (Array.isArray(x) && 0 < x.length) {
      const sym = (0,_ast__WEBPACK_IMPORTED_MODULE_5__.isSymbol)(x[0]);
      const keyName = sym ? sym.symbol : String((0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, x[0]));
      (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkUnsafeVarNamesEx)('$__#', r, keyName);

      if (x.length === 1) {
        // S expression: (# ... (keyName) ...)
        //  -> JSON    : {..., keyName: true, ...}
        r[keyName] = true;
      } else if (x.length === 2) {
        // S expression: (# ... (keyName value) ...)
        //  -> JSON    : {..., keyName: value, ...}
        r[keyName] = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, x[1]);
      } else {
        // S expression: (# ... (keyName value1 value2 ...) ...)
        //  -> JSON    : {..., keyName: [value1, value2, ], ...}
        r[keyName] = (0,_evaluate__WEBPACK_IMPORTED_MODULE_2__.evaluate)(state, [{
          symbol: state.config.reservedNames.list
        }].concat(x.slice(1)));
      }
    } else {
      throw new Error(`[SX] $__toObject: Invalid argument(s): args[?] is not array.`);
    }
  }

  return r;
};
const assignBlacklist = [_global_this__WEBPACK_IMPORTED_MODULE_1__.globalObj, Object.__proto__, {}.__proto__, Function.__proto__];
const $objectAssign = (state, name) => (...args) => {
  // S expression: ($object-assign x)
  //  -> S expr  : string
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$objectAssign', args, 1);

  if (assignBlacklist.includes(args[0])) {
    throw new Error(`[SX] $objectAssign: Invalid argument: args[0] is blacklisted object.`);
  }

  return Object.assign(args[0], ...args.slice(1));
};
const $$objectAssign = $objectAssign(null, null);
const $jsonStringify = (state, name) => (...args) => {
  // S expression: ($json-stringify x)
  //  -> S expr  : string
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$jsonStringify', args, 1, 1);
  return JSON.stringify($$first(...args));
};
const $$jsonStringify = $jsonStringify(null, null);
const $jsonParse = (state, name) => (...args) => {
  // S expression: ($json-parse x)
  //  -> S expr  : object
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$jsonParse', args, 1, 1);
  const s = $$first(...args);

  if (typeof s !== 'string') {
    throw new Error(`[SX] $jsonParse: Invalid argument(s): args[0] is not string.`);
  }

  return JSON.parse(s);
};
const $$jsonParse = $jsonParse(null, null);
const $now = (state, name) => (...args) => {
  // S expression: ($now)
  //  -> S expr  : number
  return Date.now();
};
const $$now = $now(null, null);
const $datetimeFromIso = (state, name) => (...args) => {
  // S expression: ($datetime-from-iso str)
  //  -> S expr  : number
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$datetimeFromIso', args, 1, 1);
  const s = $$first(...args);

  if (typeof s !== 'string') {
    throw new Error(`[SX] $datetimeFromIso: Invalid argument(s): args[0] is not string.`);
  }

  if (!/^(?:(?:-[0-9]{6,})|[0-9]{4,})-(?:[0-1][0-9])-(?:[0-3][0-9])(?:T(?:[0-2][0-9])(?:[:](?:[0-6][0-9])(?:[:](?:[0-6][0-9])(?:.[0-9]{1,})?)?)?(?:Z|[-+][0-9]{2}(?:[:]?[0-6][0-9])?)?)?$/.test(s)) {
    throw new Error(`[SX] $datetimeFromIso: Invalid datetime (pattern unmatched): ${s}.`);
  }

  const dt = new Date(s).getTime();

  if (Number.isNaN(dt)) {
    throw new Error(`[SX] $datetimeFromIso: Invalid datetime: ${s}.`);
  }

  return dt;
};
const $$datetimeFromIso = $datetimeFromIso(null, null);
const $datetime = (state, name) => (...args) => {
  // S expression: ($datetime year month1-12 day)
  // S expression: ($datetime year month1-12 day hours)
  // S expression: ($datetime year month1-12 day hours minutes)
  // S expression: ($datetime year month1-12 day hours minutes seconds)
  // S expression: ($datetime year month1-12 day hours minutes seconds milliseconds)
  //  -> S expr  : number
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$datetime', args, 3, 7);
  let s = '';
  const year = Number(args[0]);

  if (year >= 0) {
    s += String(year).padStart(4, '0');
  } else {
    s += '-' + String(-year).padStart(6, '0');
  } // month1


  s += '-' + String(Number(args[1])).padStart(2, '0'); // day

  s += '-' + String(Number(args[2])).padStart(2, '0'); // hours

  if (args.length >= 4) {
    s += 'T' + String(Number(args[3])).padStart(2, '0'); // minutes

    if (args.length >= 5) {
      s += ':' + String(Number(args[4])).padStart(2, '0');
    } else {
      s += ':00';
    } // seconds


    if (args.length >= 6) {
      s += ':' + String(Number(args[5])).padStart(2, '0');
    } // milliseconds


    if (args.length >= 7) {
      s += '.' + String(Number(args[6])).padStart(3, '0').slice(0, 3);
    }

    s += 'Z';
  }

  const dt = new Date(s).getTime();

  if (Number.isNaN(dt)) {
    throw new Error(`[SX] $datetime: Invalid datetime: ${s}.`);
  }

  return dt;
};
const $$datetime = $datetime(null, null);
const $datetimeLc = (state, name) => (...args) => {
  // S expression: ($datetime-lc year month1-12 day)
  // S expression: ($datetime-lc year month1-12 day hours)
  // S expression: ($datetime-lc year month1-12 day hours minutes)
  // S expression: ($datetime-lc year month1-12 day hours minutes seconds)
  // S expression: ($datetime-lc year month1-12 day hours minutes seconds milliseconds)
  //  -> S expr  : number
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$datetimeLc', args, 3, 7);
  let s = '';
  const year = Number(args[0]);

  if (year >= 0) {
    s += String(year).padStart(4, '0');
  } else {
    s += '-' + String(-year).padStart(6, '0');
  } // month1


  s += '-' + String(Number(args[1])).padStart(2, '0'); // day

  s += '-' + String(Number(args[2])).padStart(2, '0'); // hours

  if (args.length >= 4) {
    s += 'T' + String(Number(args[3])).padStart(2, '0'); // minutes

    if (args.length >= 5) {
      s += ':' + String(Number(args[4])).padStart(2, '0');
    } else {
      s += ':00';
    } // seconds


    if (args.length >= 6) {
      s += ':' + String(Number(args[5])).padStart(2, '0');
    } // milliseconds


    if (args.length >= 7) {
      s += '.' + String(Number(args[6])).padStart(3, '0').slice(0, 3);
    }
  } else {
    s += 'T00:00:00.000';
  }

  const dt = new Date(s).getTime();

  if (Number.isNaN(dt)) {
    throw new Error(`[SX] $datetimeLc: Invalid datetime: ${s}.`);
  }

  return dt;
};
const $$datetimeLc = $datetimeLc(null, null);
const $datetimeToIsoString = (state, name) => (...args) => {
  // S expression: ($datetime-to-iso-string number)
  //  -> S expr  : string
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$datetimeToIsoString', args, 1, 1);
  const n = $$first(...args);

  if (typeof n !== 'number') {
    throw new Error(`[SX] $datetimeToIsoString: Invalid argument(s): args[0] is not number.`);
  }

  const dt = new Date(n);

  if (Number.isNaN(dt.getTime())) {
    throw new Error(`[SX] $datetimeToIsoString: Invalid datetime: ${n}.`);
  }

  return dt.toISOString();
};
const $$datetimeToIsoString = $datetimeToIsoString(null, null);
const $datetimeToComponents = (state, name) => (...args) => {
  // S expression: ($datetime-to-components number)
  //  -> S expr  : list
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$datetimeToComponents', args, 1, 1);
  const n = $$first(...args);

  if (typeof n !== 'number') {
    throw new Error(`[SX] $datetimeToComponents: Invalid argument(s): args[0] is not number.`);
  }

  const dt = new Date(n);

  if (Number.isNaN(dt.getTime())) {
    throw new Error(`[SX] $datetimeToComponents: Invalid datetime: ${n}.`);
  }

  return [dt.getUTCFullYear(), dt.getUTCMonth() + 1, dt.getUTCDate(), dt.getUTCHours(), dt.getUTCMinutes(), dt.getUTCSeconds(), dt.getUTCMilliseconds(), 0, dt.getUTCDay()];
};
const $$datetimeToComponents = $datetimeToComponents(null, null);
const $datetimeToComponentsLc = (state, name) => (...args) => {
  // S expression: ($datetime-to-components-lc number)
  //  -> S expr  : list
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$datetimeToComponentsLc', args, 1, 1);
  const n = $$first(...args);

  if (typeof n !== 'number') {
    throw new Error(`[SX] $datetimeToComponentsLc: Invalid argument(s): args[0] is not number.`);
  }

  const dt = new Date(n);

  if (Number.isNaN(dt.getTime())) {
    throw new Error(`[SX] $datetimeToComponentsLc: Invalid datetime: ${n}.`);
  }

  return [dt.getFullYear(), dt.getMonth() + 1, dt.getDate(), dt.getHours(), dt.getMinutes(), dt.getSeconds(), dt.getMilliseconds(), -dt.getTimezoneOffset(), // If your time zone is UTC+2:00, +120 will be returned.
  dt.getDay()];
};
const $$datetimeToComponentsLc = $datetimeToComponentsLc(null, null);
const $match = (state, name) => (...args) => {
  // S expression: ($match pattern-str string)
  // S expression: ($match pattern-str options-str string)
  //  -> S expr  : array
  (0,_errors__WEBPACK_IMPORTED_MODULE_4__.checkParamsLength)('$match', args, 2, 3);

  if (!state.config.enableRegExpMatchOperators) {
    throw new Error(`[SX] $match: Operator is disabled by configuration.`);
  }

  if (args.length === 2) {
    const m = new RegExp(args[0]);
    return m.exec(args[1]);
  } else {
    const m = new RegExp(args[0], args[1]);
    return m.exec(args[2]);
  }
};
const $$match = $match(null, null);
const $consoleLog = (state, name) => (...args) => {
  // S expression: ($console-log expr1 ... exprN)
  //  -> S expr  : null
  console.log(...args);
  return null;
};
const $$consoleLog = $consoleLog(null, null);
const $consoleError = (state, name) => (...args) => {
  // S expression: ($console-error expr1 ... exprN)
  //  -> S expr  : null
  console.error(...args);
  return null;
};
const $$consoleError = $consoleError(null, null);
const $consoleTrace = (state, name) => (...args) => {
  // S expression: ($console-trace expr1 ... exprN)
  //  -> S expr  : null
  console.trace(...args);
  return null;
};
const $$consoleTrace = $consoleTrace(null, null);
const $consoleTime = (state, name) => (...args) => {
  // S expression: ($console-time)
  // S expression: ($console-time label)
  //  -> S expr  : null
  console.time(...args);
  return null;
};
const $$consoleTime = $consoleTime(null, null);
const $consoleTimeEnd = (state, name) => (...args) => {
  // S expression: ($console-time-end)
  // S expression: ($console-time-end label)
  //  -> S expr  : null
  console.timeEnd(...args);
  return null;
};
const $$consoleTimeEnd = $consoleTimeEnd(null, null);
const $consoleTimeLog = (state, name) => (...args) => {
  // S expression: ($console-time-log label)
  // S expression: ($console-time-log label value ... value)
  //  -> S expr  : null
  console.timeLog(...args);
  return null;
};
const $$consoleTimeLog = $consoleTimeLog(null, null);

/***/ }),

/***/ "./node_modules/liyad/modules/s-exp/operators/core/core.macro.js":
/*!***********************************************************************!*\
  !*** ./node_modules/liyad/modules/s-exp/operators/core/core.macro.js ***!
  \***********************************************************************/
/*! namespace exports */
/*! export compilationMacros [provided] [no usage info] [missing usage info prevents renaming] */
/*! export default [provided] [no usage info] [missing usage info prevents renaming] */
/*! export macros [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_require__, __webpack_exports__, __webpack_require__.r, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "macros": () => /* binding */ macros,
/* harmony export */   "compilationMacros": () => /* binding */ compilationMacros,
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var _ast__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../../ast */ "./node_modules/liyad/modules/s-exp/ast.js");
/* harmony import */ var _errors__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../../errors */ "./node_modules/liyad/modules/s-exp/errors.js");
// Copyright (c) 2018, Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln


const macros = [{
  name: '$scope',
  fn: (state, name) => list => {
    // S expression: ($scope isBlockLocal returnMultiple ((name value) | name ...) expr ... expr)
    //  -> S expr  : ($__scope isBlockLocal returnMultiple '((name value) | name ...) 'expr ... 'expr)
    return [{
      symbol: '$__scope'
    }, list[1], list[2], ...list.slice(3).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}, {
  name: '$local',
  fn: (state, name) => list => {
    // S expression: ($local ((name value) | name ...) expr ... expr)
    //  -> S expr  : ($__scope isBlockLocal=true returnMultiple=false '((name value) | name ...) 'expr ... 'expr)
    return [{
      symbol: '$__scope'
    }, true, false, ...list.slice(1).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}, {
  name: '$global',
  fn: (state, name) => list => {
    // S expression: ($__global expr1 ... exprN)
    //  -> S expr  : ($__global returnMultiple=false 'expr ... 'expr)
    return [{
      symbol: '$__global'
    }, false, ...list.slice(1).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}, {
  name: '$clisp-let',
  fn: (state, name) => list => {
    // S expression: ($clisp-let ((name value) | name ...) expr ... expr)
    //  -> S expr  : ($__scope isBlockLocal=true returnMultiple=false '((name value) | name ...) 'expr ... 'expr)
    return [{
      symbol: '$__scope'
    }, true, false, ...list.slice(1).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}, {
  name: '$capture',
  fn: (state, name) => list => {
    // S expression: ($capture (sym1 ... symN) expr ... expr)
    //  -> S expr  : ($__capture '(sym1 ... symN) 'expr ... 'expr)
    return [{
      symbol: '$__capture'
    }, ...list.slice(1).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}, {
  name: '$closure',
  fn: (state, name) => list => {
    // S expression: ($closure (sym1 ... symN) use (u-sym1 ... u-symM) expr ... expr)
    //  -> S expr  : ($__capture '(u-sym1 ... u-symM) ($__lambda '(sym1 ... symN) 'expr ... 'expr) )
    const symUse = (0,_ast__WEBPACK_IMPORTED_MODULE_1__.isSymbol)(list[2], 'use');

    if (!symUse) {
      throw new Error(`[SX] $closure: Invalid syntax: missing 'use' keyword.`);
    }

    return [{
      symbol: '$__capture'
    }, (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, list[3]), (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, [{
      symbol: '$__lambda'
    }, (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, list[1]), ...list.slice(4).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))])];
  }
}, {
  name: '|->',
  fn: (state, name) => list => {
    // S expression: (|-> (sym1 ... symN) use (u-sym1 ... u-symM) expr ... expr)
    //  -> S expr  : ($closure (sym1 ... symN) use (u-sym1 ... u-symM) expr ... expr)
    return [{
      symbol: '$closure'
    }, ...list.slice(1)];
  }
}, {
  name: '$lambda',
  fn: (state, name) => list => {
    // S expression: ($lambda (sym1 ... symN) expr ... expr)
    //  -> S expr  : ($__lambda '(sym1 ... symN) 'expr ... 'expr)
    return [{
      symbol: '$__lambda'
    }, ...list.slice(1).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}, {
  name: '->',
  fn: (state, name) => list => {
    // S expression: ($lambda (sym1 ... symN) expr ... expr)
    //  -> S expr  : ($__lambda '(sym1 ... symN) 'expr ... 'expr)
    return [{
      symbol: '$__lambda'
    }, ...list.slice(1).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}, {
  name: '$defun',
  fn: (state, name) => list => {
    // S expression: ($defun name (sym1 ... symN) expr ... expr)
    //  -> S expr  : ($__defun 'name '(sym1 ... symN) 'expr ... 'expr)
    return [{
      symbol: '$__defun'
    }, ...list.slice(1).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}, {
  name: '$refun',
  fn: (state, name) => list => {
    // S expression: ($refun name)
    //  -> S expr  : ($__refun 'name)
    return [{
      symbol: '$__refun'
    }, ...list.slice(1).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}, {
  name: '<-',
  fn: (state, name) => list => {
    // S expression: (<- name)
    //  -> S expr  : ($__refun 'name)
    return [{
      symbol: '$__refun'
    }, ...list.slice(1).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}, {
  name: '$defmacro',
  fn: (state, name) => list => {
    // S expression: ($defmacro name (sym1 ... symN) expr ... expr)
    //  -> S expr  : ($__defmacro 'name '(sym1 ... symN) 'expr ... 'expr)
    return [{
      symbol: '$__defmacro'
    }, ...list.slice(1).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}, {
  name: '$call',
  fn: (state, name) => list => {
    // S expression: ($call thisArg symbol arg1 ... argN)
    //  -> S expr  : ($__call thisArg 'symbol arg1 ... argN)
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('$call', list, 3);
    return [{
      symbol: '$__call'
    }, list[1], (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, list[2]), ...list.slice(3)];
  }
}, {
  name: '$try',
  fn: (state, name) => list => {
    // S expression: ($try expr catch-expr)
    //  -> S expr  : ($__try 't-expr 'catch-expr)
    return [{
      symbol: '$__try'
    }, ...list.slice(1).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}, {
  name: '$if',
  fn: (state, name) => list => {
    // S expression: ($if cond t-expr f-expr)
    //  -> S expr  : ($__if cond 't-expr 'f-expr)
    return [{
      symbol: '$__if'
    }, list[1], ...list.slice(2).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}, {
  name: '$if-null',
  fn: (state, name) => list => {
    // S expression: ($if-null cond null-expr)
    //  -> S expr  : ($__if-null cont 'null-expr)
    return [{
      symbol: '$__if-null'
    }, list[1], ...list.slice(2).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}, {
  name: '??',
  fn: (state, name) => list => {
    // S expression: (?? cond null-expr)
    //  -> S expr  : ($__if-null cont 'null-expr)
    return [{
      symbol: '$__if-null'
    }, list[1], ...list.slice(2).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}, {
  name: '$cond',
  fn: (state, name) => list => {
    // S expression: ($cond cond1 expr1 ... condN exprN)
    //  -> S expr  : ($__cond 'cond1 'expr1 ... 'condN 'exprN)
    return [{
      symbol: '$__cond'
    }, ...list.slice(1).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}, {
  name: '$while',
  fn: (state, name) => list => {
    // S expression: ($while condition expr1 exprN)
    //  -> S expr  : ($__while 'condition 'expr1 'exprN)
    return [{
      symbol: '$__while'
    }, ...list.slice(1).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}, {
  name: '$do-while',
  fn: (state, name) => list => {
    // S expression: ($do-while condition expr1 exprN)
    //  -> S expr  : ($__do-while 'condition 'expr1 'exprN)
    return [{
      symbol: '$__do-while'
    }, ...list.slice(1).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}, {
  name: '$until',
  fn: (state, name) => list => {
    // S expression: ($until condition expr1 exprN)
    //  -> S expr  : ($__until 'condition 'expr1 'exprN)
    return [{
      symbol: '$__until'
    }, ...list.slice(1).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}, {
  name: '$do-until',
  fn: (state, name) => list => {
    // S expression: ($do-until condition expr1 exprN)
    //  -> S expr  : ($__do-until 'condition 'expr1 'exprN)
    return [{
      symbol: '$__do-until'
    }, ...list.slice(1).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}, {
  name: '$repeat',
  fn: (state, name) => list => {
    // S expression: ($repeat i of n-times expr1 exprN)
    //  -> S expr  : ($__repeat 'i n-times 'expr1 'exprN)
    const symOf = (0,_ast__WEBPACK_IMPORTED_MODULE_1__.isSymbol)(list[2], 'of');

    if (!symOf) {
      throw new Error(`[SX] $repeat: Invalid syntax: missing 'of' keyword.`);
    }

    return [{
      symbol: '$__repeat'
    }, (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, list[1]), list[3], ...list.slice(4).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}, {
  name: '$for',
  fn: (state, name) => list => {
    // S expression: ($for x of list expr1 exprN)
    //  -> S expr  : ($__for 'x list 'expr1 'exprN)
    const symOf = (0,_ast__WEBPACK_IMPORTED_MODULE_1__.isSymbol)(list[2], 'of');

    if (!symOf) {
      throw new Error(`[SX] $for: Invalid syntax: missing 'of' keyword.`);
    }

    return [{
      symbol: '$__for'
    }, (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, list[1]), list[3], ...list.slice(4).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}, {
  name: '$get',
  fn: (state, name) => list => {
    // S expression: ($get nameOrIndex1 ... nameOrIndexN)
    //  -> S expr  : ($__get 'nameOrIndex1 ... 'nameOrIndexN)
    return [{
      symbol: '$__get'
    }, ...list.slice(1).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}, {
  name: '$let',
  fn: (state, name) => list => {
    // S expression: ($let nameStrOrSymbol expr)
    //  -> S expr  : ($__let 'nameStrOrSymbol expr)
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('$let', list, 3, 3);
    return [{
      symbol: '$__let'
    }, (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, list[1]), list[2]];
  }
}, {
  name: '$clisp-defvar',
  fn: (state, name) => list => {
    // S expression: ($let nameStrOrSymbol expr)
    //  -> S expr  : ($__let 'nameStrOrSymbol expr)
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('$clisp-defvar', list, 3, 3);
    return [{
      symbol: '$global'
    }, [{
      symbol: '$__let'
    }, (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, list[1]), list[2]]];
  }
}, {
  name: '$set',
  fn: (state, name) => list => {
    // S expression: ($set nameOrListOfNameOrIndex expr)
    //  -> S expr  : ($__set 'nameOrListOfNameOrIndex expr)
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('$set', list, 3, 3);
    return [{
      symbol: '$__set'
    }, (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, list[1]), list[2]];
  }
}, {
  name: '$clisp-setq',
  fn: (state, name) => list => {
    // S expression: ($clisp-setq symbol expr)
    //  -> S expr  : ($__set 'symbol expr)
    (0,_errors__WEBPACK_IMPORTED_MODULE_0__.checkParamsLength)('$clisp-setq', list, 3, 3);
    return [{
      symbol: '$__set'
    }, (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, list[1]), list[2]];
  }
}, {
  name: '$and',
  fn: (state, name) => list => {
    // S expression: ($and expr1 ... exprN)
    //  -> S expr  : ($__and 'expr1 ... 'exprN)
    return [{
      symbol: '$__and'
    }, ...list.slice(1).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}, {
  name: '$or',
  fn: (state, name) => list => {
    // S expression: ($or expr1 ... exprN)
    //  -> S expr  : ($__or 'expr1 ... 'exprN)
    return [{
      symbol: '$__or'
    }, ...list.slice(1).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}, {
  name: '$gensym',
  fn: (state, name) => list => {
    // S expression: ($gensym)
    // S expression: ($gensym name)
    //  -> S expr  : ($__gensym 'name)
    return [{
      symbol: '$__gensym'
    }, ...list.slice(1).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}, {
  name: '#',
  fn: (state, name) => list => {
    // S expression: (# (name value...)...)
    //  -> S expr  : ($__# '(name value...)...)
    return [{
      symbol: '$__#'
    }, ...list.slice(1).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}];
const compilationMacros = [{
  name: '$$closure',
  fn: (state, name) => list => {
    // S expression: ($$closure (sym1 ... symN) use (u-sym1 ... u-symM) expr ... expr)
    //  -> S expr  : ($__capture '(u-sym1 ... u-symM) ($$__lambda '(sym1 ... symN) 'expr ... 'expr) )
    const symUse = (0,_ast__WEBPACK_IMPORTED_MODULE_1__.isSymbol)(list[2], 'use');

    if (!symUse) {
      throw new Error(`[SX] $closure: Invalid syntax: missing 'use' keyword.`);
    }

    return [{
      symbol: '$__capture'
    }, (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, list[3]), (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, [{
      symbol: '$$__lambda'
    }, (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, list[1]), ...list.slice(4).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))])];
  }
}, {
  name: '|=>',
  fn: (state, name) => list => {
    // S expression: (|-> (sym1 ... symN) use (u-sym1 ... u-symM) expr ... expr)
    //  -> S expr  : ($closure (sym1 ... symN) use (u-sym1 ... u-symM) expr ... expr)
    return [{
      symbol: '$$closure'
    }, ...list.slice(1)];
  }
}, {
  name: '$$lambda',
  fn: (state, name) => list => {
    // S expression: ($$lambda (sym1 ... symN) expr ... expr)
    //  -> S expr  : ($$__lambda '(sym1 ... symN) 'expr ... 'expr)
    return [{
      symbol: '$$__lambda'
    }, ...list.slice(1).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}, {
  name: '=>',
  fn: (state, name) => list => {
    // S expression: ($$lambda (sym1 ... symN) expr ... expr)
    //  -> S expr  : ($$__lambda '(sym1 ... symN) 'expr ... 'expr)
    return [{
      symbol: '$$__lambda'
    }, ...list.slice(1).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}, {
  name: '$$defun',
  fn: (state, name) => list => {
    // S expression: ($$defun name (sym1 ... symN) expr ... expr)
    //  -> S expr  : ($$__defun 'name '(sym1 ... symN) 'expr ... 'expr)
    return [{
      symbol: '$$__defun'
    }, ...list.slice(1).map(x => (0,_ast__WEBPACK_IMPORTED_MODULE_1__.quote)(state, x))];
  }
}]; // for backword compatibility

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ([].concat(macros, compilationMacros));

/***/ }),

/***/ "./node_modules/liyad/modules/s-exp/operators/core/core.operator.js":
/*!**************************************************************************!*\
  !*** ./node_modules/liyad/modules/s-exp/operators/core/core.operator.js ***!
  \**************************************************************************/
/*! namespace exports */
/*! export compilationOperators [provided] [no usage info] [missing usage info prevents renaming] */
/*! export default [provided] [no usage info] [missing usage info prevents renaming] */
/*! export operators [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_require__, __webpack_exports__, __webpack_require__.r, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "operators": () => /* binding */ operators,
/* harmony export */   "compilationOperators": () => /* binding */ compilationOperators,
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var _core_fn__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./core.fn */ "./node_modules/liyad/modules/s-exp/operators/core/core.fn.js");
// Copyright (c) 2018, Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln

const operators = [{
  name: '$car',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$car
}, {
  name: '$cdr',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$cdr
}, {
  name: '$cons',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$cons
}, {
  name: '$first',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$first
}, {
  name: '$second',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$second
}, {
  name: '$last',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$last
}, {
  name: '$progn',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$last
}, {
  name: '$rest',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$rest
}, {
  name: '$first-and-second',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$firstAndSecond
}, {
  name: '$atom',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$atom
}, {
  name: '$eq',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$eq
}, {
  name: '===',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$eq
}, {
  name: '$not-eq',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$notEq
}, {
  name: '!==',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$notEq
}, {
  name: '$list',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$list
}, {
  name: '$__scope',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$__scope
}, {
  name: '$__global',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$__globalScope
}, {
  name: '$__capture',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$__capture
}, {
  name: '$__lambda',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$__lambda
}, {
  name: '$__defun',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$__defun
}, {
  name: '$__refun',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$__refun
}, {
  name: '$__defmacro',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$__defmacro
}, {
  name: '$apply',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$apply
}, {
  name: '$__call',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$__call
}, {
  name: '$__try',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$__try
}, {
  name: '$raise',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$raise
}, {
  name: '$__if',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$__if
}, {
  name: '$__if-null',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$__ifNull
}, {
  name: '$__cond',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$__cond
}, {
  name: '$__while',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$__while
}, {
  name: '$__do-while',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$__doWhile
}, {
  name: '$__until',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$__until
}, {
  name: '$__do-until',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$__doUntil
}, {
  name: '$__repeat',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$__repeat
}, {
  name: '$__for',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$__for
}, {
  name: '$pipe',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$pipe
}, {
  name: '$__get',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$__get
}, {
  name: '$__let',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$__let
}, {
  name: '$__set',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$__set
}, {
  name: '$boolean',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$boolean
}, {
  name: '$not',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$not
}, {
  name: '$__and',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$__and
}, {
  name: '$__or',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$__or
}, {
  name: '==',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$ambiguousEq
}, {
  name: '!=',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$ambiguousNotEq
}, {
  name: '<',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$lt
}, {
  name: '<=',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$le
}, {
  name: '>',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$gt
}, {
  name: '>=',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$ge
}, {
  name: '$typeof',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$typeof
}, {
  name: '$symbol',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$symbol
}, {
  name: '$__gensym',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$__gensym
}, {
  name: '$is-symbol',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$isSymbol
}, {
  name: '$is-null',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$isNull
}, {
  name: '$is-nil',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$isNil
}, {
  name: '$is-undefined',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$isUndefined
}, {
  name: '$is-list',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$isList
}, {
  name: '$is-string',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$isString
}, {
  name: '$is-number',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$isNumber
}, {
  name: '$is-NaN',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$isNaN
}, {
  name: '$is-finite',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$isFinite
}, {
  name: '$is-integer',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$isInteger
}, {
  name: '$to-string',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$toString
}, {
  name: '$to-number',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$toNumber
}, {
  name: '$__#',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$__toObject
}, {
  name: '$object-assign',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$objectAssign
}, {
  name: '$json-stringify',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$jsonStringify
}, {
  name: '$now',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$now
}, {
  name: '$datetime-from-iso',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$datetimeFromIso
}, {
  name: '$datetime',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$datetime
}, {
  name: '$datetime-lc',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$datetimeLc
}, {
  name: '$datetime-to-iso-string',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$datetimeToIsoString
}, {
  name: '$datetime-to-components',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$datetimeToComponents
}, {
  name: '$datetime-to-components-lc',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$datetimeToComponentsLc
}, {
  name: '$json-parse',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$jsonParse
}, {
  name: '$match',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$match
}, {
  name: '$console-log',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$consoleLog
}, {
  name: '$console-error',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$consoleError
}, {
  name: '$console-trace',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$consoleTrace
}, {
  name: '$console-time',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$consoleTime
}, {
  name: '$console-time-end',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$consoleTimeEnd
}, {
  name: '$console-time-log',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$consoleTimeLog
}];
const compilationOperators = [{
  name: '$$__lambda',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$comp$__lambda
}, {
  name: '$$__defun',
  fn: _core_fn__WEBPACK_IMPORTED_MODULE_0__.$comp$__defun
}]; // for backword compatibility

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ([].concat(operators, compilationOperators));

/***/ }),

/***/ "./node_modules/liyad/modules/s-exp/operators/core/core.symbol.js":
/*!************************************************************************!*\
  !*** ./node_modules/liyad/modules/s-exp/operators/core/core.symbol.js ***!
  \************************************************************************/
/*! namespace exports */
/*! export default [provided] [no usage info] [missing usage info prevents renaming] */
/*! export symbols [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.r, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "symbols": () => /* binding */ symbols,
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
// Copyright (c) 2018, Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln
const symbols = [{
  name: 'nil',
  fn: (state, name) => []
}, {
  name: 'null',
  fn: (state, name) => null
}, {
  name: 'undefined',
  fn: (state, name) => void 0
}, {
  name: 'true',
  fn: (state, name) => true
}, {
  name: '#true',
  fn: (state, name) => true
}, {
  name: '#t',
  fn: (state, name) => true
}, {
  name: 'false',
  fn: (state, name) => false
}, {
  name: '#false',
  fn: (state, name) => false
}, {
  name: '#f',
  fn: (state, name) => false
}, {
  name: '#Number:Infinity',
  fn: (state, name) => Number.POSITIVE_INFINITY
}, {
  name: '+Infinity',
  fn: (state, name) => Number.POSITIVE_INFINITY
}, {
  name: '-Infinity',
  fn: (state, name) => Number.NEGATIVE_INFINITY
}, {
  name: '#Number:Epsilon',
  fn: (state, name) => Number.EPSILON
}, {
  name: '#Number:MaxValue',
  fn: (state, name) => Number.MAX_VALUE
}, {
  name: '#Number:MinValue',
  fn: (state, name) => Number.MIN_VALUE
}, {
  name: '#Number:MinSafeInteger',
  fn: (state, name) => Number.MAX_SAFE_INTEGER
}, {
  name: '#Number:MinSafeInteger',
  fn: (state, name) => Number.MIN_SAFE_INTEGER
}, {
  name: 'NaN',
  fn: (state, name) => Number.NaN
}];
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (symbols);

/***/ }),

/***/ "./node_modules/liyad/modules/s-exp/operators/core/index.js":
/*!******************************************************************!*\
  !*** ./node_modules/liyad/modules/s-exp/operators/core/index.js ***!
  \******************************************************************/
/*! namespace exports */
/*! export default [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_require__, __webpack_require__.r, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => /* binding */ install
/* harmony export */ });
/* harmony import */ var _core_operator__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./core.operator */ "./node_modules/liyad/modules/s-exp/operators/core/core.operator.js");
/* harmony import */ var _core_macro__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./core.macro */ "./node_modules/liyad/modules/s-exp/operators/core/core.macro.js");
/* harmony import */ var _core_symbol__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./core.symbol */ "./node_modules/liyad/modules/s-exp/operators/core/core.symbol.js");
// Copyright (c) 2018, Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln



function install(config) {
  config.funcs = (config.funcs || []).concat(_core_operator__WEBPACK_IMPORTED_MODULE_0__.operators).concat(config.enableCompilationOperators ? _core_operator__WEBPACK_IMPORTED_MODULE_0__.compilationOperators : []);
  config.macros = (config.macros || []).concat(_core_macro__WEBPACK_IMPORTED_MODULE_1__.macros).concat(config.enableCompilationOperators ? _core_macro__WEBPACK_IMPORTED_MODULE_1__.compilationMacros : []);
  config.symbols = (config.symbols || []).concat(_core_symbol__WEBPACK_IMPORTED_MODULE_2__.default);
  return config;
}

/***/ }),

/***/ "./node_modules/liyad/modules/s-exp/parser.js":
/*!****************************************************!*\
  !*** ./node_modules/liyad/modules/s-exp/parser.js ***!
  \****************************************************/
/*! namespace exports */
/*! export parse [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_require__, __webpack_require__.r, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "parse": () => /* binding */ parse
/* harmony export */ });
/* harmony import */ var _types__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./types */ "./node_modules/liyad/modules/s-exp/types.js");
/* harmony import */ var _ast__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./ast */ "./node_modules/liyad/modules/s-exp/ast.js");
// Copyright (c) 2018, Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln



function isEOF(ch) {
  return typeof ch === 'object' && Object.prototype.hasOwnProperty.call(ch, 'eof');
}

function isSpace(ch) {
  return typeof ch === 'string' && ch.trim().length === 0;
}

function isNumberFirstChar(ch) {
  return typeof ch === 'string' && /^[0-9\+\-]$/.test(ch);
}

function isNumberAfterSignChar(ch) {
  return typeof ch === 'string' && /^[0-9]$/.test(ch);
}

function isSymbolFirstChar(ch) {
  return typeof ch === 'string' && !isSpace(ch) && !isNumberFirstChar(ch);
}

function lookCurrentLineHint(state) {
  return `line: ${state.line} / strings: ${state.index} / pos: ${state.pos} :${state.strings.length > state.index ? state.strings[state.index].slice(state.pos, state.pos + 20) : ''}`;
}

function getChar(state, virtualEof, disableEscape) {
  if (state.strings.length <= state.index) {
    return {
      eof: true
    };
  }

  if (state.strings[state.index].length <= state.pos) {
    if (!state.values || state.values.length <= state.index) {
      state.pos = 0;
      state.index++;
      return getChar(state);
    } else {
      const ch = {
        value: state.values[state.index]
      };
      state.pos = 0;
      state.index++;
      return ch;
    }
  }

  if (virtualEof) {
    for (const v of virtualEof) {
      const ch = state.strings[state.index].slice(state.pos, state.pos + v.length);

      if (ch === v) {
        state.pos += v.length;
        state.line += ch.split('\n').length - 1;
        return {
          eof: false,
          eofSeq: v
        };
      }
    }
  }

  {
    let ch = state.strings[state.index].slice(state.pos, state.pos + 1);
    state.pos++;

    if (ch === '\n') {
      state.line++;
    }

    if (!disableEscape && ch === '\\') {
      if (state.strings[state.index].length <= state.pos) {
        throw new Error(`[SX] getChar: Invalid syntax at: ${lookCurrentLineHint(state)}.`);
      }

      ch = state.strings[state.index].slice(state.pos, state.pos + 1);
      state.pos++;

      switch (ch) {
        case 'b':
          ch = '\b';
          break;

        case 't':
          ch = '\t';
          break;

        case 'n':
          ch = '\n';
          break;

        case 'v':
          ch = '\v';
          break;

        case 'f':
          ch = '\f';
          break;

        case 'r':
          ch = '\r';
          break;

        case 'U':
        case 'u':
          {
            if (state.strings[state.index].slice(state.pos, state.pos + 1) === '{') {
              let ch1 = '';

              for (let i = 0; i < 6; i++) {
                const ch2 = state.strings[state.index].slice(state.pos + i, state.pos + 1 + i);

                if (ch2 === '}') {
                  if (i === 0) {
                    throw new Error(`[SX] getChar: Invalid syntax at: ${lookCurrentLineHint(state)}.`);
                  }

                  state.pos += i;
                  break;
                } else if (!/^[0-9A-Fa-f]{1}$/.test(ch1)) {
                  throw new Error(`[SX] getChar: Invalid syntax at: ${lookCurrentLineHint(state)}.`);
                }

                ch1 += ch2;
              }

              if (state.strings[state.index].slice(state.pos, state.pos + 1) !== '}') {
                throw new Error(`[SX] getChar: Invalid syntax at: ${lookCurrentLineHint(state)}.`);
              }

              state.pos++;
              ch = String.fromCodePoint(Number.parseInt(ch1, 16));
            } else {
              const ch1 = state.strings[state.index].slice(state.pos, state.pos + 4);

              if (!/^[0-9A-Fa-f]{4}$/.test(ch1)) {
                throw new Error(`[SX] getChar: Invalid syntax at: ${lookCurrentLineHint(state)}.`);
              }

              state.pos += 4;
              ch = String.fromCodePoint(Number.parseInt(ch1, 16));
            }
          }
          break;
      }
    }

    return ch;
  }
}

function lookAheads(state, n, virtualEof, disableEscape) {
  const index = state.index;
  const pos = state.pos;
  const line = state.line;
  const chs = [];

  try {
    for (let i = 0; i < n; i++) {
      chs.push(getChar(state, virtualEof, disableEscape));
    }
  } finally {
    state.index = index;
    state.pos = pos;
    state.line = line;
  }

  return chs;
}

function lookAhead(state, virtualEof, disableEscape) {
  const index = state.index;
  const pos = state.pos;
  const line = state.line;
  let ch;

  try {
    ch = getChar(state, virtualEof, disableEscape);
  } finally {
    state.index = index;
    state.pos = pos;
    state.line = line;
  }

  return ch;
}

function skipWhitespaces(state) {
  let ch = lookAhead(state);

  while (!isEOF(ch) && isSpace(ch)) {
    getChar(state);
    ch = lookAhead(state);
  }
}

function parseNumber(state, virtualEof) {
  let s = '';
  let ch = lookAhead(state, virtualEof);

  while (!isEOF(ch)) {
    if (typeof ch === 'string') {
      if (/^0[XxOoBb][0-9]*$/.test(s + ch)) {
        getChar(state, virtualEof);
        s += ch;
      } else if (/^[0-9\+\-\.EeInfinityNaN]+$/.test(s + ch)) {
        getChar(state, virtualEof);
        s += ch;
      } else {
        break;
      }
    } else {
      break;
    }

    ch = lookAhead(state, virtualEof);
  }

  if (!/^([\+\-]?\d*\.?\d+(?:[Ee][\+\-]?\d+)?)|(0[XxOoBb][0-9]+)|([\+\-]Infinity)|(NaN)$/.test(s)) {
    throw new Error(`[SX] parseNumber: Invalid syntax at: ${lookCurrentLineHint(state)}.`);
  }

  return Number(s);
}

function parseSymbol(state, virtualEof) {
  let s = '';
  let ch = lookAhead(state, virtualEof);

  while (!isEOF(ch)) {
    if (typeof ch === 'string') {
      if (isSpace(ch)) {
        break;
      } else if (ch === '#' && lookAheads(state, 2, virtualEof)[1] === '|') {
        break;
      } else if (/^[^.;()"]+$/.test(s + ch)) {
        getChar(state, virtualEof);
        s += ch;
      } else {
        break;
      }
    } else {
      if (typeof ch === 'object' && Object.prototype.hasOwnProperty.call(ch, 'value')) {
        getChar(state, virtualEof);
        const v = ch.value;
        s += String(ch);
      } else {
        throw new Error(`[SX] parseSymbol: Invalid syntax at: ${lookCurrentLineHint(state)}.`);
      }
    }

    ch = lookAhead(state, virtualEof);
  }

  if (state.config.enableShorthands) {
    let m = null; // tslint:disable-next-line:no-conditional-assignment

    if (m = s.match(/^:((?:\:[^=:]+?)+?)=$/)) {
      // ::foo:bar:baz= -> ($splice ($set (foo bar baz)))
      const ws = m[1].slice(1).split(':');
      const z = [{
        symbol: state.config.reservedNames.splice
      }, [{
        symbol: state.config.reservedNames.set
      }, ws]];
      return z;
    } // tslint:disable-next-line:no-conditional-assignment
    else if (m = s.match(/^:((?:\:[^@:]+?)+?)@([^@:]+?)$/)) {
        // ::foo:bar@baz -> ($splice ($call ($get foo bar) baz))
        const ws = m[1].slice(1).split(':');
        const z = [{
          symbol: state.config.reservedNames.splice
        }, [{
          symbol: state.config.reservedNames.call
        }, [{
          symbol: state.config.reservedNames.get
        }, ...ws], {
          symbol: m[2]
        }]];
        return z;
      } // tslint:disable-next-line:no-conditional-assignment
      else if (m = s.match(/^:((?:\:[^:]+?)+?)$/)) {
          // ::foo:bar:baz -> ($get foo bar baz)
          const ws = m[1].slice(1).split(':');
          const z = [{
            symbol: state.config.reservedNames.get
          }, ...ws];
          return z;
        }
  }

  return {
    symbol: s
  };
}

function parseStringOrComment(state, eof, valuesStartSeq, valuesStopChar, disableEscape, allowPhysicalEof) {
  const eofSeqs = valuesStartSeq ? [...eof, valuesStartSeq] : eof;
  const strings = [];
  const values = [];

  for (;;) {
    let s = '';
    let ch = lookAhead(state, eofSeqs, disableEscape);

    while (!isEOF(ch)) {
      if (typeof ch === 'string') {
        getChar(state, eofSeqs, disableEscape);
        s += ch;
      } else {
        if (typeof ch === 'object' && Object.prototype.hasOwnProperty.call(ch, 'value')) {
          getChar(state, eofSeqs, disableEscape);
          const v = ch.value;
          s += String(ch);
        } else {
          throw new Error(`[SX] parseStringOrComment: Invalid syntax at: ${lookCurrentLineHint(state)}.`);
        }
      }

      ch = lookAhead(state, eofSeqs, disableEscape);
    }

    getChar(state, eofSeqs, disableEscape);

    if (ch.eof === true) {
      if (!allowPhysicalEof) {
        throw new _types__WEBPACK_IMPORTED_MODULE_0__.ScriptTerminationError('parseStringOrComment');
      }
    }

    strings.push(s);

    if (ch.eofSeq === valuesStartSeq) {
      values.push(parseList(state, valuesStopChar, []));
    } else {
      break;
    }
  }

  return {
    strings,
    values
  };
}

function parseString(state, disableEscape) {
  return parseStringOrComment(state, ['"'], null, ')', disableEscape, false).strings[0];
}

function parseHereDoc(state, symbol, attrs) {
  const q = [symbol];

  if (attrs) {
    q.push(attrs);
  }

  const inner = parseStringOrComment(state, ['"""'], '%%%(', ')', false, false);

  for (let i = 0; i < inner.strings.length; i++) {
    q.push(inner.strings[i]);

    if (i < inner.values.length) {
      q.push(inner.values[i]);
    }
  }

  return q;
}

function parseSingleLineComment(state) {
  return {
    comment: parseStringOrComment(state, ['\r', '\n'], null, ')', false, true).strings[0]
  };
}

function parseMultiLineComment(state) {
  return {
    comment: parseStringOrComment(state, ['|#'], null, ')', false, false).strings[0]
  };
}

function parseOneToken(state) {
  skipWhitespaces(state);
  let ch = lookAhead(state);

  while (!isEOF(ch)) {
    switch (ch) {
      case ')':
        throw new Error(`[SX] parseOneToken: Invalid syntax at: ${lookCurrentLineHint(state)}.`);

      case '(':
        getChar(state);
        return parseList(state, ')', []);

      case "'":
      case "`":
      case ',':
        {
          getChar(state);
          const ahead = lookAhead(state);
          let isSpliceUnquote = false;

          if (ch === ',' && ahead === '@') {
            getChar(state);
            isSpliceUnquote = true;
          }

          skipWhitespaces(state);
          const ret = (ch === "'" ? _ast__WEBPACK_IMPORTED_MODULE_1__.quote : ch === "`" ? _ast__WEBPACK_IMPORTED_MODULE_1__.backquote : _ast__WEBPACK_IMPORTED_MODULE_1__.wrapByUnquote)(state, parseOneToken(state));
          return isSpliceUnquote ? (0,_ast__WEBPACK_IMPORTED_MODULE_1__.splice)(state, ret) : ret;
        }

      case ".":
        {
          getChar(state);
          const aheads = lookAheads(state, 2);

          if (state.config.enableSpread && aheads[0] === '.' && aheads[1] === '.') {
            getChar(state);
            getChar(state);
            skipWhitespaces(state);
            return (0,_ast__WEBPACK_IMPORTED_MODULE_1__.spread)(state, parseOneToken(state));
          } else {
            skipWhitespaces(state);
            return {
              dotted: parseOneToken(state)
            };
          }
        }

      case ';':
        getChar(state);
        return parseSingleLineComment(state);

      case '#':
        {
          const aheads = lookAheads(state, 2);

          if (aheads[1] === '|') {
            getChar(state);
            getChar(state);
            return parseMultiLineComment(state);
          } else {
            return parseSymbol(state);
          }
        }

      case '"':
        {
          getChar(state);
          const aheads = lookAheads(state, 4);

          if (state.config.enableHereDoc && aheads[0] === '"' && aheads[1] === '"') {
            let isHereDoc = true;

            if (isEOF(aheads[2]) || isSpace(aheads[2])) {// here doc
            } else if (isNumberFirstChar(aheads[2])) {
              // TODO: single +/- char is a symbol.
              if (aheads[2] === '+' || aheads[2] === '-') {
                if (!isNumberAfterSignChar(aheads[3])) {
                  isHereDoc = false;
                }
              } // here doc

            } else if (isSymbolFirstChar(aheads[2])) {
              isHereDoc = false;
            } else {// here doc
            }

            getChar(state);
            getChar(state);
            let sym = null;
            let attrs = null;

            if (isHereDoc) {
              sym = {
                symbol: state.config.reservedNames.Template
              };
            } else {
              sym = parseSymbol(state, ['@']);

              if (sym === null) {
                throw new Error(`[SX] parseOneToken: Invalid syntax at: ${lookCurrentLineHint(state)}.`);
              }

              if (typeof sym === 'number') {
                throw new Error(`[SX] parseOneToken: Invalid syntax at: ${lookCurrentLineHint(state)}.`);
              }

              const ahs = lookAheads(state, 2);

              if (ahs[0] === '@') {
                if (ahs[1] !== '{') {
                  throw new Error(`[SX] parseOneToken: Invalid syntax at: ${lookCurrentLineHint(state)}.`);
                }

                getChar(state);
                getChar(state);
                const a = parseList(state, '}', [{
                  symbol: '@'
                }]);

                if (Array.isArray(a)) {
                  attrs = a;
                }
              }
            }

            return parseHereDoc(state, sym, attrs);
          } else {
            return parseString(state, false);
          }
        }

      case '@':
        if (state.config.enableVerbatimStringLiteral) {
          const aheads = lookAheads(state, 2);

          if (aheads[1] === '"') {
            getChar(state);
            getChar(state);
            return parseString(state, true);
          }
        }

      // FALL_THRU

      default:
        if (typeof ch !== 'string') {
          if (typeof ch === 'object' && Object.prototype.hasOwnProperty.call(ch, 'value')) {
            getChar(state);
            return state.config.wrapExternalValue ? ch : ch.value;
          } else {
            throw new Error(`[SX] parseOneToken: Invalid syntax at: ${lookCurrentLineHint(state)}.`);
          }
        } else if (isSpace(ch)) {
          break;
        } else if (isNumberFirstChar(ch)) {
          // TODO: single +/- char is a symbol.
          if (ch === '+' || ch === '-') {
            const aheads = lookAheads(state, 2);

            if (!isNumberAfterSignChar(aheads[1])) {
              return parseSymbol(state);
            }
          }

          return parseNumber(state);
        } else if (isSymbolFirstChar(ch)) {
          return parseSymbol(state);
        } else {
          throw new Error(`[SX] parseOneToken: Invalid syntax at: ${lookCurrentLineHint(state)}.`);
        }

    }

    skipWhitespaces(state);
    ch = lookAhead(state);
  }

  throw new _types__WEBPACK_IMPORTED_MODULE_0__.ScriptTerminationError('parseOneToken');
}

function parseList(state, listStopChar, initialList) {
  const r = initialList.slice(0);
  let dotted = false;
  skipWhitespaces(state);
  let ch = lookAhead(state);

  while (!isEOF(ch)) {
    switch (ch) {
      case listStopChar:
        getChar(state);

        if (dotted) {
          return r[0];
        } else {
          return r;
        }

      default:
        {
          const t = parseOneToken(state);

          if (typeof t === 'object' && Object.prototype.hasOwnProperty.call(t, 'dotted')) {
            if (r.length !== 1) {
              throw new Error(`[SX] parseList: Invalid syntax at: ${lookCurrentLineHint(state)}.`);
            }

            dotted = true;

            if (Array.isArray(t)) {
              t.unshift(r.pop());
              r.push(t);
            } else {
              r.push({
                car: r.pop(),
                cdr: t.dotted
              });
            }
          } else if (typeof t === 'object' && Object.prototype.hasOwnProperty.call(t, 'comment')) {
            if (!state.config.stripComments) {
              r.push(t);
            }
          } else {
            if (dotted) {
              throw new Error(`[SX] parseList: Invalid syntax at: ${lookCurrentLineHint(state)}.`);
            }

            r.push(t);
          }
        }
        break;
    }

    skipWhitespaces(state);
    ch = lookAhead(state);
  }

  throw new _types__WEBPACK_IMPORTED_MODULE_0__.ScriptTerminationError('parseList');
}

function parse(state) {
  const r = [];
  skipWhitespaces(state);
  let ch = lookAhead(state);

  while (!isEOF(ch)) {
    switch (ch) {
      case '(':
        getChar(state);
        r.push(parseList(state, ')', []));
        break;

      case "'":
      case "`":
        {
          getChar(state);
          skipWhitespaces(state);

          for (;;) {
            const t = parseOneToken(state);

            if (typeof t === 'object' && Object.prototype.hasOwnProperty.call(t, 'comment')) {
              if (!state.config.stripComments) {
                r.push(t);
              }
            } else {
              r.push((ch === "'" ? _ast__WEBPACK_IMPORTED_MODULE_1__.quote : _ast__WEBPACK_IMPORTED_MODULE_1__.backquote)(state, t));
              break;
            }
          }

          break;
        }

      case ';':
        getChar(state);

        if (state.config.stripComments) {
          parseSingleLineComment(state);
        } else {
          r.push(parseSingleLineComment(state));
        }

        break;

      case '#':
        {
          const aheads = lookAheads(state, 2);

          if (aheads[1] === '|') {
            getChar(state);
            getChar(state);

            if (state.config.stripComments) {
              parseMultiLineComment(state);
            } else {
              r.push(parseMultiLineComment(state));
            }
          } else {
            getChar(state);

            if (state.config.stripComments) {
              parseSingleLineComment(state);
            } else {
              r.push(parseSingleLineComment(state));
            }
          }
        }
        break;

      case '"':
        {
          const aheads = lookAheads(state, 3);

          if (aheads[1] === '"' && aheads[2] === '"') {
            r.push(parseOneToken(state));
            break;
          }
        }
      // FALL_THRU

      default:
        throw new Error(`[SX] parseInitialState: Invalid syntax at: ${lookCurrentLineHint(state)}.`);
    }

    skipWhitespaces(state);
    ch = lookAhead(state);
  }

  return r;
}

/***/ }),

/***/ "./node_modules/liyad/modules/s-exp/types.js":
/*!***************************************************!*\
  !*** ./node_modules/liyad/modules/s-exp/types.js ***!
  \***************************************************/
/*! namespace exports */
/*! export FatalError [provided] [no usage info] [missing usage info prevents renaming] */
/*! export MaxEvaluationCountError [provided] [no usage info] [missing usage info prevents renaming] */
/*! export ScriptTerminationError [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_require__.r, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "FatalError": () => /* binding */ FatalError,
/* harmony export */   "MaxEvaluationCountError": () => /* binding */ MaxEvaluationCountError,
/* harmony export */   "ScriptTerminationError": () => /* binding */ ScriptTerminationError
/* harmony export */ });
// Copyright (c) 2018, Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln
class FatalError extends Error {
  constructor(message) {
    super(message);
  }

}
class MaxEvaluationCountError extends FatalError {
  constructor() {
    super(`[SX] evaluate: The maximum count of evaluations has been exceeded.`);
  }

}
class ScriptTerminationError extends FatalError {
  constructor(where) {
    super(`[SX] ${where}: Unexpected termination of script.`);
  }

}

/***/ }),

/***/ "./src/cli.ts":
/*!********************!*\
  !*** ./src/cli.ts ***!
  \********************/
/*! flagged exports */
/*! export __esModule [provided] [maybe used in spec (runtime-defined)] [usage prevents renaming] */
/*! other exports [not provided] [maybe used in spec (runtime-defined)] */
/*! runtime requirements: __webpack_exports__, __webpack_require__ */
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

 // Copyright (c) 2019 Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln

Object.defineProperty(exports, "__esModule", ({
  value: true
}));

const cli_1 = __webpack_require__(/*! ./lib/cli */ "./src/lib/cli.ts");

cli_1.run(process.argv);

/***/ }),

/***/ "./src/codegen.ts":
/*!************************!*\
  !*** ./src/codegen.ts ***!
  \************************/
/*! unknown exports (runtime-defined) */
/*! runtime requirements: top-level-this-exports, __webpack_exports__, __webpack_require__ */
/*! CommonJS bailout: this is used directly at 5:22-26 */
/*! CommonJS bailout: this is used directly at 18:19-23 */
/*! CommonJS bailout: exports is used directly at 26:50-57 */
/*! CommonJS bailout: exports is used directly at 28:51-58 */
/*! CommonJS bailout: exports is used directly at 30:46-53 */
/*! CommonJS bailout: exports is used directly at 32:47-54 */
/*! CommonJS bailout: exports is used directly at 34:46-53 */
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

 // Copyright (c) 2019 Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function () {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __exportStar = this && this.__exportStar || function (m, exports) {
  for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};

Object.defineProperty(exports, "__esModule", ({
  value: true
}));

__exportStar(__webpack_require__(/*! ./lib/codegen/typescript */ "./src/lib/codegen/typescript.ts"), exports);

__exportStar(__webpack_require__(/*! ./lib/codegen/json-schema */ "./src/lib/codegen/json-schema.ts"), exports);

__exportStar(__webpack_require__(/*! ./lib/codegen/proto3 */ "./src/lib/codegen/proto3.ts"), exports);

__exportStar(__webpack_require__(/*! ./lib/codegen/graphql */ "./src/lib/codegen/graphql.ts"), exports);

__exportStar(__webpack_require__(/*! ./lib/codegen/csharp */ "./src/lib/codegen/csharp.ts"), exports);

/***/ }),

/***/ "./src/compiler.ts":
/*!*************************!*\
  !*** ./src/compiler.ts ***!
  \*************************/
/*! flagged exports */
/*! export __esModule [provided] [no usage info] [missing usage info prevents renaming] */
/*! export compile [provided] [no usage info] [missing usage info prevents renaming] */
/*! export parse [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_exports__, __webpack_require__ */
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

 // Copyright (c) 2019 Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.compile = exports.parse = void 0;

const types_1 = __webpack_require__(/*! fruitsconfits/modules/lib/types */ "./node_modules/fruitsconfits/modules/lib/types.js");

const parser_1 = __webpack_require__(/*! fruitsconfits/modules/lib/parser */ "./node_modules/fruitsconfits/modules/lib/parser.js");

const core_1 = __webpack_require__(/*! liyad/modules/s-exp/operators/core */ "./node_modules/liyad/modules/s-exp/operators/core/index.js");

const interpreters_1 = __webpack_require__(/*! liyad/modules/s-exp/interpreters */ "./node_modules/liyad/modules/s-exp/interpreters/index.js");

const defaults_1 = __webpack_require__(/*! liyad/modules/s-exp/defaults */ "./node_modules/liyad/modules/s-exp/defaults.js");

const operators = __webpack_require__(/*! ./operators */ "./src/operators.ts");

const resolver_1 = __webpack_require__(/*! ./lib/resolver */ "./src/lib/resolver.ts");

const protection_1 = __webpack_require__(/*! ./lib/protection */ "./src/lib/protection.ts");

const compiler_1 = __webpack_require__(/*! ./lib/compiler */ "./src/lib/compiler.ts");

function parseExternalDirective(s) {
  const z = compiler_1.externalTypeDef(types_1.parserInput(s, {
    /* TODO: set initial state to the context */
  }));

  if (!z.succeeded) {
    throw new Error('Invalid external directive.');
  }

  return z.tokens;
}

function parse(s) {
  const z = compiler_1.program(types_1.parserInput(s, {
    /* TODO: set initial state to the context */
  }));

  if (!z.succeeded) {
    throw new Error(parser_1.formatErrorMessage(z));
  }

  return z.tokens;
}

exports.parse = parse;

const lisp = (() => {
  let config = Object.assign({}, defaults_1.defaultConfig);
  config.reservedNames = Object.assign({}, config.reservedNames, {
    Template: '$concat'
  });
  config = core_1.default(config);
  config.stripComments = true;
  return interpreters_1.SExpression(config);
})(); // tslint:disable: object-literal-key-quotes


function compile(s) {
  const mapTyToTySet = new Map();
  const schema = new Map();
  let gensymCount = 0;

  const def = (name, ty) => {
    let ret = ty;
    const sym = typeof name === 'string' ? name : name.symbol;

    if (protection_1.isUnsafeVarNames(protection_1.dummyTargetObject, sym)) {
      throw new Error(`Unsafe symbol name is appeared: ${sym}`);
    }

    if (!mapTyToTySet.has(ret)) {
      const originalTypeName = ret.typeName;
      ret = operators.withName(operators.withTypeName(originalTypeName ? operators.withOriginalTypeName(ret, originalTypeName) : ret, sym), sym);
    }

    const tySet = mapTyToTySet.has(ret) ? mapTyToTySet.get(ret) : {
      ty: ret,
      exported: false,
      isDeclare: false,
      resolved: false
    };
    schema.set(sym, tySet);

    if (!mapTyToTySet.has(ret)) {
      // TODO: aliases are not exported correctly
      mapTyToTySet.set(ret, tySet);
    }

    return ret;
  };

  const ref = (name, ...memberNames) => {
    const sym = typeof name === 'string' ? name : name.symbol;

    if (protection_1.isUnsafeVarNames(protection_1.dummyTargetObject, sym)) {
      throw new Error(`Unsafe symbol name is appeared: ${sym}`);
    }

    const memberTreeSymbols = memberNames.map(x => {
      const ms = typeof x === 'string' ? x : x.symbol;

      if (protection_1.isUnsafeVarNames(protection_1.dummyTargetObject, ms)) {
        throw new Error(`Unsafe symbol name is appeared: ${ms}`);
      }

      return ms;
    });

    if (!schema.has(sym)) {
      return Object.assign({
        kind: 'symlink',
        symlinkTargetName: sym,
        name: sym,
        typeName: sym
      }, 0 < memberTreeSymbols.length ? {
        memberTree: memberTreeSymbols
      } : {});
    }

    let ty = resolver_1.resolveMemberNames(schema.get(sym).ty, sym, memberTreeSymbols, 0);

    if (ty.noOutput) {
      ty = Object.assign({}, ty);
      delete ty.noOutput;
    }

    return ty;
  };

  const redef = (original, ty) => {
    if (original === ty) {
      return ty;
    } // NOTE: 'ty' should already be registered to 'mapTyToTySet' and 'schema'


    const tySet = mapTyToTySet.has(original) ? mapTyToTySet.get(original) : {
      ty: original,
      exported: false,
      isDeclare: false,
      resolved: false
    };
    tySet.ty = ty;
    mapTyToTySet.set(tySet.ty, tySet);

    if (ty.name) {
      schema.set(ty.name, tySet);
    }

    return tySet.ty;
  };

  const exported = ty => {
    if (ty.kind === 'never' && typeof ty.passThruCodeBlock === 'string') {
      ty.passThruCodeBlock = `export ${ty.passThruCodeBlock}`;
      return ty;
    } else {
      // NOTE: 'ty' should already be registered to 'mapTyToTySet' and 'schema'
      const tySet = mapTyToTySet.has(ty) ? mapTyToTySet.get(ty) : {
        ty,
        exported: false,
        isDeclare: false,
        resolved: false
      };
      tySet.exported = true;
      return ty;
    }
  };

  const external = (...names) => {
    for (const name of names) {
      let ty = null;

      if (typeof name === 'string') {
        ty = def(name, operators.primitive('any'));
      } else {
        ty = def(name[0], name[1] ? name[1] : operators.primitive('any'));
      }

      ty.noOutput = true;
    }
  };

  const asConst = ty => {
    switch (ty.kind) {
      case 'enum':
        // NOTE: `ty` may already `def`ed.
        ty.isConst = true;
        break;

      default:
        throw new Error(`It cannot set to const: ${ty.kind} ${ty.typeName || '(unnamed)'}`);
    }

    return ty;
  };

  const asDeclare = ty => {
    // NOTE: 'ty' should already be registered to 'mapTyToTySet' and 'schema'
    const tySet = mapTyToTySet.has(ty) ? mapTyToTySet.get(ty) : {
      ty,
      exported: false,
      isDeclare: false,
      resolved: false
    };
    tySet.isDeclare = true;
    return ty;
  };

  const passthru = (str, docCommentText) => {
    const ty = {
      kind: 'never',
      passThruCodeBlock: str || ''
    };

    if (docCommentText) {
      ty.docComment = docCommentText;
    }

    schema.set(`__$$$gensym_${gensymCount++}$$$__`, {
      ty,
      exported: false,
      isDeclare: false,
      resolved: false
    });
    return ty;
  };

  const directive = (name, body) => {
    switch (name) {
      case '@tynder-external':
        lisp.evaluateAST(parseExternalDirective(`external ${body} ;`));
        break;

      case '@tynder-pass-through':
        passthru(body);
        break;

      default:
        throw new Error(`Unknown directive is appeared: ${name}`);
    }

    return [];
  };

  lisp.setGlobals({
    picked: operators.picked,
    omit: operators.omit,
    partial: operators.partial,
    intersect: operators.intersect,
    oneOf: operators.oneOf,
    subtract: operators.subtract,
    primitive: operators.primitive,
    primitiveValue: operators.primitiveValue,
    optional: operators.optional,
    repeated: operators.repeated,
    sequenceOf: operators.sequenceOf,
    spread: operators.spread,
    enumType: operators.enumType,
    objectType: operators.objectType,
    derived: operators.derived,
    def,
    ref,
    redef,
    export: exported,
    external,
    asConst,
    asDeclare,
    passthru,
    directive,
    docComment: operators.withDocComment,
    '@range': (minValue, maxValue) => ty => operators.withRange(minValue, maxValue)(ty),
    '@minValue': minValue => ty => operators.withMinValue(minValue)(ty),
    '@maxValue': maxValue => ty => operators.withMaxValue(maxValue)(ty),
    '@greaterThan': greaterThan => ty => operators.withGreaterThan(greaterThan)(ty),
    '@lessThan': lessThan => ty => operators.withLessThan(lessThan)(ty),
    '@minLength': minLength => ty => operators.withMinLength(minLength)(ty),
    '@maxLength': maxLength => ty => operators.withMaxLength(maxLength)(ty),
    '@match': pattern => ty => operators.withMatch(pattern)(ty),
    '@stereotype': stereotype => ty => operators.withStereotype(stereotype)(ty),
    '@constraint': (name, args) => ty => operators.withConstraint(name, args)(ty),
    '@forceCast': () => ty => operators.withForceCast()(ty),
    '@recordType': () => ty => operators.withRecordType()(ty),
    '@meta': meta => ty => operators.withMeta(meta)(ty),
    '@msg': messages => ty => operators.withMsg(messages)(ty),
    '@msgId': messageId => ty => operators.withMsgId(messageId)(ty)
  });
  const z = parse(s);
  lisp.evaluateAST(z);
  return resolver_1.resolveSchema(schema);
}

exports.compile = compile; // tslint:enable: object-literal-key-quotes

/***/ }),

/***/ "./src/lib/cli.ts":
/*!************************!*\
  !*** ./src/lib/cli.ts ***!
  \************************/
/*! flagged exports */
/*! export __esModule [provided] [no usage info] [missing usage info prevents renaming] */
/*! export printHelp [provided] [no usage info] [missing usage info prevents renaming] */
/*! export run [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_exports__, __webpack_require__ */
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

 // Copyright (c) 2019 Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.run = exports.printHelp = void 0;

const fs = __webpack_require__(/*! fs */ "fs");

const path = __webpack_require__(/*! path */ "path");

const compiler_1 = __webpack_require__(/*! ../compiler */ "./src/compiler.ts");

const serializer_1 = __webpack_require__(/*! ../serializer */ "./src/serializer.ts");

const codegen_1 = __webpack_require__(/*! ../codegen */ "./src/codegen.ts");

function compileTo(fn, srcDir, destDir, options) {
  if (!fs.existsSync(destDir)) {
    fs.mkdirSync(destDir, {
      recursive: true
    });
  }

  if (fs.lstatSync(srcDir).isDirectory()) {
    const files = fs.readdirSync(srcDir);

    for (const entry of files) {
      const srcEntryPath = path.join(srcDir, entry);

      if (fs.lstatSync(srcEntryPath).isDirectory()) {
        compileTo(fn, srcEntryPath, path.join(destDir, entry), options);
      } else {
        if (entry.toLowerCase().endsWith(options.srcExt)) {
          const code = fs.readFileSync(srcEntryPath, {
            encoding: 'utf8'
          });
          let trans = '';

          try {
            const typeMap = compiler_1.compile(code);
            trans = fn(typeMap);
          } catch (error) {
            throw SyntaxError(`${srcEntryPath} - ${error.message}`);
          }

          fs.writeFileSync(path.join(destDir, entry.slice(0, -options.srcExt.length) + options.destExt), trans, {
            encoding: 'utf8'
          });
        }
      }
    }
  }
}

function compileToTynderCompiled(srcDir, destDir, options) {
  const opts = Object.assign({}, {
    srcExt: '.tss',
    destExt: '.json'
  }, options || {});
  return compileTo(serializer_1.serialize, srcDir, destDir, opts);
}

function compileToTynderCompiledAsTs(srcDir, destDir, options) {
  const opts = Object.assign({}, {
    srcExt: '.tss',
    destExt: '.ts'
  }, options || {});
  return compileTo(types => serializer_1.serialize(types, true), srcDir, destDir, opts);
}

function compileToTypeScript(srcDir, destDir, options) {
  const opts = Object.assign({}, {
    srcExt: '.tss',
    destExt: '.d.ts'
  }, options || {});
  return compileTo(codegen_1.generateTypeScriptCode, srcDir, destDir, opts);
}

function compileToJsonSchema(srcDir, destDir, options) {
  const opts = Object.assign({}, {
    srcExt: '.tss',
    destExt: '.json'
  }, options || {});
  return compileTo(codegen_1.generateJsonSchema, srcDir, destDir, opts);
}

function compileToJsonSchemaAsTs(srcDir, destDir, options) {
  const opts = Object.assign({}, {
    srcExt: '.tss',
    destExt: '.ts'
  }, options || {});
  return compileTo(types => codegen_1.generateJsonSchema(types, true), srcDir, destDir, opts);
}

function compileToProto3(srcDir, destDir, options) {
  const opts = Object.assign({}, {
    srcExt: '.tss',
    destExt: '.proto'
  }, options || {});
  return compileTo(codegen_1.generateProto3Code, srcDir, destDir, opts);
}

function compileToGraphQl(srcDir, destDir, options) {
  const opts = Object.assign({}, {
    srcExt: '.tss',
    destExt: '.graphql'
  }, options || {});
  return compileTo(codegen_1.generateGraphQlCode, srcDir, destDir, opts);
}

function compileToCSharp(srcDir, destDir, options) {
  const opts = Object.assign({}, {
    srcExt: '.tss',
    destExt: '.cs'
  }, options || {});
  return compileTo(codegen_1.generateCSharpCode, srcDir, destDir, opts);
}

function printHelp() {
  console.log(`tynder - TypeScript friendly Data validator for JavaScript.

Usage:
  tynder subcommand options...

Subcommands:
  help
      Show this help.
  compile
      Compile schema and output as JSON files.
          * default input file extension is *.tss
          * default output file extension is *.json
  compile-as-ts
      Compile schema and output as JavaScript|TypeScript files.
          * default input file extension is *.tss
          * default output file extension is *.ts
      Generated code is:
          const schema = {...};
          export default schema;
  gen-ts
      Compile schema and generate TypeScript type definition files.
          * default input file extension is *.tss
          * default output file extension is *.d.ts
  gen-json-schema
      Compile schema and generate 'JSON Schema' files.
          * default input file extension is *.tss
          * default output file extension is *.json
  gen-json-schema-as-ts
      Compile schema and generate 'JSON Schema'
      as JavaScript|TypeScript files.
          * default input file extension is *.tss
          * default output file extension is *.ts
      Generated code is:
          const schema = {...};
          export default schema;
  gen-csharp
      Compile schema and generate 'C#' type definition files.
          * default input file extension is *.tss
          * default output file extension is *.cs
  gen-proto3
      Compile schema and generate 'Protocol Buffers 3' type definition files.
          * default input file extension is *.tss
          * default output file extension is *.proto
  gen-graphql
      Compile schema and generate 'GraphQL' type definition files.
          * default input file extension is *.tss
          * default output file extension is *.graphql

Options:
  --indir dirname
      Input directory
  --outdir dirname
      Output directory
  --inext fileExtensionName
      Input files' extension
  --outext fileExtensionName
      Output files' extension

`);
}

exports.printHelp = printHelp;

function run(argv) {
  let inDir = null;
  let outDir = null;
  let inExt = null;
  let outExt = null;

  if (argv.length < 3) {
    printHelp();
    process.exit(0);
  }

  try {
    for (let i = 3; i < argv.length; i++) {
      switch (argv[i]) {
        case '--indir':
          i++;

          if (argv.length <= i) {
            throw new Error(`Parameters are too short: ${argv[i]}.`);
          }

          inDir = argv[i];
          break;

        case '--outdir':
          i++;

          if (argv.length <= i) {
            throw new Error(`Parameters are too short: ${argv[i]}.`);
          }

          outDir = argv[i];
          break;

        case '--inext':
          i++;

          if (argv.length <= i) {
            throw new Error(`Parameters are too short: ${argv[i]}.`);
          }

          inExt = argv[i];
          break;

        case '--outext':
          i++;

          if (argv.length <= i) {
            throw new Error(`Parameters are too short: ${argv[i]}.`);
          }

          outExt = argv[i];
          break;

        default:
          throw new Error(`Unknown option: ${argv[i]}.`);
      }
    }

    if (!inDir) {
      throw new Error(`"--indir" is not set.`);
    }

    if (!outDir) {
      throw new Error(`"--indir" is not set.`);
    }

    const options = {};

    if (inExt) {
      options.srcExt = inExt;
    }

    if (outExt) {
      options.destExt = outExt;
    }

    switch (argv[2]) {
      case 'compile':
        compileToTynderCompiled(inDir, outDir, options);
        break;

      case 'compile-as-ts':
        compileToTynderCompiledAsTs(inDir, outDir, options);
        break;

      case 'gen-ts':
        compileToTypeScript(inDir, outDir, options);
        break;

      case 'gen-json-schema':
        compileToJsonSchema(inDir, outDir, options);
        break;

      case 'gen-json-schema-as-ts':
        compileToJsonSchemaAsTs(inDir, outDir, options);
        break;

      case 'gen-proto3':
        compileToProto3(inDir, outDir, options);
        break;

      case 'gen-graphql':
        compileToGraphQl(inDir, outDir, options);
        break;

      case 'gen-csharp':
        compileToCSharp(inDir, outDir, options);
        break;

      case 'help':
        printHelp();
        process.exit(0);

      default:
        throw new Error(`Unknown subcommand: ${argv[0]}.`);
    }
  } catch (e) {
    console.error(e.message);
    printHelp();
    process.exit(-1);
  }
}

exports.run = run;

/***/ }),

/***/ "./src/lib/codegen/csharp.ts":
/*!***********************************!*\
  !*** ./src/lib/codegen/csharp.ts ***!
  \***********************************/
/*! flagged exports */
/*! export __esModule [provided] [no usage info] [missing usage info prevents renaming] */
/*! export generateCSharpCode [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_exports__, __webpack_require__ */
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

 // Copyright (c) 2020 Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.generateCSharpCode = void 0;

const escape_1 = __webpack_require__(/*! ../../lib/escape */ "./src/lib/escape.ts");

const util_1 = __webpack_require__(/*! ./../util */ "./src/lib/util.ts");

function formatTypeName(ty, ctx, typeName) {
  if (typeName.includes('.') || ty.kind === 'symlink' || ty.kind === 'enum') {
    return generateCSharpCodeInner(ty, false, ctx);
  }

  return typeName;
}

function formatCSharpCodeDocComment(ty, nestLevel) {
  let code = '';
  const indent = '    '.repeat(nestLevel);
  const docComment = typeof ty === 'string' ? ty : ty.docComment;

  if (docComment) {
    if (0 <= docComment.indexOf('\n')) {
      code += `${indent}/**\n${indent}  ${docComment.split('\n').map(x => x.trimLeft()).join(`\n${indent} `)}\n${indent} */\n`;
    } else {
      code += `${indent}/** ${docComment} */\n`;
    }
  }

  return code;
}

function formatMemberType(ty, ctx) {
  if (ty.typeName) {
    return formatTypeName(ty, ctx, ty.typeName);
  } else {
    switch (ty.kind) {
      case 'primitive':
        return generateCSharpCodePrimitive(ty, ctx);

      case 'primitive-value':
        return generateCSharpCodePrimitiveValue(ty, ctx);

      case 'repeated':
        return generateCSharpCodeRepeated(ty, ctx);

      case 'one-of':
        return generateCSharpCodeOneOf(ty, ctx);

      default:
        return 'object';
    }
  }
}

function appendOptionalModifier(name) {
  switch (name) {
    case 'decimal':
    case 'int':
    case 'double':
    case 'bool':
      return `${name}?`;

    default:
      return name;
  }
}

function isNullableOneOf(ty, ctx) {
  const filtered = ty.oneOf.filter(x => !(x.kind === 'primitive' && (x.primitiveName === 'null' || x.primitiveName === 'undefined') || x.kind === 'primitive-value' && (x.value === null || x.value === void 0)));
  return filtered.length === 1 && ty.oneOf.length !== 1 ? filtered[0] : null;
}

function generateCSharpCodePrimitive(ty, ctx) {
  // TODO: Function, DateStr, DateTimeStr
  switch (ty.primitiveName) {
    case 'null':
    case 'undefined':
      return 'object';

    case 'integer':
      return 'int';

    case 'bigint':
      return 'decimal';

    case 'number':
      return 'double';

    case 'boolean':
      return 'bool';

    default:
      return ty.primitiveName;
  }
}

function generateCSharpCodePrimitiveValue(ty, ctx) {
  if (ty.value === null || ty.value === void 0) {
    return 'object';
  }

  switch (typeof ty.primitiveName) {
    case 'bigint':
      return 'decimal';

    default:
      switch (typeof ty.value) {
        case 'number':
          return 'double';

        case 'string':
          return 'string';

        case 'boolean':
          return 'bool';

        default:
          return 'object';
      }

  }
}

function generateCSharpCodeRepeated(ty, ctx) {
  return `${formatMemberType(ty.repeated, ctx)}[]`;
}

function generateCSharpCodeSpread(ty, ctx) {
  return '';
}

function generateCSharpCodeSequence(ty, ctx) {
  return 'object[]';
}

function generateCSharpCodeOneOf(ty, ctx) {
  const z = isNullableOneOf(ty, ctx);

  if (z) {
    return appendOptionalModifier(formatMemberType(z, ctx));
  } else {
    return 'object';
  }
}

function generateCSharpCodeOptional(ty, ctx) {
  return appendOptionalModifier(generateCSharpCodeInner(ty.optional, false, ctx));
}

function generateCSharpCodeEnum(ty, ctx) {
  return 'object';
}

function addAttributes(ty, ctx, typeName) {
  const attrs = [];
  let ty2 = ty;

  if (ty2.kind !== 'optional') {
    switch (typeName) {
      case 'decimal':
      case 'int':
      case 'double':
      case 'bool':
        break;

      default:
        if (ty2.kind === 'one-of') {
          if (!isNullableOneOf(ty2, ctx)) {
            attrs.push('Required');
          }
        } else {
          attrs.push('Required');
        }

        break;
    }

    ty2 = ty;
  }

  switch (ty2.kind) {
    case 'primitive':
      {
        if (typeof ty2.minLength === 'number') {
          attrs.push(`MinLength(${ty2.minLength})`);
        }

        if (typeof ty2.maxLength === 'number') {
          attrs.push(`MaxLength(${ty2.maxLength})`);
        }

        if (ty2.minValue !== null && ty2.minValue !== void 0 || ty2.maxValue !== null && ty2.maxValue !== void 0) {
          switch (ty2.primitiveName) {
            case 'string':
              attrs.push(`Range(typeof(string), "${util_1.nvl2(ty2.minValue, x => escape_1.escapeString(x), '')}", "${util_1.nvl2(ty2.maxValue, x => escape_1.escapeString(x), '\\U00010FFFF')}")`);
              break;

            case 'bigint':
              attrs.push(`Range(typeof(decimal), ${util_1.nvl2(ty2.minValue, x => `new decimal(@"${String(x)}").ToString()`, 'Decimal.MinValue')}, ${util_1.nvl2(ty2.maxValue, x => `new decimal(@"${String(x)}").ToString()`, 'Decimal.MaxValue')})`);
              break;

            case 'integer':
              attrs.push(`Range(${util_1.nvl2(ty2.minValue, x => `(int)${String(x)}`, 'Int32.MinValue')}, ${util_1.nvl2(ty2.maxValue, x => `(int)${String(x)}`, 'Int32.MaxValue')})`);
              break;

            case 'number':
              attrs.push(`Range(${util_1.nvl2(ty2.minValue, x => `(double)${String(x)}`, 'Double.MinValue')}, ${util_1.nvl2(ty2.maxValue, x => `(double)${String(x)}`, 'Double.MaxValue')})`);
              break;
          }
        }

        if (ty2.pattern) {
          attrs.push(`RegularExpression(@"${ty2.pattern.source.replace(/"/g, '""')}")`);
        }
      }
      break;

    case 'repeated':
      {
        if (typeof ty2.min === 'number') {
          attrs.push(`MinLength(${ty2.min})`);
        }

        if (typeof ty2.max === 'number') {
          attrs.push(`MaxLength(${ty2.max})`);
        }
      }
      break;
  }

  if (0 < attrs.length) {
    return `[${attrs.join(', ')}]\n${'    '.repeat(ctx.nestLevel + 1)}`;
  } else {
    return '';
  }
}

function generateCSharpCodeObject(ty, isInterface, ctx) {
  const sep = '\n\n';
  const memberLines = ty.members.filter(x => !x[2]).map(x => {
    const typeName = x[1].typeName ? formatTypeName(x[1], Object.assign(Object.assign({}, ctx), {
      nestLevel: ctx.nestLevel + 1
    }), x[1].typeName) : generateCSharpCodeInner(x[1], false, Object.assign(Object.assign({}, ctx), {
      nestLevel: ctx.nestLevel + 1
    }));
    return `${formatCSharpCodeDocComment(x[3] || '', ctx.nestLevel + 1)}${'    '.repeat(ctx.nestLevel + 1)}${addAttributes(x[1], ctx, typeName)}public ${typeName} ${x[0]} { get; set; }`;
  });

  if (memberLines.length === 0) {
    return `\n${'    '.repeat(ctx.nestLevel)}{\n${'    '.repeat(ctx.nestLevel)}}`;
  }

  return `\n${'    '.repeat(ctx.nestLevel)}{\n${memberLines.join(sep)}\n${'    '.repeat(ctx.nestLevel)}}`;
}

function generateCSharpCodeInner(ty, isInterface, ctx) {
  var _a;

  switch (ty.kind) {
    case 'never':
    case 'any':
    case 'unknown':
      return 'object';

    case 'primitive':
      return generateCSharpCodePrimitive(ty, ctx);

    case 'primitive-value':
      return generateCSharpCodePrimitiveValue(ty, ctx);

    case 'repeated':
      return generateCSharpCodeRepeated(ty, ctx);

    case 'spread':
      return generateCSharpCodeSpread(ty, ctx);

    case 'sequence':
      return generateCSharpCodeSequence(ty, ctx);

    case 'one-of':
      return generateCSharpCodeOneOf(ty, ctx);

    case 'optional':
      return generateCSharpCodeOptional(ty, ctx);

    case 'enum':
      return generateCSharpCodeEnum(ty, ctx);

    case 'object':
      return generateCSharpCodeObject(ty, isInterface, ctx);

    case 'symlink':
      if ((_a = ctx.schema) === null || _a === void 0 ? void 0 : _a.has(ty.symlinkTargetName)) {
        const target = ctx.schema.get(ty.symlinkTargetName);

        switch (target === null || target === void 0 ? void 0 : target.ty.kind) {
          case 'enum':
            return 'object';
        }
      }

      return ty.symlinkTargetName;

    case 'operator':
      throw new Error(`Unexpected type assertion: ${ty.kind}`);

    default:
      throw new Error(`Unknown type assertion: ${ty.kind}`);
  }
}

function generateCSharpCode(schema) {
  let code = `using System.ComponentModel.DataAnnotations;

namespace Tynder.UserSchema
{
`;
  const ctx = {
    nestLevel: 1,
    schema
  };

  for (const ty of schema.entries()) {
    const indent0 = '    '.repeat(ctx.nestLevel);

    if (ty[1].ty.kind === 'object') {// nothing to do
    } else if (ty[1].ty.kind === 'enum') {// nothing to do
    } else if (ty[1].ty.kind === 'never' && ty[1].ty.passThruCodeBlock) {// nothing to do
    } else {
      code += formatCSharpCodeDocComment(ty[1].ty, ctx.nestLevel);
      let tyName = 'System.Object';

      switch (ty[1].ty.kind) {
        case 'primitive':
          switch (ty[1].ty.primitiveName) {
            case 'integer':
              tyName = 'System.Int32';
              break;

            case 'bigint':
              tyName = 'System.Decimal';
              break;

            case 'number':
              tyName = 'System.Double';
              break;

            case 'boolean':
              tyName = 'System.Boolean';
              break;

            case 'string':
              tyName = 'System.String';
              break;
          }

          break;

        case 'primitive-value':
          if (ty[1].ty.value !== null && ty[1].ty.value !== void 0) {
            switch (typeof ty[1].ty.primitiveName) {
              case 'bigint':
                tyName = 'System.Decimal';
                break;

              default:
                switch (typeof ty[1].ty.value) {
                  case 'number':
                    tyName = 'System.Double';
                    break;

                  case 'boolean':
                    tyName = 'System.Boolean';
                    break;

                  case 'string':
                    tyName = 'System.String';
                    break;
                }

            }
          }

          break;
      }

      code += `${indent0}using ${ty[0]} = ${tyName};\n\n`;
    }
  }

  let isFirst = true;

  for (const ty of schema.entries()) {
    const accessModifier = ty[1].exported ? 'public' : 'public';
    const indent0 = '    '.repeat(ctx.nestLevel);
    const indent1 = '    '.repeat(ctx.nestLevel + 1);

    if (ty[1].ty.kind === 'object' || ty[1].ty.kind === 'enum') {
      if (isFirst) {
        isFirst = false;
        code += '\n';
      } else {
        code += '\n\n';
      }

      code += formatCSharpCodeDocComment(ty[1].ty, ctx.nestLevel);
    }

    if (ty[1].ty.kind === 'object') {
      code += `${indent0}${accessModifier} class ${ty[0]}${ty[1].ty.baseTypes && ty[1].ty.baseTypes.length ? ` : ${ty[1].ty.baseTypes.filter(x => x.typeName).map(x => formatTypeName(x, Object.assign(Object.assign({}, ctx), {
        nestLevel: ctx.nestLevel + 1
      }), x.typeName)).join(', ')}` : ''} ${generateCSharpCodeInner(ty[1].ty, true, ctx)}\n`;
    } else if (ty[1].ty.kind === 'enum') {
      let value = 0;
      code += `${indent0}${accessModifier} static class ${ty[0]}\n${indent0}{\n${ty[1].ty.values.map(x => `${formatCSharpCodeDocComment(x[2] || '', ctx.nestLevel + 1)}${indent1}${(() => {
        if (value !== null && x[1] === value) {
          value++;
          return `public static double ${x[0]} { get { return ${x[1]}; } }`;
        } else {
          if (typeof x[1] === 'number') {
            value = x[1] + 1;
            return `public static double ${x[0]} { get { return ${x[1]}; } }`;
          } else {
            return `public static string ${x[0]} { get { return "${escape_1.escapeString(x[1])}"; } }`;
          }
        }
      })()}`).join('\n\n')}\n${indent0}}\n`;
    } else if (ty[1].ty.kind === 'never' && ty[1].ty.passThruCodeBlock) {// nothing to do
    } else {// nothing to do
      }
  }

  return code + '}\n';
}

exports.generateCSharpCode = generateCSharpCode;

/***/ }),

/***/ "./src/lib/codegen/graphql.ts":
/*!************************************!*\
  !*** ./src/lib/codegen/graphql.ts ***!
  \************************************/
/*! flagged exports */
/*! export __esModule [provided] [no usage info] [missing usage info prevents renaming] */
/*! export generateGraphQlCode [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_exports__ */
/***/ ((__unused_webpack_module, exports) => {

 // Copyright (c) 2019 Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.generateGraphQlCode = void 0;

function formatTypeName(ty, ctx, typeName) {
  if (typeName.includes('.')) {
    return generateGraphQlCodeInner(ty, false, ctx, false);
  }

  return typeName;
}

function formatGraphQlCodeDocComment(ty, nestLevel) {
  let code = '';
  const indent = '    '.repeat(nestLevel);
  const docComment = typeof ty === 'string' ? ty : ty.docComment;

  if (docComment) {
    if (0 <= docComment.indexOf('\n')) {
      code += `${indent}/**\n${indent}  ${docComment.split('\n').map(x => x.trimLeft()).join(`\n${indent} `)}\n${indent} */\n`;
    } else {
      code += `${indent}/** ${docComment} */\n`;
    }
  }

  return code;
}

function isNullableOneOf(ty, ctx) {
  const filtered = ty.oneOf.filter(x => !(x.kind === 'primitive' && (x.primitiveName === 'null' || x.primitiveName === 'undefined') || x.kind === 'primitive-value' && (x.value === null || x.value === void 0)));
  return filtered.length === 1 && ty.oneOf.length !== 1 ? filtered[0] : null;
}

function generateGraphQlCodePrimitive(ty, ctx) {
  switch (ty.primitiveName) {
    case 'number':
      return 'Float';

    case 'integer':
      return 'Int';

    case 'bigint':
      return 'BigInt';

    case 'string':
      return 'String';

    case 'boolean':
      return 'Boolean';

    case 'undefined':
    case 'null':
    default:
      return 'Any';
    // TODO: Any is invalid type.
  } // TODO: Function, DateStr, DateTimeStr

}

function generateGraphQlCodePrimitiveValue(ty, ctx) {
  if (ty.value === null) {
    return 'Any'; // TODO: Any is invalid type.
  }

  if (ty.value === void 0) {
    return 'Any'; // TODO: Any is invalid type.
  }

  switch (typeof ty.value) {
    case 'number':
      return 'Float';

    case 'bigint':
      return 'BigInt';

    case 'string':
      return 'String';

    case 'boolean':
      return 'Boolean';

    default:
      return 'Any';
    // TODO: Any is invalid type.
  }
}

function generateGraphQlCodeRepeated(ty, ctx) {
  return `[${ty.repeated.typeName ? formatTypeName(ty.repeated, ctx, ty.repeated.typeName) : generateGraphQlCodeInner(ty.repeated, false, ctx, false)}${ty.repeated.kind === 'optional' || ty.repeated.kind === 'one-of' && isNullableOneOf(ty.repeated, ctx) ? '' : '!'}]`;
}

function generateGraphQlCodeSpread(ty, ctx) {
  return '';
}

function generateGraphQlCodeSequence(ty, ctx) {
  return '[Any]'; // TODO: Any is invalid type.
}

function generateGraphQlCodeOneOf(ty, ctx, isUnion) {
  const z = isNullableOneOf(ty, ctx);

  if (z) {
    return z.typeName ? z.typeName : generateGraphQlCodeInner(z, false, ctx, false);
  } else {
    if (isUnion) {
      return `${ty.oneOf.map(x => x.typeName ? x.typeName : generateGraphQlCodeInner(x, false, ctx, false)).join(' | ')}`;
    } else {
      return 'Any'; // TODO: Any is invalid type.
    }
  }
}

function generateGraphQlCodeEnum(ty, ctx) {
  return ty.typeName ? formatTypeName(ty, ctx, ty.typeName) : 'Any';
}

function generateGraphQlCodeObject(ty, isInterface, ctx) {
  if (ty.members.length === 0) {
    return '{}';
  }

  const sep = '\n';
  const memberLines = ty.members.map(x => `${formatGraphQlCodeDocComment(x[3] || '', ctx.nestLevel + 1)}${'    '.repeat(ctx.nestLevel + 1)}${x[0]}: ${x[1].typeName ? formatTypeName(x[1], Object.assign(Object.assign({}, ctx), {
    nestLevel: ctx.nestLevel + 1
  }), x[1].typeName) : generateGraphQlCodeInner(x[1], false, Object.assign(Object.assign({}, ctx), {
    nestLevel: ctx.nestLevel + 1
  }), false)}${x[1].kind === 'optional' || x[1].kind === 'one-of' && isNullableOneOf(x[1], ctx) ? '' : '!'}`);
  return `{\n${memberLines.join(sep)}${sep}${'    '.repeat(ctx.nestLevel)}}`;
}

function generateGraphQlCodeInner(ty, isInterface, ctx, isUnion) {
  let ret = '';

  switch (ty.kind) {
    case 'optional':
      return generateGraphQlCodeInner(ty.optional, isInterface, ctx, false);

    case 'one-of':
      return generateGraphQlCodeOneOf(ty, ctx, isUnion);
    // TODO: inline union is invalid.

    case 'spread':
      return generateGraphQlCodeSpread(ty, ctx);

    case 'sequence':
      return generateGraphQlCodeSequence(ty, ctx);

    case 'never':
      ret = 'Any'; // TODO: Any is invalid type.

      break;

    case 'any':
      ret = 'Any'; // TODO: Any is invalid type.

      break;

    case 'unknown':
      ret = 'Any'; // TODO: Any is invalid type.

      break;

    case 'primitive':
      ret = generateGraphQlCodePrimitive(ty, ctx);
      break;

    case 'primitive-value':
      ret = generateGraphQlCodePrimitiveValue(ty, ctx);
      break;

    case 'repeated':
      ret = generateGraphQlCodeRepeated(ty, ctx);
      break;

    case 'enum':
      ret = generateGraphQlCodeEnum(ty, ctx);
      break;

    case 'object':
      ret = generateGraphQlCodeObject(ty, isInterface, ctx);
      break;

    case 'symlink':
      ret = ty.symlinkTargetName;
      break;

    case 'operator':
      throw new Error(`Unexpected type assertion: ${ty.kind}`);

    default:
      throw new Error(`Unknown type assertion: ${ty.kind}`);
  }

  return ret + '';
}

function generateGraphQlCode(types) {
  let code = `\nscalar Any\nunion BigInt = String | Int\n\n`;
  const ctx = {
    nestLevel: 0
  };

  for (const ty of types.entries()) {
    if (ty[1].ty.noOutput) {
      code += `scalar ${ty[0]}\n\n`;
      continue;
    }

    code += formatGraphQlCodeDocComment(ty[1].ty, ctx.nestLevel);

    if (ty[1].ty.kind === 'object') {
      code += `type ${ty[0]} ${generateGraphQlCodeInner(ty[1].ty, true, ctx, false)}\n\n`;
    } else if (ty[1].ty.kind === 'enum') {
      const indent0 = '    '.repeat(ctx.nestLevel);
      const indent1 = '    '.repeat(ctx.nestLevel + 1);
      code += `enum ${ty[0]} {\n${ty[1].ty.values.map(x => `${formatGraphQlCodeDocComment(x[2] || '', ctx.nestLevel + 1)}${indent1}${x[0]}\n`).join('')}${indent0}}\n\n`;
    } else if (ty[1].ty.kind === 'never' && ty[1].ty.passThruCodeBlock) {// nothing to do
    } else {
      code += `union ${ty[0]} = ${generateGraphQlCodeInner(ty[1].ty, false, ctx, true)}\n\n`;
    }
  }

  return code;
}

exports.generateGraphQlCode = generateGraphQlCode;

/***/ }),

/***/ "./src/lib/codegen/json-schema.ts":
/*!****************************************!*\
  !*** ./src/lib/codegen/json-schema.ts ***!
  \****************************************/
/*! flagged exports */
/*! export __esModule [provided] [no usage info] [missing usage info prevents renaming] */
/*! export generateJsonSchema [provided] [no usage info] [missing usage info prevents renaming] */
/*! export generateJsonSchemaObject [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_exports__ */
/***/ ((__unused_webpack_module, exports) => {

 // Copyright (c) 2019 Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.generateJsonSchema = exports.generateJsonSchemaObject = void 0;

function addMetaInfo(a, ty) {
  const a2 = Object.assign({}, a);
  let changed = false;

  if (ty.docComment) {
    a2.description = ty.docComment;
    changed = true;
  }

  switch (ty.kind) {
    case 'repeated':
      if (typeof ty.min === 'number') {
        a2.minItems = ty.min;
        changed = true;
      }

      if (typeof ty.max === 'number') {
        a2.maxItems = ty.max;
        changed = true;
      }

      break;

    case 'primitive':
      if (typeof ty.minValue === 'number') {
        a2.minimum = ty.minValue;
        changed = true;
      }

      if (typeof ty.maxValue === 'number') {
        a2.maximum = ty.maxValue;
        changed = true;
      }

      if (typeof ty.greaterThanValue === 'number') {
        a2.exclusiveMinimum = ty.greaterThanValue;
        changed = true;
      }

      if (typeof ty.lessThanValue === 'number') {
        a2.exclusiveMaximum = ty.lessThanValue;
        changed = true;
      }

      if (typeof ty.minLength === 'number') {
        a2.minLength = ty.minLength;
        changed = true;
      }

      if (typeof ty.maxLength === 'number') {
        a2.maxLength = ty.maxLength;
        changed = true;
      }

      if (ty.pattern) {
        a2.pattern = ty.pattern.source;
        changed = true;
      }

      break;
  }

  return changed ? a2 : a;
}

function generateJsonSchemaInner(schema, ty, nestLevel) {
  var _a;

  if (0 < nestLevel && ty.typeName) {
    const ret = {
      $ref: `#/definitions/${ty.typeName.replace(/\./g, '/properties/')}`
    };
    const r2 = addMetaInfo(ret, ty);

    if (ret !== r2) {
      // NOTE: `$ref` cannot have value constraints.
      return generateJsonSchemaInner(schema, ty, 0);
    } else {
      return ret;
    }
  }

  switch (ty.kind) {
    case 'symlink':
      {
        const ret = {
          $ref: `#/definitions/${ty.symlinkTargetName}`
        };
        const r2 = addMetaInfo(ret, ty);

        if (ret !== r2) {
          // NOTE: `$ref` cannot have value constraints.
          const t2 = (_a = schema.get(ty.symlinkTargetName)) === null || _a === void 0 ? void 0 : _a.ty;

          if (t2) {
            return generateJsonSchemaInner(schema, t2, 0);
          } else {
            // Drop constraints.
            return ret;
          }
        } else {
          return ret;
        }
      }

    case 'repeated':
      {
        const ret = {
          type: 'array',
          items: generateJsonSchemaInner(schema, ty.repeated, nestLevel + 1)
        };

        if (typeof ty.min === 'number') {
          ret.minItems = ty.min;
        }

        if (typeof ty.max === 'number') {
          ret.maxItems = ty.max;
        }

        return addMetaInfo(ret, ty);
      }

    case 'sequence':
      {
        const ret = {
          type: 'array',
          items: {
            anyOf: ty.sequence.map(x => generateJsonSchemaInner(schema, x, nestLevel + 1))
          }
        };
        return addMetaInfo(ret, ty);
      }

    case 'spread':
      {
        return generateJsonSchemaInner(schema, ty.spread, nestLevel + 1);
      }

    case 'one-of':
      {
        const ret = {
          anyOf: ty.oneOf.map(x => generateJsonSchemaInner(schema, x, nestLevel + 1))
        };
        return addMetaInfo(ret, ty);
      }

    case 'optional':
      {
        const ret = {
          oneOf: [generateJsonSchemaInner(schema, ty.optional, nestLevel + 1), {
            type: 'null'
          }]
        };
        return addMetaInfo(ret, ty);
      }

    case 'enum':
      {
        const ret = {
          type: ['string', 'number'],
          enum: ty.values.map(x => x[1])
        };
        return addMetaInfo(ret, ty);
      }

    case 'object':
      {
        const properties = {};
        const patternProperties = {};
        let patternPropsCount = 0;
        const required = [];

        for (const m of ty.members) {
          const z = generateJsonSchemaInner(schema, m[1].kind === 'optional' ? m[1].optional : m[1], nestLevel + 1);

          if (m[3]) {
            z.description = m[3];
          } else {
            delete z.description;
          }

          properties[m[0]] = z;

          if (m[1].kind !== 'optional') {
            required.push(m[0]);
          }
        }

        for (const m of ty.additionalProps || []) {
          const z = generateJsonSchemaInner(schema, m[1], nestLevel + 1);

          if (m[3]) {
            z.description = m[3];
          } else {
            delete z.description;
          }

          for (const k of m[0]) {
            patternPropsCount++;

            switch (k) {
              case 'number':
                patternProperties['^[0-9]+$'] = z;
                break;

              case 'string':
                patternProperties['^.*$'] = z;
                break;

              default:
                patternProperties[k.source] = z;
                break;
            }
          }
        }

        const ret = Object.assign(Object.assign(Object.assign({
          type: 'object',
          properties
        }, 0 < patternPropsCount ? {
          patternProperties
        } : {}), 0 < required.length ? {
          required
        } : {}), {
          additionalProperties: false
        });
        return addMetaInfo(ret, ty);
      }

    case 'primitive':
      {
        switch (ty.primitiveName) {
          case 'null':
          case 'undefined':
            {
              const ret = {
                type: 'null'
              };
              return addMetaInfo(ret, ty);
            }

          case 'number':
            {
              const ret = {
                type: 'number'
              };
              return addMetaInfo(ret, ty);
            }

          case 'bigint':
            {
              const ret = {
                type: ['integer', 'string']
              };
              return addMetaInfo(ret, ty);
            }

          case 'integer':
            {
              const ret = {
                type: 'integer'
              };
              return addMetaInfo(ret, ty);
            }

          case 'string':
            {
              const ret = {
                type: 'string'
              };
              return addMetaInfo(ret, ty);
            }

          case 'boolean':
            {
              const ret = {
                type: 'boolean'
              };
              return addMetaInfo(ret, ty);
            }
        } // TODO: Function, DateStr, DateTimeStr

      }

    case 'primitive-value':
      {
        switch (typeof ty.value) {
          case 'number':
            {
              const ret = {
                type: 'number',
                enum: [ty.value]
              };
              return addMetaInfo(ret, ty);
            }

          case 'bigint':
            {
              const ret = {
                type: ['integer', 'string'],
                enum: [ty.value.toString()]
              };

              if (BigInt(Number.MIN_SAFE_INTEGER) <= ty.value && ty.value <= BigInt(Number.MAX_SAFE_INTEGER)) {
                ret.enum.push(Number(ty.value));
              }

              return addMetaInfo(ret, ty);
            }

          case 'string':
            {
              const ret = {
                type: 'string',
                enum: [ty.value]
              };
              return addMetaInfo(ret, ty);
            }

          case 'boolean':
            {
              const ret = {
                type: 'boolean',
                enum: [ty.value]
              };
              return addMetaInfo(ret, ty);
            }

          default:
            throw new Error(`Unknown primitive-value assertion: ${typeof ty.value}`);
        }
      }

    case 'never':
      {
        const ret = {
          type: 'null'
        };
        return addMetaInfo(ret, ty);
      }

    case 'any':
    case 'unknown':
      {
        const ret = {
          type: ['null', 'integer', 'number', 'string', 'boolean', 'array', 'object']
        };
        return addMetaInfo(ret, ty);
      }

    case 'operator':
      throw new Error(`Unexpected type assertion: ${ty.kind}`);

    default:
      throw new Error(`Unknown type assertion: ${ty.kind}`);
  }
}

function generateJsonSchemaObject(schema) {
  const ret = {
    $schema: 'http://json-schema.org/draft-06/schema#',
    definitions: {}
  };

  for (const ty of schema.entries()) {
    if (ty[1].ty.kind === 'never' && ty[1].ty.passThruCodeBlock) {
      continue;
    }

    ret.definitions[ty[0]] = generateJsonSchemaInner(schema, ty[1].ty, 0);
  }

  return ret;
}

exports.generateJsonSchemaObject = generateJsonSchemaObject;

function generateJsonSchema(schema, asTs) {
  const ret = generateJsonSchemaObject(schema);

  if (asTs) {
    return `\n// tslint:disable: object-literal-key-quotes\n` + `const schema = ${JSON.stringify(ret, null, 2)};\nexport default schema;` + `\n// tslint:enable: object-literal-key-quotes\n`;
  } else {
    return JSON.stringify(ret, null, 2);
  }
}

exports.generateJsonSchema = generateJsonSchema;

/***/ }),

/***/ "./src/lib/codegen/proto3.ts":
/*!***********************************!*\
  !*** ./src/lib/codegen/proto3.ts ***!
  \***********************************/
/*! flagged exports */
/*! export __esModule [provided] [no usage info] [missing usage info prevents renaming] */
/*! export generateProto3Code [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_exports__, __webpack_require__ */
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

 // Copyright (c) 2019 Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.generateProto3Code = void 0;

const escape_1 = __webpack_require__(/*! ../../lib/escape */ "./src/lib/escape.ts");

function formatTypeName(ty, ctx, typeName) {
  if (typeName.includes('.')) {
    return generateProto3CodeInner(ty, false, ctx);
  }

  return typeName;
}

function formatProto3CodeDocComment(ty, nestLevel) {
  let code = '';
  const indent = '    '.repeat(nestLevel);
  const docComment = typeof ty === 'string' ? ty : ty.docComment;

  if (docComment) {
    if (0 <= docComment.indexOf('\n')) {
      code += `${indent}/**\n${indent}  ${docComment.split('\n').map(x => x.trimLeft()).join(`\n${indent} `)}\n${indent} */\n`;
    } else {
      code += `${indent}/** ${docComment} */\n`;
    }
  }

  return code;
}

function formatMemberType(ty, ctx) {
  if (ty.typeName) {
    return formatTypeName(ty, ctx, ty.typeName);
  } else {
    switch (ty.kind) {
      case 'primitive':
        return generateProto3CodePrimitive(ty, ctx);

      case 'primitive-value':
        return generateProto3CodePrimitiveValue(ty, ctx);

      case 'repeated':
        return generateProto3CodeRepeated(ty, ctx);

      case 'one-of':
        return generateProto3CodeOneOf(ty, ctx);

      default:
        return 'object';
    }
  }
}

function appendOptionalModifier(name) {
  switch (name) {
    case 'double':
      return 'google.protobuf.DoubleValue';

    case 'int64':
      return 'google.protobuf.Int64Value';

    case 'int32':
      return 'google.protobuf.Int32Value';

    case 'string':
      return 'google.protobuf.StringValue';

    case 'bool':
      return 'google.protobuf.BoolValue';

    default:
      return name;
  }
}

function isNullableOneOf(ty, ctx) {
  const filtered = ty.oneOf.filter(x => !(x.kind === 'primitive' && (x.primitiveName === 'null' || x.primitiveName === 'undefined') || x.kind === 'primitive-value' && (x.value === null || x.value === void 0)));
  return filtered.length === 1 && ty.oneOf.length !== 1 ? filtered[0] : null;
}

function generateProto3CodePrimitive(ty, ctx) {
  switch (ty.primitiveName) {
    case 'number':
      return 'double';

    case 'integer':
      return 'int32';

    case 'bigint':
      return 'string';

    case 'string':
      return 'string';

    case 'boolean':
      return 'bool';

    case 'undefined':
    case 'null':
    default:
      return 'google.protobuf.Any';
  } // TODO: Function, integer, DateStr, DateTimeStr

}

function generateProto3CodePrimitiveValue(ty, ctx) {
  if (ty.value === null) {
    return 'google.protobuf.Any';
  }

  if (ty.value === void 0) {
    return 'google.protobuf.Any';
  }

  switch (typeof ty.value) {
    case 'number':
      return 'double';

    case 'bigint':
      return 'string';

    case 'string':
      return 'string';

    case 'boolean':
      return 'bool';

    default:
      return 'google.protobuf.Any';
  }
}

function generateProto3CodeRepeated(ty, ctx) {
  return `repeated ${ty.repeated.typeName ? formatTypeName(ty.repeated, ctx, ty.repeated.typeName) : ty.repeated.kind === 'repeated' ? 'google.protobuf.Any' : generateProto3CodeInner(ty.repeated, false, ctx)}`;
}

function generateProto3CodeSpread(ty, ctx) {
  return '';
}

function generateProto3CodeSequence(ty, ctx) {
  return 'repeated google.protobuf.Any';
}

function generateProto3CodeOneOf(ty, ctx) {
  const z = isNullableOneOf(ty, ctx);

  if (z) {
    return appendOptionalModifier(formatMemberType(z, ctx));
  } else {
    return 'google.protobuf.Any';
  }
}

function generateProto3CodeOptional(ty, ctx) {
  return appendOptionalModifier(generateProto3CodeInner(ty.optional, false, ctx));
}

function generateProto3CodeEnum(ty, ctx) {
  return ty.typeName ? formatTypeName(ty, ctx, ty.typeName) : 'google.protobuf.Any';
}

function generateProto3CodeObject(ty, isInterface, ctx) {
  if (ty.members.length === 0) {
    return '{}';
  }

  const sep = isInterface ? ';\n' : ',\n';
  let count = 1;
  const memberLines = ty.members.map(x => `${formatProto3CodeDocComment(x[3] || '', ctx.nestLevel + 1)}${'    '.repeat(ctx.nestLevel + 1)}${x[1].typeName ? formatTypeName(x[1], Object.assign(Object.assign({}, ctx), {
    nestLevel: ctx.nestLevel + 1
  }), x[1].typeName) : generateProto3CodeInner(x[1], false, Object.assign(Object.assign({}, ctx), {
    nestLevel: ctx.nestLevel + 1
  }))} ${x[0]} = ${count++}`);
  return `{\n${memberLines.join(sep)}${sep}${'    '.repeat(ctx.nestLevel)}}`;
}

function generateProto3CodeInner(ty, isInterface, ctx) {
  switch (ty.kind) {
    case 'never':
    case 'any':
    case 'unknown':
      return 'google.protobuf.Any';

    case 'primitive':
      return generateProto3CodePrimitive(ty, ctx);

    case 'primitive-value':
      return generateProto3CodePrimitiveValue(ty, ctx);

    case 'repeated':
      return generateProto3CodeRepeated(ty, ctx);

    case 'spread':
      return generateProto3CodeSpread(ty, ctx);

    case 'sequence':
      return generateProto3CodeSequence(ty, ctx);

    case 'one-of':
      return generateProto3CodeOneOf(ty, ctx);

    case 'optional':
      return generateProto3CodeOptional(ty, ctx);

    case 'enum':
      return generateProto3CodeEnum(ty, ctx);

    case 'object':
      return generateProto3CodeObject(ty, isInterface, ctx);

    case 'symlink':
      return ty.symlinkTargetName;

    case 'operator':
      throw new Error(`Unexpected type assertion: ${ty.kind}`);

    default:
      throw new Error(`Unknown type assertion: ${ty.kind}`);
  }
}

function generateProto3Code(types) {
  let code = `
syntax = "proto3";
import "google/protobuf/wrappers.proto";
import "google/protobuf/any.proto";

`;
  const ctx = {
    nestLevel: 0
  };

  for (const ty of types.entries()) {
    if (ty[1].ty.noOutput) {
      const indent0 = '    '.repeat(ctx.nestLevel);
      const indent1 = '    '.repeat(ctx.nestLevel + 1);
      code += `message ${ty[0]} {\n${indent1}google.protobuf.Any value = 1;\n${indent0}}\n\n`;
      continue;
    }

    code += formatProto3CodeDocComment(ty[1].ty, ctx.nestLevel);

    if (ty[1].ty.kind === 'object') {
      code += `message ${ty[0]} ${generateProto3CodeInner(ty[1].ty, true, ctx)}\n\n`;
    } else if (ty[1].ty.kind === 'enum') {
      const indent0 = '    '.repeat(ctx.nestLevel);
      const indent1 = '    '.repeat(ctx.nestLevel + 1);

      if (0 < ty[1].ty.values.filter(x => typeof x[1] !== 'number').length) {
        // NOTE: string enum is not allowed
        code += `message ${ty[0]} {\n${indent1}google.protobuf.Any value = 1;\n${indent0}}\n\n`;
      } else {
        code += `enum ${ty[0]} {\n${indent1}option allow_alias = true;\n${ty[1].ty.values.filter(x => x[1] === 0).length === 0 ? `${indent1}${ty[0]}__UNKNOWN__ = 0;\n` : // NOTE: 0 value item is required
        ''}${ty[1].ty.values.map(x => `${formatProto3CodeDocComment(x[2] || '', ctx.nestLevel + 1)}${indent1}${(() => {
          if (typeof x[1] === 'number') {
            return `${ty[0]}_${x[0]} = ${x[1]}`; // NOTE: label namespace is shared by all top-level enum
          } else {
            return `${ty[0]}_${x[0]} = '${escape_1.escapeString(x[1])}'`; // NOTE: string enum is not allowed
          }
        })()};\n`).join('')}${indent0}}\n\n`;
      }
    } else if (ty[1].ty.kind === 'never' && ty[1].ty.passThruCodeBlock) {// nothing to do
    } else {
      const indent0 = '    '.repeat(ctx.nestLevel);
      const indent1 = '    '.repeat(ctx.nestLevel + 1);
      code += `message ${ty[0]} {\n${indent1}${generateProto3CodeInner(ty[1].ty, false, ctx)} value = 1;\n${indent0}}\n\n`;
    }
  }

  return code;
}

exports.generateProto3Code = generateProto3Code;

/***/ }),

/***/ "./src/lib/codegen/typescript.ts":
/*!***************************************!*\
  !*** ./src/lib/codegen/typescript.ts ***!
  \***************************************/
/*! flagged exports */
/*! export __esModule [provided] [no usage info] [missing usage info prevents renaming] */
/*! export generateTypeScriptCode [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_exports__, __webpack_require__ */
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

 // Copyright (c) 2019 Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.generateTypeScriptCode = void 0;

const escape_1 = __webpack_require__(/*! ../../lib/escape */ "./src/lib/escape.ts");

const util_1 = __webpack_require__(/*! ../../lib/util */ "./src/lib/util.ts");

function formatTypeName(typeName) {
  if (typeName.includes('.')) {
    const z = typeName.split('.');
    let s = z[0];

    for (let i = 1; i < z.length; i++) {
      s += `['${escape_1.escapeString(z[i])}']`;
    }

    return `(${s})`;
  }

  return typeName;
}

function formatTypeScriptCodeDocComment(ty, nestLevel) {
  let code = '';
  const indent = '    '.repeat(nestLevel);
  const docComment = typeof ty === 'string' ? ty : ty.docComment;

  if (docComment) {
    if (0 <= docComment.indexOf('\n')) {
      code += `${indent}/**\n${indent}  ${docComment.split('\n').map(x => x.trimLeft()).join(`\n${indent} `)}\n${indent} */\n`;
    } else {
      code += `${indent}/** ${docComment} */\n`;
    }
  }

  return code;
}

function generateTypeScriptCodePrimitive(ty, ctx) {
  // TODO: Function, DateStr, DateTimeStr
  switch (ty.primitiveName) {
    case 'integer':
      return 'number';

    default:
      return ty.primitiveName;
  }
}

function generateTypeScriptCodePrimitiveValue(ty, ctx) {
  if (ty.value === null) {
    return 'null';
  }

  if (ty.value === void 0) {
    return 'undefined';
  }

  switch (typeof ty.value) {
    case 'string':
      return `'${escape_1.escapeString(ty.value)}'`;

    case 'bigint':
      return `${ty.value.toString()}n`;

    default:
      return ty.value.toString();
  }
}

function generateTypeScriptCodeRepeated(ty, ctx) {
  return ty.repeated.kind === 'primitive' || ty.repeated.kind === 'never' || ty.repeated.kind === 'any' || ty.repeated.kind === 'unknown' || ty.repeated.kind === 'object' || ty.repeated.kind === 'symlink' || ty.repeated.kind === 'one-of' && ty.repeated.typeName ? `${ty.repeated.typeName ? formatTypeName(ty.repeated.typeName) : generateTypeScriptCodeInner(ty.repeated, false, ctx)}[]` : `Array<${ty.repeated.typeName ? formatTypeName(ty.repeated.typeName) : generateTypeScriptCodeInner(ty.repeated, false, ctx)}>`;
}

function generateTypeScriptCodeSpread(ty, ctx) {
  return '';
}

function generateTypeScriptCodeSequence(ty, ctx) {
  if (0 < ty.sequence.filter(x => x.kind === 'spread' || x.kind === 'optional').length) {
    return 'any[]';
  }

  return `[${ty.sequence.filter(x => x.kind !== 'spread' && x.kind !== 'optional').map(x => x.typeName ? formatTypeName(x.typeName) : generateTypeScriptCodeInner(x, false, Object.assign(Object.assign({}, ctx), {
    nestLevel: ctx.nestLevel + 1
  }))).join(', ')}]`;
}

function generateTypeScriptCodeOneOf(ty, ctx) {
  return `(${ty.oneOf.map(x => x.typeName ? formatTypeName(x.typeName) : generateTypeScriptCodeInner(x, false, ctx)).join(' | ')})`;
}

function generateTypeScriptCodeOptional(ty, ctx) {
  return generateTypeScriptCodeInner(ty.optional, false, ctx);
}

function generateTypeScriptCodeEnum(ty, ctx) {
  return `(${ty.values.map(x => `${x[1]}`).join(' | ')})`;
}

function formatAdditionalPropsName(ak, i) {
  return `[propName${i}: ${ak.map(x => typeof x === 'string' ? x : 'string').join(' | ')}]`;
}

function generateTypeScriptCodeObject(ty, isInterface, ctx) {
  var _a, _b;

  if (ty.members.filter(x => !x[2]).length === 0 && ((_a = ty.additionalProps) === null || _a === void 0 ? void 0 : _a.filter(x => !x[2]).length) === 0) {
    return '{}';
  } // NOTE: Semicolon is always preferred.
  // https://github.com/typescript-eslint/typescript-eslint/blob/master/packages/eslint-plugin/docs/rules/member-delimiter-style.md


  const sep = isInterface ? ';\n' : ';\n';
  const memberLines = ty.members.filter(x => !x[2]).map(x => `${formatTypeScriptCodeDocComment(x[3] || '', ctx.nestLevel + 1)}${'    '.repeat(ctx.nestLevel + 1)}${util_1.SymbolPattern.test(x[0]) ? x[0] : `'${escape_1.escapeString(x[0])}'`}${x[1].kind === 'optional' ? '?' : ''}: ${x[1].typeName ? formatTypeName(x[1].typeName) : generateTypeScriptCodeInner(x[1], false, Object.assign(Object.assign({}, ctx), {
    nestLevel: ctx.nestLevel + 1
  }))}`);
  const additionalPropsLines = ((_b = ty.additionalProps) === null || _b === void 0 ? void 0 : _b.filter(x => !x[2]).map((x, i) => `${formatTypeScriptCodeDocComment(x[3] || '', ctx.nestLevel + 1)}${'    '.repeat(ctx.nestLevel + 1)}${formatAdditionalPropsName(x[0], i)}${x[1].kind === 'optional' ? '?' : ''}: ${x[1].typeName ? formatTypeName(x[1].typeName) : generateTypeScriptCodeInner(x[1], false, Object.assign(Object.assign({}, ctx), {
    nestLevel: ctx.nestLevel + 1
  }))}`)) || [];
  const propsLines = memberLines.concat(additionalPropsLines);

  if (propsLines.length === 0) {
    return '{}';
  }

  return `{\n${propsLines.join(sep)}${sep}${'    '.repeat(ctx.nestLevel)}}`;
}

function generateTypeScriptCodeInner(ty, isInterface, ctx) {
  switch (ty.kind) {
    case 'never':
      return 'never';

    case 'any':
      return 'any';

    case 'unknown':
      return 'unknown';

    case 'primitive':
      return generateTypeScriptCodePrimitive(ty, ctx);

    case 'primitive-value':
      return generateTypeScriptCodePrimitiveValue(ty, ctx);

    case 'repeated':
      return generateTypeScriptCodeRepeated(ty, ctx);

    case 'spread':
      return generateTypeScriptCodeSpread(ty, ctx);

    case 'sequence':
      return generateTypeScriptCodeSequence(ty, ctx);

    case 'one-of':
      return generateTypeScriptCodeOneOf(ty, ctx);

    case 'optional':
      return generateTypeScriptCodeOptional(ty, ctx);

    case 'enum':
      return generateTypeScriptCodeEnum(ty, ctx);

    case 'object':
      return generateTypeScriptCodeObject(ty, isInterface, ctx);

    case 'symlink':
      return ty.symlinkTargetName;

    case 'operator':
      throw new Error(`Unexpected type assertion: ${ty.kind}`);

    default:
      throw new Error(`Unknown type assertion: ${ty.kind}`);
  }
}

function generateTypeScriptCode(types) {
  let code = '';
  const ctx = {
    nestLevel: 0
  };

  for (const ty of types.entries()) {
    if (ty[1].ty.noOutput) {
      continue;
    }

    code += formatTypeScriptCodeDocComment(ty[1].ty, ctx.nestLevel);

    if (ty[1].exported) {
      code += 'export ';
    }

    if (ty[1].isDeclare) {
      code += 'declare ';
    }

    if (ty[1].ty.kind === 'object') {
      code += `interface ${ty[0]}${ty[1].ty.baseTypes && ty[1].ty.baseTypes.length ? ` extends ${ty[1].ty.baseTypes.filter(x => x.typeName).map(x => formatTypeName(x.typeName)).join(', ')}` : ''} ${generateTypeScriptCodeInner(ty[1].ty, true, ctx)}\n\n`;
    } else if (ty[1].ty.kind === 'enum') {
      const indent0 = '    '.repeat(ctx.nestLevel);
      const indent1 = '    '.repeat(ctx.nestLevel + 1);
      let value = 0;
      code += `${ty[1].ty.isConst ? 'const ' : ''}enum ${ty[0]} {\n${ty[1].ty.values.map(x => `${formatTypeScriptCodeDocComment(x[2] || '', ctx.nestLevel + 1)}${indent1}${(() => {
        if (value !== null && x[1] === value) {
          value++;
          return `${x[0]}`;
        } else {
          if (typeof x[1] === 'number') {
            value = x[1] + 1;
            return `${x[0]} = ${x[1]}`;
          } else {
            return `${x[0]} = '${escape_1.escapeString(x[1])}'`;
          }
        }
      })()},\n`).join('')}${indent0}}\n\n`;
    } else if (ty[1].ty.kind === 'never' && ty[1].ty.passThruCodeBlock) {
      code += `${ty[1].ty.passThruCodeBlock}\n\n`;
    } else {
      code += `type ${ty[0]} = ${(ty[1].ty.originalTypeName ? formatTypeName(ty[1].ty.originalTypeName) : void 0) || generateTypeScriptCodeInner(ty[1].ty, false, ctx)};\n\n`;
    }
  }

  return code;
}

exports.generateTypeScriptCode = generateTypeScriptCode;

/***/ }),

/***/ "./src/lib/compiler.ts":
/*!*****************************!*\
  !*** ./src/lib/compiler.ts ***!
  \*****************************/
/*! flagged exports */
/*! export __esModule [provided] [no usage info] [missing usage info prevents renaming] */
/*! export externalTypeDef [provided] [no usage info] [missing usage info prevents renaming] */
/*! export program [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_exports__, __webpack_require__ */
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

 // Copyright (c) 2019 Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.program = exports.externalTypeDef = void 0;

const string_parser_1 = __webpack_require__(/*! fruitsconfits/modules/lib/string-parser */ "./node_modules/fruitsconfits/modules/lib/string-parser.js");

const object_parser_1 = __webpack_require__(/*! fruitsconfits/modules/lib/object-parser */ "./node_modules/fruitsconfits/modules/lib/object-parser.js");

const protection_1 = __webpack_require__(/*! ./protection */ "./src/lib/protection.ts");

const $s = string_parser_1.getStringParsers({
  rawToToken: rawToken => rawToken,
  concatTokens: tokens => tokens.length ? [tokens.reduce((a, b) => String(a) + b)] : []
});
const $o = object_parser_1.getObjectParsers({
  rawToToken: rawToken => rawToken,
  concatTokens: tokens => tokens.length ? [tokens.reduce((a, b) => String(a) + b)] : [],
  comparator: (a, b) => a === b
});
const {
  seq,
  cls,
  notCls,
  clsFn,
  classes,
  numbers,
  cat,
  once,
  repeat,
  qty,
  zeroWidth,
  err,
  beginning,
  end,
  first,
  or,
  combine,
  erase,
  trans,
  ahead,
  rules,
  makeProgram
} = $s;
const directiveLineComment = trans(tokens => [[{
  symbol: 'directive'
}, ...tokens]])(erase(qty(2)(cls('/'))), erase(repeat(classes.space)), cat(seq('@tynder-'), repeat(first(classes.alnum, cls('-')))), // [0]
erase(repeat(classes.space)), cat(repeat(notCls('\r\n', '\n', '\r'))), // [1]
erase(first(classes.newline, ahead(end()))));
const directiveBlockComment = trans(tokens => [[{
  symbol: 'directive'
}, ...tokens]])(erase(seq('/*')), erase(repeat(classes.space)), cat(seq('@tynder-'), repeat(first(classes.alnum, cls('-')))), // [0]
erase(repeat(classes.space)), cat(repeat(notCls('*/'))), // [1]
erase(seq('*/')));
const lineComment = combine(erase(qty(2)(cls('/'))), first(combine(ahead(repeat(classes.space), notCls('@tynder-')), repeat(notCls('\r\n', '\n', '\r')), first(classes.newline, ahead(end()))), first(classes.newline, ahead(end()))));
const hashLineComment = combine(seq('#'), repeat(notCls('\r\n', '\n', '\r')), first(classes.newline, ahead(end())));
const docComment = combine(seq('/**'), repeat(classes.space), input => {
  const ret = cat(repeat(notCls('*/')))(input);

  if (ret.succeeded) {
    // define a reducer
    const ctx2 = Object.assign({}, ret.next.context); // NOTE: context is immutable

    ctx2.docComment = (ret.tokens[0] || '').trim();
    ret.next.context = ctx2;
  }

  return ret;
}, seq('*/'));
const blockComment = combine(seq('/*'), ahead(repeat(classes.space), notCls('@tynder-')), repeat(notCls('*/')), seq('*/'));
const commentOrSpace = first(classes.space, lineComment, hashLineComment, docComment, blockComment);
const trueValue = trans(tokens => [true])(seq('true'));
const falseValue = trans(tokens => [false])(seq('false'));
const nullValue = trans(tokens => [null])(seq('null'));
const undefinedValue = trans(tokens => [void 0])(seq('undefined'));
const positiveInfinityValue = trans(tokens => [Number.POSITIVE_INFINITY])(qty(0, 1)(seq('+')), seq('Infinity'));
const negativeInfinityValue = trans(tokens => [Number.NEGATIVE_INFINITY])(seq('-Infinity'));
const nanValue = trans(tokens => [Number.NaN])(seq('NaN'));
const binaryIntegerValue = trans(tokens => [Number.parseInt(tokens[0].replace(/_/g, ''), 2)])(numbers.bin(seq('0b')));
const octalIntegerValue = trans(tokens => [Number.parseInt(tokens[0].replace(/_/g, ''), 8)])(numbers.oct(seq('0o'), seq('0')));
const hexIntegerValue = trans(tokens => [Number.parseInt(tokens[0].replace(/_/g, ''), 16)])(numbers.hex(seq('0x'), seq('0X')));
const decimalIntegerValue = trans(tokens => [Number.parseInt(tokens[0].replace(/_/g, ''), 10)])(numbers.int);
const bigDecimalIntegerValue = trans(tokens => [BigInt(tokens[0].replace(/_/g, ''))])(numbers.bigint);
const floatingPointNumberValue = trans(tokens => [Number.parseFloat(tokens[0].replace(/_/g, ''))])(numbers.float);
const numberValue = first(octalIntegerValue, hexIntegerValue, binaryIntegerValue, bigDecimalIntegerValue, floatingPointNumberValue, decimalIntegerValue, positiveInfinityValue, negativeInfinityValue, nanValue);
const stringEscapeSeq = first(trans(t => ['\''])(seq('\\\'')), trans(t => ['\"'])(seq('\\"')), trans(t => ['\`'])(seq('\\`')), trans(t => ['/'])(seq('\\/')), trans(t => ['\\'])(seq('\\\\')), trans(t => [''])(seq('\\\r\n')), trans(t => [''])(seq('\\\r')), trans(t => [''])(seq('\\\n')), trans(t => ['\n'])(seq('\\n')), trans(t => ['\r'])(seq('\\r')), trans(t => ['\v'])(seq('\\v')), trans(t => ['\t'])(seq('\\t')), trans(t => ['\b'])(seq('\\b')), trans(t => ['\f'])(seq('\\f')), trans(t => [String.fromCodePoint(Number.parseInt(t[0], 16))])(cat(erase(seq('\\u')), qty(4, 4)(classes.hex))), trans(t => [String.fromCodePoint(Number.parseInt(t[0], 16))])(cat(erase(seq('\\u{')), qty(1, 6)(classes.hex), erase(seq('}')))), trans(t => [String.fromCodePoint(Number.parseInt(t[0], 16))])(cat(erase(seq('\\x')), qty(2, 2)(classes.hex))), trans(t => [String.fromCodePoint(Number.parseInt(t[0], 8))])(cat(erase(seq('\\')), qty(3, 3)(classes.oct))));
const signleQuotStringValue = trans(tokens => {
  var _a;

  return [(_a = tokens[0]) !== null && _a !== void 0 ? _a : ''];
})(erase(seq("'")), cat(repeat(first(stringEscapeSeq, combine(cls('\r', '\n'), err('Line breaks within strings are not allowed.')), notCls("'")))), erase(seq("'")));
const doubleQuotStringValue = trans(tokens => {
  var _a;

  return [(_a = tokens[0]) !== null && _a !== void 0 ? _a : ''];
})(erase(seq('"')), cat(repeat(first(stringEscapeSeq, combine(cls('\r', '\n'), err('Line breaks within strings are not allowed.')), notCls('"')))), erase(seq('"')));
const backQuotStringValue = trans(tokens => {
  var _a;

  return [(_a = tokens[0]) !== null && _a !== void 0 ? _a : ''];
})(erase(seq('`')), cat(repeat(first(stringEscapeSeq, notCls('`')))), erase(seq('`')));
const stringValue = first(signleQuotStringValue, doubleQuotStringValue, backQuotStringValue);
const regexpStringValue = // TODO: '/' ']' '\\' in character class '[]' is not parsed correctly.
trans(tokens => {
  var _a, _b;

  return [{
    value: tokens[1] ? new RegExp((_a = tokens[0]) !== null && _a !== void 0 ? _a : '', tokens[1]) : new RegExp((_b = tokens[0]) !== null && _b !== void 0 ? _b : '')
  }];
})(erase(seq('/')), cat(repeat(first(stringEscapeSeq, notCls('/')))), erase(seq('/')), cat(qty(0)(cls('g', 'i', 'm', 's', 'u', 'y'))));
const symbolName = trans(tokens => tokens)(cat(combine(first(classes.alpha, cls('$', '_')), repeat(first(classes.alnum, cls('$', '_'))))));
const decoratorSymbolName = trans(tokens => [{
  symbol: tokens[0]
}])(cat(combine(seq('@'), first(classes.alpha, cls('$', '_')), repeat(first(classes.alnum, cls('$', '_'))))));
const simpleConstExpr = first(trueValue, falseValue, nullValue, undefinedValue, numberValue, stringValue);
const objKey = first(stringValue, symbolName);
const listValue = first(trans(tokens => [[]])(erase(seq('['), repeat(commentOrSpace), seq(']'))), trans(tokens => {
  const ast = [{
    symbol: '$list'
  }];

  for (const token of tokens) {
    ast.push(token);
  }

  return [ast];
})(erase(seq('[')), combine(erase(repeat(commentOrSpace)), first(input => listValue(input), // NOTE: recursive definitions
// NOTE: recursive definitions
input => objectValue(input), //       should place as lambda.
simpleConstExpr), erase(repeat(commentOrSpace))), repeat(combine(erase(repeat(commentOrSpace), seq(','), repeat(commentOrSpace)), first(input => listValue(input), // NOTE: recursive definitions
// NOTE: recursive definitions
input => objectValue(input), //       should place as lambda.
simpleConstExpr), erase(repeat(commentOrSpace)))), qty(0, 1)(erase(seq(','), repeat(commentOrSpace))), first(ahead(seq(']')), err('listValue: Unexpected token has appeared.')), erase(seq(']'))));
const objectKeyValuePair = combine(objKey, erase(repeat(commentOrSpace), first(seq(':'), err('":" is needed.')), repeat(commentOrSpace)), first(input => listValue(input), // NOTE: recursive definitions
// NOTE: recursive definitions
input => objectValue(input), //       should place as lambda.
simpleConstExpr, err('object value is needed.')));
const objectValue = first(trans(tokens => [[{
  symbol: '#'
}]])(erase(seq('{'), repeat(commentOrSpace), seq('}'))), trans(tokens => {
  const ast = [{
    symbol: '#'
  }];

  for (let i = 0; i < tokens.length; i += 2) {
    if (protection_1.isUnsafeVarNames(protection_1.dummyTargetObject, tokens[i])) {
      throw new Error(`Unsafe symbol name is appeared in object literal: ${tokens[i]}`);
    }

    ast.push([tokens[i], tokens[i + 1]]);
  }

  return [ast];
})(erase(seq('{')), combine(erase(repeat(commentOrSpace)), objectKeyValuePair, erase(repeat(commentOrSpace))), repeat(combine(erase(seq(','), repeat(commentOrSpace)), objectKeyValuePair, erase(repeat(commentOrSpace)))), qty(0, 1)(erase(seq(','), repeat(commentOrSpace))), first(ahead(seq('}')), err('objectValue: Unexpected token has appeared.')), erase(seq('}'))));
const constExpr = first(simpleConstExpr, listValue, objectValue); // const primitiveValue = trans(tokens => [[{symbol: 'primitiveValue'}, tokens[0]]])(
//     first(trueValue, falseValue, nullValue, undefinedValue,
//           numberValue, stringValue, ));

const primitiveValueNoNullUndefined = trans(tokens => [[{
  symbol: 'primitiveValue'
}, tokens[0]]])(first(trueValue, falseValue, numberValue, stringValue));
const primitiveTypeName = trans(tokens => [[{
  symbol: 'primitive'
}, tokens[0]]])(first(seq('number?'), seq('integer?'), seq('bigint?'), seq('string?'), seq('boolean?'), // TODO: '?' is allowed in the sequence assertion
seq('number'), seq('integer'), seq('bigint'), seq('string'), seq('boolean'))); // TODO: function

const additionalPropPrimitiveTypeName = first(seq('number'), seq('string'));
const nullUndefinedTypeName = trans(tokens => [[{
  symbol: 'primitive'
}, tokens[0]]])(first(seq('null'), seq('undefined'), seq('any'), seq('unknown'), seq('never')));
const simpleOrDottedTypeName = first(primitiveTypeName, nullUndefinedTypeName, trans(tokens => [[{
  symbol: 'ref'
}, ...tokens]])(ahead(notCls('Array', 'Partial', 'Pick', 'Omit')), combine(symbolName, repeat(combine(erase(repeat(commentOrSpace), seq('.'), repeat(commentOrSpace)), symbolName)))));
const sequenceType = trans(tokens => [[{
  symbol: 'sequenceOf'
}, ...tokens]])(combine(erase(seq('[')), combine(erase(repeat(commentOrSpace)), input => spreadOrComplexType(first(seq(','), seq(']')))(input), erase(repeat(commentOrSpace))), repeat(combine(erase(seq(','), repeat(commentOrSpace)), input => spreadOrComplexType(first(seq(','), seq(']')))(input), erase(repeat(commentOrSpace)))), qty(0, 1)(erase(seq(','), repeat(commentOrSpace))), first(ahead(seq(']')), err('sequenceType: Unexpected token has appeared.')), erase(seq(']'))));
const arraySizeFactorInner = first(trans(tokens => [[{
  symbol: '#'
}, ['max', tokens[0]]]])(erase(seq('..')), erase(repeat(commentOrSpace)), decimalIntegerValue), trans(tokens => [[{
  symbol: '#'
}, ['min', tokens[0]], ['max', tokens[1]]]])(decimalIntegerValue, erase(repeat(commentOrSpace)), erase(seq('..')), erase(repeat(commentOrSpace)), decimalIntegerValue), trans(tokens => [[{
  symbol: '#'
}, ['min', tokens[0]]]])(decimalIntegerValue, erase(repeat(commentOrSpace)), erase(seq('..'))), trans(tokens => [[{
  symbol: '#'
}, ['min', tokens[0]], ['max', tokens[0]]]])(decimalIntegerValue));
const arraySizeFactor = trans(tokens => tokens.length > 0 ? tokens : [[{
  symbol: '#'
}]])(erase(seq('[')), erase(repeat(commentOrSpace)), qty(0, 1)(arraySizeFactorInner), erase(repeat(commentOrSpace)), erase(seq(']')));
const complexArrayType = trans(tokens => [[{
  symbol: 'repeated'
}, tokens[0], tokens[1]]])(erase(seq('Array')), erase(repeat(commentOrSpace)), erase(seq('<')), erase(repeat(commentOrSpace)), first(input => complexType(first(seq(','), seq('>')))(input), err('type is expected in Array type.')), // [0]
erase(repeat(commentOrSpace)), qty(0, 1)(combine(erase(seq(',')), erase(repeat(commentOrSpace)), first(arraySizeFactorInner, // [1]
err('complexArrayType: Unexpected token has appeared. Expect array size.')), erase(repeat(commentOrSpace)))), first(ahead(seq('>')), err('\'>\' is expected in Array type.')), erase(seq('>')));
const partialType = trans(tokens => [[{
  symbol: 'partial'
}, tokens[0], tokens[1]]])(erase(seq('Partial')), erase(repeat(commentOrSpace)), erase(seq('<')), erase(repeat(commentOrSpace)), first(input => complexType(first(seq(','), seq('>')))(input), err('type is expected in Partial type.')), // [0]
erase(repeat(commentOrSpace)), first(ahead(seq('>')), err('\'>\' is expected in Partial type.')), erase(seq('>')));
const pickOrOmitType = trans(tokens => [[{
  symbol: tokens[0] === 'Pick' ? 'picked' : 'omit'
}, tokens[1], ...tokens.slice(2)]])(first(seq('Pick'), seq('Omit')), // [0]
erase(repeat(commentOrSpace)), erase(seq('<')), erase(repeat(commentOrSpace)), first(input => complexType(first(seq(','), seq('>')))(input), err('type is expected in Partial type.')), // [1]
erase(repeat(commentOrSpace)), combine(erase(seq(',')), erase(repeat(commentOrSpace)), stringValue, // [2]
qty(0)(combine(erase(repeat(commentOrSpace)), erase(seq('|')), erase(repeat(commentOrSpace)), stringValue)), // [3],...
erase(repeat(commentOrSpace))), first(ahead(seq('>')), err('\'>\' is expected in Pick|Omit type.')), erase(seq('>')));
const genericOrSimpleType = trans(tokens => [tokens[0]])( // remove generics parameters
simpleOrDottedTypeName, // [0]
erase(repeat(commentOrSpace)), qty(0, 1)(combine(erase(seq('<')), combine( // [1]
erase(repeat(commentOrSpace)), first(input => complexType(first(seq(','), seq('>')))(input), err('type is expected in generic type.')), erase(repeat(commentOrSpace))), repeat(combine( // [2]...
erase(seq(','), repeat(commentOrSpace)), first(input => complexType(first(seq(','), seq('>')))(input), err('type is expected in generic type.')), erase(repeat(commentOrSpace)))), qty(0, 1)(erase(seq(','), repeat(commentOrSpace))), first(ahead(seq('>')), err('genericType: Unexpected token has appeared.')), erase(seq('>')))));
const spreadType = trans(tokens => [[{
  symbol: 'spread'
}, tokens[0], tokens[1]]])(erase(seq('...')), erase(repeat(commentOrSpace)), erase(seq('<')), erase(repeat(commentOrSpace)), input => complexType(first(seq(','), seq('>')))(input), erase(repeat(commentOrSpace)), qty(0, 1)(combine(erase(seq(',')), erase(repeat(commentOrSpace)), first(arraySizeFactorInner, err('spreadType: Unexpected token has appeared. Expect array size.')), erase(repeat(commentOrSpace)))), first(ahead(seq('>')), err('spreadType: Unexpected token has appeared.')), erase(seq('>')));
const decorator = trans(tokens => [tokens])(decoratorSymbolName, qty(0, 1)(first(combine(erase(seq('('), repeat(commentOrSpace), seq(')'))), combine(erase(seq('(')), first(combine(combine(erase(repeat(commentOrSpace)), first(regexpStringValue, constExpr), erase(repeat(commentOrSpace))), repeat(combine(erase(repeat(commentOrSpace)), erase(seq(',')), erase(repeat(commentOrSpace)), first(regexpStringValue, constExpr), erase(repeat(commentOrSpace)))), qty(0, 1)(erase(seq(','), repeat(commentOrSpace))), first(ahead(seq(')')), err('decorator: Unexpected token has appeared. Expect ")".'))), err('decorator: Unexpected token has appeared.')), erase(seq(')'))))));
const decoratorsClause = trans(tokens => tokens)(repeat(combine(decorator, erase(repeat(commentOrSpace)))));

const complexTypeInnerWOSinpleArrayType = edge => first(primitiveValueNoNullUndefined, genericOrSimpleType, partialType, pickOrOmitType, complexArrayType, sequenceType, input => interfaceDefInner(first(seq(';'), seq(',')))(input));

const complexTypeInnerRoot = edge => trans(tokens => {
  let ty = [{
    symbol: '$pipe'
  }, tokens[1], ...tokens[0]];

  if (tokens[2] !== null) {
    for (const z of tokens[2]) {
      ty = [{
        symbol: 'repeated'
      }, ty, z];
    }
  }

  return [[ty, ...(tokens[3] ? [tokens[3]] : []), ...tokens.slice(4)]];
})(trans(tokens => [tokens])(qty(0, 1)(decoratorsClause)), // [0]
first( // [1]
// [1]
input => complexTypeInnerWOSinpleArrayType(edge)(input), combine(erase(seq('(')), erase(repeat(commentOrSpace)), input => complexType(edge)(input), erase(repeat(commentOrSpace)), erase(seq(')')))), combine(trans(tokens => tokens[0] !== null ? [tokens] : [null])( // [2]
first(qty(1)(combine(erase(repeat(commentOrSpace)), arraySizeFactor)), zeroWidth(() => null))), combine(first( // [3]...
trans(tokens => [tokens[0], ...tokens[1]])(qty(1)(combine(erase(repeat(commentOrSpace)), trans(tokens => [{
  op: tokens[0]
}])(or(seq('&'), seq('|'), seq('-'))), erase(repeat(commentOrSpace)), input => complexTypeInnerRoot(edge)(input)))), trans(tokens => [])()))));

const binaryOp = (op, op1, op2) => {
  return [{
    symbol: op
  }, op1, op2];
};

const isOperator = (v, op) => {
  if (typeof v === 'object' && v.op === op) {
    return true;
  }

  return false;
};

const isValue = v => {
  // TODO: check type
  return true;
}; // production rules:
//   S -> S "&" S


const complexTypeExprRule3 = $o.trans(tokens => [binaryOp('intersect', tokens[0], tokens[2])])($o.clsFn(t => isValue(t)), $o.clsFn(t => isOperator(t, '&')), $o.clsFn(t => isValue(t))); // production rules:
//   S -> S "|" S

const complexTypeExprRule2 = $o.trans(tokens => [binaryOp('oneOf', tokens[0], tokens[2])])($o.clsFn(t => isValue(t)), $o.clsFn(t => isOperator(t, '|')), $o.clsFn(t => isValue(t))); // production rules:
//   S -> S "-" S

const complexTypeExprRule1 = $o.trans(tokens => [binaryOp('subtract', tokens[0], tokens[2])])($o.clsFn(t => isValue(t)), $o.clsFn(t => isOperator(t, '-')), $o.clsFn(t => isValue(t)));

const complexType = edge => rules({
  rules: [complexTypeExprRule3, complexTypeExprRule2, complexTypeExprRule1],
  check: $o.combine($o.classes.any, $o.end())
})(trans(tokens => tokens[0])(complexTypeInnerRoot(edge)));

const spreadOrComplexType = edge => first(spreadType, complexType(edge));

const setDocComment = input => {
  const ret = zeroWidth(() => [])(input);

  if (ret.succeeded) {
    const text = ret.next.context.docComment;
    ret.next.context = Object.assign({}, ret.next.context);
    delete ret.next.context.docComment;
    ret.tokens.length = 0;
    ret.tokens.push(text ? text : null);
  }

  return ret;
};

const typeDef = trans(tokens => [[{
  symbol: 'def'
}, tokens[1], [{
  symbol: 'docComment'
}, tokens[2], tokens[0]]]])(erase(seq('type')), setDocComment, // [0]
erase(qty(1)(commentOrSpace)), first(symbolName, // [1]
err('typeDef: Unexpected token has appeared. Expect symbol name.')), erase(repeat(commentOrSpace)), first(ahead(seq('=')), err('typeDef: Unexpected token has appeared. Expect "=".')), erase(seq('=')), first(combine(erase(repeat(commentOrSpace)), input => complexType(first(seq(','), seq(';')))(input), // [2]
erase(repeat(commentOrSpace))), err('typeDef: Unexpected token has appeared.')), first(ahead(seq(';')), err('typeDef: Unexpected token has appeared. Expect ";".')), erase(seq(';')));
const interfaceExtendsClause = trans(tokens => [[{
  symbol: '$list'
}, ...tokens.map(x => [{
  symbol: 'ref'
}, x])]])(erase(first(seq('extends'), combine(symbolName, err('interfaceExtendsClause: Unexpected token has appeared. Expect "extends" keyword.')))), erase(qty(1)(commentOrSpace)), first(symbolName, err('interfaceExtendsClause: Unexpected token has appeared. Expect symbol name.')), repeat(combine(erase(repeat(commentOrSpace)), erase(seq(',')), erase(repeat(commentOrSpace)), first(symbolName, err('interfaceExtendsClause: Unexpected token has appeared. Expect symbol name.')))));
const interfaceKey = first(trans(tokens => [[{
  symbol: '$list'
}, ...tokens]])(erase(seq('[')), erase(repeat(commentOrSpace), objKey, repeat(commentOrSpace), first(seq(':'), err('":" is needed.')), repeat(commentOrSpace)), repeat(combine(first(regexpStringValue, additionalPropPrimitiveTypeName), erase(repeat(commentOrSpace), seq('|'), repeat(commentOrSpace)))), first(regexpStringValue, additionalPropPrimitiveTypeName), erase(repeat(commentOrSpace)), first(ahead(seq(']')), err('interfaceKey: Unexpected token has appeared. Expect "]".')), erase(seq(']'))), objKey);

const interfaceKeyTypePair = separator => trans(tokens => [[{
  symbol: '$list'
}, tokens[2], [{
  symbol: '$pipe'
}, tokens[3] === '?' ? [{
  symbol: 'optional'
}, tokens[4]] : tokens[4], ...tokens[0]], tokens[1]]])(trans(tokens => [tokens])(first(decoratorsClause, zeroWidth(() => []))), // [0] decorators
setDocComment, // [1]
interfaceKey, // [2] key
first( // [3] '?' | ''
combine(erase(repeat(commentOrSpace)), seq('?'), erase(repeat(commentOrSpace))), zeroWidth(() => [''])), erase(repeat(commentOrSpace), first(seq(':'), err('":" is needed.')), repeat(commentOrSpace)), first( // [4] type
// [4] type
input => complexType(first(separator, seq('}')))(input), err('interface member type is needed.')));

const interfaceDefInner = separator => trans(tokens => [[{
  symbol: 'objectType'
}, ...tokens]])(first(combine(erase(seq('{'), repeat(commentOrSpace), seq('}'))), combine(erase(seq('{')), combine(erase(repeat(commentOrSpace)), interfaceKeyTypePair(separator), erase(repeat(commentOrSpace))), repeat(combine(erase(separator, repeat(commentOrSpace)), interfaceKeyTypePair(separator), erase(repeat(commentOrSpace)))), qty(0, 1)(erase(separator, repeat(commentOrSpace))), first(ahead(seq('}')), err('interfaceDefInner: Unexpected token has appeared. Expect "}".')), erase(seq('}')))));

const interfaceDef = trans(tokens => [[{
  symbol: 'def'
}, tokens[1], [{
  symbol: 'docComment'
}, [{
  symbol: 'derived'
}, tokens[3], [{
  symbol: '$spread'
}, tokens[2]]], tokens[0]]]])(erase(seq('interface')), setDocComment, // [0] base types
erase(qty(1)(commentOrSpace)), first(symbolName, // [1] symbol
err('interfaceDef: Unexpected token has appeared. Expect symbol name.')), erase(repeat(commentOrSpace)), first(interfaceExtendsClause, // [2]
zeroWidth(() => [])), erase(repeat(commentOrSpace)), first(input => interfaceDefInner(first(seq(';'), seq(',')))(input), // [3]
err('interfaceDef: Unexpected token has appeared.')));
const enumKeyValue = trans(tokens => [[{
  symbol: '$list'
}, tokens[1], tokens[2], tokens[0]]])(setDocComment, // [0]
symbolName, erase(repeat(commentOrSpace)), first(combine(erase(seq('=')), first(combine(erase(repeat(commentOrSpace)), first(decimalIntegerValue, stringValue), erase(repeat(commentOrSpace))), err('enumKeyValue: Unexpected token has appeared.'))), zeroWidth(() => null)));
const enumDef = trans(tokens => [[{
  symbol: 'def'
}, tokens[1], [{
  symbol: 'docComment'
}, [{
  symbol: 'enumType'
}, ...tokens.slice(2)], tokens[0]]]])(erase(seq('enum')), setDocComment, // [0]
erase(qty(1)(commentOrSpace)), first(symbolName, err('enumDef: Unexpected token has appeared. Expect symbol name.')), erase(repeat(commentOrSpace)), first(combine(erase(seq('{'), repeat(commentOrSpace), seq('}'))), combine(erase(seq('{')), combine(erase(repeat(commentOrSpace)), enumKeyValue, erase(repeat(commentOrSpace))), repeat(combine(erase(seq(','), repeat(commentOrSpace)), enumKeyValue, erase(repeat(commentOrSpace)))), qty(0, 1)(erase(seq(','), repeat(commentOrSpace))), first(ahead(seq('}')), err('enumDef: Unexpected token has appeared. Expect "}".')), erase(seq('}'))), err('enumDef: Unexpected token has appeared.')));
const internalDef = first(typeDef, interfaceDef, enumDef);
const constDef = trans(tokens => [[{
  symbol: 'asConst'
}, tokens[0]]])(erase(seq('const'), qty(1)(commentOrSpace)), first(enumDef, err('constDef: Unexpected token has appeared.')));
const constDefNoErr = trans(tokens => [[{
  symbol: 'asConst'
}, tokens[0]]])(erase(seq('const'), qty(1)(commentOrSpace)), first(enumDef));
const exportedDef = trans(tokens => [[{
  symbol: 'export'
}, tokens[0]]])(erase(seq('export'), qty(1)(commentOrSpace)), first(constDef, internalDef, input => declareTypeAndEnumStatement(input), input => declareVarStatement(input), err('exportedDef: Unexpected token has appeared.')));
const defStatement = trans(tokens => [[{
  symbol: '$local'
}, [[{
  symbol: '_ty'
}, tokens[1]]], [{
  symbol: 'redef'
}, {
  symbol: '_ty'
}, [{
  symbol: '$pipe'
}, {
  symbol: '_ty'
}, ...tokens[0]]]]])(trans(tokens => [tokens])(first(decoratorsClause, zeroWidth(() => []))), // [0] decorators
first(exportedDef, // [1] body
// [1] body
input => declareTypeAndEnumStatement(input), constDef, internalDef));
const externalSymbolAndType = trans(tokens => [[{
  symbol: '$list'
}, ...tokens]])(symbolName, erase(repeat(commentOrSpace)), qty(0, 1)(combine(erase(seq(':')), erase(repeat(commentOrSpace)), input => complexType(first(seq(';'), seq(',')))(input))));
exports.externalTypeDef = trans(tokens => [[{
  symbol: 'external'
}, ...tokens]])(erase(seq('external')), erase(qty(1)(commentOrSpace)), externalSymbolAndType, repeat(combine(erase(repeat(commentOrSpace)), erase(cls(',')), erase(repeat(commentOrSpace)), first(externalSymbolAndType, err('externalTypeDef: Unexpected token has appeared. Expect symbol name.')), erase(repeat(commentOrSpace)))), erase(repeat(commentOrSpace)), first(ahead(cls(';')), err('externalTypeDef: Unexpected token has appeared. Expect ";".')), erase(cls(';')));
const declareTypeAndEnumStatement = trans(tokens => [[{
  symbol: 'asDeclare'
}, ...tokens]])(erase(seq('declare')), erase(qty(1)(commentOrSpace)), first(constDefNoErr, // NOTE: There is still the possibility of "const varName". -> `declareVarStatement` will be called.
internalDef));
const declareVarStatement = trans(tokens => [[{
  symbol: 'passthru'
}, tokens[0], tokens[1]]])(cat(seq('declare'), qty(1)(commentOrSpace), first(seq('var'), seq('let'), seq('const'), err('declareVarStatement: Unexpected token has appeared. Expect "var|let|const".')), qty(1)(commentOrSpace), cat(repeat(notCls(';'))), first(ahead(seq(';')), err('declareVarStatement: Unexpected token has appeared. Expect ";".')), cls(';')), setDocComment); // [1]

const importStatement = trans(tokens => [[{
  symbol: 'passthru'
}, tokens[0]]])(cat(seq('import'), qty(1)(commentOrSpace), cat(repeat(notCls(';'))), first(ahead(seq(';')), err('importStatement: Unexpected token has appeared. Expect ";".')), cls(';')));
const definition = first(directiveLineComment, directiveBlockComment, defStatement, exports.externalTypeDef, declareVarStatement, importStatement);
exports.program = makeProgram(combine(erase(repeat(commentOrSpace)), repeat(combine(definition, erase(repeat(commentOrSpace)))), erase(repeat(commentOrSpace)), first(ahead(end()), err('program: Unexpected token has appeared.')), end()));

/***/ }),

/***/ "./src/lib/escape.ts":
/*!***************************!*\
  !*** ./src/lib/escape.ts ***!
  \***************************/
/*! flagged exports */
/*! export __esModule [provided] [no usage info] [missing usage info prevents renaming] */
/*! export escapeString [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_exports__ */
/***/ ((__unused_webpack_module, exports) => {

 // Copyright (c) 2019 Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.escapeString = void 0;

function escapeString(s) {
  return s.replace(/\x08/g, '\\b').replace(/\f/g, '\\f').replace(/\n/g, '\\n').replace(/\r/g, '\\r').replace(/\t/g, '\\t').replace(/\v/g, '\\v').replace(/\\/g, '\\\\').replace(/\'/g, '\\\'').replace(/\"/g, '\\\"').replace(/\`/g, '\\\`');
}

exports.escapeString = escapeString;

/***/ }),

/***/ "./src/lib/protection.ts":
/*!*******************************!*\
  !*** ./src/lib/protection.ts ***!
  \*******************************/
/*! flagged exports */
/*! export __esModule [provided] [no usage info] [missing usage info prevents renaming] */
/*! export dummyTargetObject [provided] [no usage info] [missing usage info prevents renaming] */
/*! export funConstructor [provided] [no usage info] [missing usage info prevents renaming] */
/*! export globalObj [provided] [no usage info] [missing usage info prevents renaming] */
/*! export isUnsafeVarNames [provided] [no usage info] [missing usage info prevents renaming] */
/*! export objConstructor [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_exports__ */
/***/ ((__unused_webpack_module, exports) => {

 // Copyright (c) 2020 Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln

var _a;

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.isUnsafeVarNames = exports.funConstructor = exports.objConstructor = exports.globalObj = exports.dummyTargetObject = void 0; // tslint:disable: no-shadowed-variable
// tslint:disable: function-constructor

exports.dummyTargetObject = {}; // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment

_a = (() => {
  var _a, _b;

  let globalObj = null;

  try {
    // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment, @typescript-eslint/no-implied-eval
    globalObj = Function('return this')();
  } catch (e) {// Nothing to do.
  }

  if (!globalObj) {
    // Fall back (for CSP, etc...)
    if (typeof window === 'object' && window) {
      globalObj = window;
    } else if (typeof global === 'object' && global) {
      globalObj = global;
    } else if (typeof globalThis === 'object' && globalThis) {
      globalObj = globalThis;
    } else {
      globalObj = exports.dummyTargetObject;
    }
  } // NOTE: ({}).constructor === Object
  // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment


  let objConstructor = null;

  try {
    // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
    objConstructor = (_a = {}.constructor) !== null && _a !== void 0 ? _a : Object;
  } catch (e) {// Nothing to do.
  }

  if (!objConstructor) {
    // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
    objConstructor = exports.dummyTargetObject;
  } // NOTE: ({}).toString.constructor === Function
  // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment


  let funConstructor = null;

  try {
    // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
    funConstructor = (_b = {}.toString.constructor) !== null && _b !== void 0 ? _b : Function;
  } catch (e) {// Nothing to do.
  }

  if (!funConstructor) {
    // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
    funConstructor = exports.dummyTargetObject;
  }

  return {
    // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
    g: globalObj,
    o: objConstructor,
    f: funConstructor
  };
})(), exports.globalObj = _a.g, exports.objConstructor = _a.o, exports.funConstructor = _a.f; // eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types

function isUnsafeVarNames(target, varName) {
  if (target === exports.globalObj || varName === '__proto__' || varName === '__defineGetter__' || varName === '__defineSetter__' || varName === '__lookupGetter__' || varName === '__lookupSetter__') {
    return true;
  }

  if (varName === 'prototype' || varName === 'constructor') {
    if (target === null || target === void 0 || typeof target === 'function') {
      return true;
    }
  }

  if (target === null || target === void 0 || target === exports.objConstructor) {
    if (Object.prototype.hasOwnProperty.call(exports.objConstructor, varName)) {
      return true;
    }
  }

  if (target === null || target === void 0 || target === exports.funConstructor) {
    // checking 'call', 'arguments', 'caller', ...
    let con = exports.funConstructor;

    while (con) {
      // eslint-disable-next-line @typescript-eslint/no-unsafe-call, @typescript-eslint/no-unsafe-member-access
      if (Object.prototype.hasOwnProperty.call(con, varName)) {
        return true;
      } // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment, @typescript-eslint/no-unsafe-member-access


      con = con.__proto__;
    }
  }

  if (typeof target === 'function') {
    // eslint-disable-next-line @typescript-eslint/no-unsafe-call, @typescript-eslint/no-unsafe-member-access
    if (!Object.prototype.hasOwnProperty.call(target, varName)) {
      // function's prototypes' members
      return true;
    }
  }

  return false;
}

exports.isUnsafeVarNames = isUnsafeVarNames;

/***/ }),

/***/ "./src/lib/resolver.ts":
/*!*****************************!*\
  !*** ./src/lib/resolver.ts ***!
  \*****************************/
/*! flagged exports */
/*! export __esModule [provided] [no usage info] [missing usage info prevents renaming] */
/*! export resolveMemberNames [provided] [no usage info] [missing usage info prevents renaming] */
/*! export resolveSchema [provided] [no usage info] [missing usage info prevents renaming] */
/*! export resolveSymbols [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_exports__, __webpack_require__ */
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

 // Copyright (c) 2019 Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.resolveSchema = exports.resolveSymbols = exports.resolveMemberNames = void 0;

const operators = __webpack_require__(/*! ../operators */ "./src/operators.ts");

const util_1 = __webpack_require__(/*! ../lib/util */ "./src/lib/util.ts");

function mergeTypeAndSymlink(ty, link) {
  const link2 = Object.assign({}, link);
  delete link2.kind; // NOTE: (TS>=4.0) TS2790: The operand of a 'delete' operator must be optional.

  delete link2.symlinkTargetName; // NOTE: (TS>=4.0) TS2790: The operand of a 'delete' operator must be optional.

  delete link2.memberTree; // NOTE: (TS>=4.0) TS2790: The operand of a 'delete' operator must be optional.

  return Object.assign(Object.assign({}, ty), link2);
}

function updateSchema(original, schema, ty, typeName) {
  if (typeName && schema.has(typeName)) {
    const z = schema.get(typeName);

    if (z.ty === original) {
      schema.set(typeName, Object.assign(Object.assign({}, z), {
        ty,
        resolved: true
      }));
    }
  }

  return ty;
}

function resolveMemberNames(ty, rootSym, memberTreeSymbols, memberPos) {
  const addTypeName = (mt, typeName, memberSym) => {
    if (typeName) {
      return Object.assign(Object.assign({}, mt), {
        typeName: memberPos === 0 ? `${rootSym}.${memberTreeSymbols.join('.')}` : `${typeName}.${memberSym}`
      });
    } else {
      return mt;
    }
  };

  for (let i = memberPos; i < memberTreeSymbols.length; i++) {
    const memberSym = memberTreeSymbols[i];

    switch (ty.kind) {
      case 'optional':
        return resolveMemberNames(ty.optional, rootSym, memberTreeSymbols, i + 1);

      case 'object':
        for (const m of ty.members) {
          if (memberSym === m[0]) {
            return addTypeName(resolveMemberNames(m[1], rootSym, memberTreeSymbols, i + 1), ty.typeName, memberSym);
          }
        }

        if (ty.additionalProps) {
          for (const m of ty.additionalProps) {
            for (const k of m[0]) {
              switch (k) {
                case 'number':
                  if (util_1.NumberPattern.test(memberSym)) {
                    return resolveMemberNames(m[1], rootSym, memberTreeSymbols, i + 1);
                  }

                  break;

                case 'string':
                  return resolveMemberNames(m[1], rootSym, memberTreeSymbols, i + 1);

                default:
                  if (k.test(memberSym)) {
                    return resolveMemberNames(m[1], rootSym, memberTreeSymbols, i + 1);
                  }

                  break;
              }
            }
          }
        }

        throw new Error(`Undefined member name is appeared: ${memberSym}`);

      case 'symlink':
        if (!ty.typeName) {
          throw new Error(`Reference of anonymous type is appeared: ${memberSym}`);
        }

        return Object.assign({
          kind: 'symlink',
          symlinkTargetName: rootSym,
          name: memberSym,
          typeName: rootSym
        }, 0 < memberTreeSymbols.length ? {
          memberTree: memberTreeSymbols
        } : {});

      default:
        // TODO: kind === 'operator'
        throw new Error(`Unsupported type kind is appeared: (kind:${ty.kind}).${memberSym}`);
    }
  }

  return ty;
}

exports.resolveMemberNames = resolveMemberNames;

function resolveSymbols(schema, ty, ctx) {
  var _a;

  const ctx2 = Object.assign(Object.assign({}, ctx), {
    nestLevel: ctx.nestLevel + 1
  });

  switch (ty.kind) {
    case 'symlink':
      {
        const x = schema.get(ty.symlinkTargetName);

        if (!x) {
          throw new Error(`Undefined symbol '${ty.symlinkTargetName}' is referred.`);
        }

        if (0 <= ctx.symlinkStack.findIndex(s => s === ty.symlinkTargetName)) {
          return ty;
        }

        const ty2 = Object.assign({}, ty);
        let xTy = x.ty;

        if (ty.memberTree && 0 < ty.memberTree.length) {
          xTy = Object.assign({}, resolveMemberNames(xTy, ty.symlinkTargetName, ty.memberTree, 0));
          ty2.typeName = xTy.typeName;
        }

        return resolveSymbols(schema, mergeTypeAndSymlink(xTy, ty2), Object.assign(Object.assign({}, ctx2), {
          symlinkStack: [...ctx2.symlinkStack, ty2.symlinkTargetName]
        }));
      }

    case 'repeated':
      return updateSchema(ty, schema, Object.assign(Object.assign({}, ty), {
        repeated: resolveSymbols(schema, ty.repeated, ctx2)
      }), ty.typeName);

    case 'spread':
      return updateSchema(ty, schema, Object.assign(Object.assign({}, ty), {
        spread: resolveSymbols(schema, ty.spread, ctx2)
      }), ty.typeName);

    case 'sequence':
      return updateSchema(ty, schema, Object.assign(Object.assign({}, ty), {
        sequence: ty.sequence.map(x => resolveSymbols(schema, x, ctx2))
      }), ty.typeName);

    case 'one-of':
      return updateSchema(ty, schema, Object.assign(Object.assign({}, ty), {
        oneOf: ty.oneOf.map(x => resolveSymbols(schema, x, ctx2))
      }), ty.typeName);

    case 'optional':
      return updateSchema(ty, schema, Object.assign(Object.assign({}, ty), {
        optional: resolveSymbols(schema, ty.optional, ctx2)
      }), ty.typeName);

    case 'object':
      {
        if (0 < ctx.nestLevel && ty.typeName && 0 <= ctx.symlinkStack.findIndex(s => s === ty.typeName)) {
          if (schema.has(ty.typeName)) {
            const z = schema.get(ty.typeName);

            if (z.resolved) {
              return z.ty;
            }
          }
        }

        const baseSymlinks = (_a = ty.baseTypes) === null || _a === void 0 ? void 0 : _a.filter(x => x.kind === 'symlink');

        if (baseSymlinks && baseSymlinks.length > 0 && !ctx.isDeserialization) {
          const exts = baseSymlinks.map(x => resolveSymbols(schema, x, ctx2)).filter(x => x.kind === 'object'); // TODO: if x.kind !== 'object' items exist -> error?

          const d2 = resolveSymbols(schema, operators.derived(Object.assign(Object.assign({}, ty), ty.baseTypes ? {
            baseTypes: ty.baseTypes.filter(x => x.kind !== 'symlink')
          } : {}), ...exts), ty.typeName ? Object.assign(Object.assign({}, ctx2), {
            symlinkStack: [...ctx2.symlinkStack, ty.typeName]
          }) : ctx2);
          return updateSchema(ty, schema, Object.assign(Object.assign({}, ty), d2), ty.typeName);
        } else {
          return updateSchema(ty, schema, Object.assign(Object.assign(Object.assign({}, Object.assign(Object.assign({}, ty), {
            members: ty.members.map(x => [x[0], resolveSymbols(schema, x[1], ty.typeName ? Object.assign(Object.assign({}, ctx2), {
              symlinkStack: [...ctx2.symlinkStack, ty.typeName]
            }) : ctx2), ...x.slice(2)])
          })), ty.additionalProps && 0 < ty.additionalProps.length ? {
            additionalProps: ty.additionalProps.map(x => [x[0], resolveSymbols(schema, x[1], ty.typeName ? Object.assign(Object.assign({}, ctx2), {
              symlinkStack: [...ctx2.symlinkStack, ty.typeName]
            }) : ctx2), ...x.slice(2)])
          } : {}), ty.baseTypes && 0 < ty.baseTypes.length ? {
            baseTypes: ctx.isDeserialization ? ty.baseTypes.map(x => x.kind === 'symlink' ? resolveSymbols(schema, x, ctx2) : x).filter(x => x.kind === 'object') : ty.baseTypes
          } : {}), ty.typeName);
        }
      }

    case 'operator':
      if (ctx2.operators) {
        const ctx3 = ty.typeName ? Object.assign(Object.assign({}, ctx2), {
          symlinkStack: [...ctx2.symlinkStack, ty.typeName]
        }) : ctx2;
        const operands = ty.operands.map(x => {
          if (typeof x === 'object' && x.kind) {
            return resolveSymbols(schema, x, ctx3);
          }

          return x;
        });

        if (0 < operands.filter(x => x && typeof x === 'object' && (x.kind === 'symlink' || x.kind === 'operator')).length) {
          throw new Error(`Unresolved type operator is found: ${ty.operator}`);
        }

        if (!ctx2.operators[ty.operator]) {
          throw new Error(`Undefined type operator is found: ${ty.operator}`);
        }

        const ty2 = Object.assign({}, ty);
        delete ty2.operator; // NOTE: (TS>=4.0) TS2790: The operand of a 'delete' operator must be optional.

        delete ty2.operands; // NOTE: (TS>=4.0) TS2790: The operand of a 'delete' operator must be optional.

        return updateSchema(ty, schema, Object.assign(Object.assign({}, ty2), resolveSymbols(schema, ctx2.operators[ty.operator](...operands), ctx3)), ty.typeName);
      } else {
        return ty;
      }

    default:
      return ty;
  }
}

exports.resolveSymbols = resolveSymbols;
const resolverOps = {
  picked: operators.picked,
  omit: operators.omit,
  partial: operators.partial,
  intersect: operators.intersect,
  subtract: operators.subtract
};

function resolveSchema(schema, opts) {
  for (const ent of schema.entries()) {
    const ty = resolveSymbols(schema, ent[1].ty, Object.assign(Object.assign({}, opts), {
      nestLevel: 0,
      symlinkStack: [ent[0]],
      operators: resolverOps
    }));
    ent[1].ty = ty;
  }

  return schema;
}

exports.resolveSchema = resolveSchema;

/***/ }),

/***/ "./src/lib/util.ts":
/*!*************************!*\
  !*** ./src/lib/util.ts ***!
  \*************************/
/*! flagged exports */
/*! export DatePattern [provided] [no usage info] [missing usage info prevents renaming] */
/*! export DateTimeNoTzPattern [provided] [no usage info] [missing usage info prevents renaming] */
/*! export DateTimePattern [provided] [no usage info] [missing usage info prevents renaming] */
/*! export NumberPattern [provided] [no usage info] [missing usage info prevents renaming] */
/*! export SymbolPattern [provided] [no usage info] [missing usage info prevents renaming] */
/*! export __esModule [provided] [no usage info] [missing usage info prevents renaming] */
/*! export nvl [provided] [no usage info] [missing usage info prevents renaming] */
/*! export nvl2 [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_exports__ */
/***/ ((__unused_webpack_module, exports) => {

 // Copyright (c) 2020 Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.nvl2 = exports.nvl = exports.DateTimeNoTzPattern = exports.DateTimePattern = exports.DatePattern = exports.NumberPattern = exports.SymbolPattern = void 0;
exports.SymbolPattern = /^[A-Za-z_$][A-Za-z0-9_$]*$/;
exports.NumberPattern = /^([\+\-]?\d*\.?\d+(?:[Ee][\+\-]?\d+)?)$/;
exports.DatePattern = /^(\d{4}-[01]\d-[0-3]\d)$/;
exports.DateTimePattern = /^((?:(?:\d{4}-[01]\d-[0-3]\dT[0-2]\d:[0-5]\d:[0-5]\d\.\d+)|(?:\d{4}-[01]\d-[0-3]\dT[0-2]\d:[0-5]\d:[0-5]\d)|(?:\d{4}-[01]\d-[0-3]\dT[0-2]\d:[0-5]\d))(?:[+-][0-2]\d:[0-5]\d|Z))$/;
exports.DateTimeNoTzPattern = /^((?:\d{4}-[01]\d-[0-3]\dT[0-2]\d:[0-5]\d:[0-5]\d\.\d+)|(?:\d{4}-[01]\d-[0-3]\dT[0-2]\d:[0-5]\d:[0-5]\d)|(?:\d{4}-[01]\d-[0-3]\dT[0-2]\d:[0-5]\d))$/;

function nvl(v, alt) {
  return v !== null && v !== void 0 ? v : alt;
}

exports.nvl = nvl;

function nvl2(v, f, alt) {
  return v !== null && v !== void 0 ? f(v) : alt;
}

exports.nvl2 = nvl2;

/***/ }),

/***/ "./src/operators.ts":
/*!**************************!*\
  !*** ./src/operators.ts ***!
  \**************************/
/*! flagged exports */
/*! export __esModule [provided] [no usage info] [missing usage info prevents renaming] */
/*! export derived [provided] [no usage info] [missing usage info prevents renaming] */
/*! export enumType [provided] [no usage info] [missing usage info prevents renaming] */
/*! export intersect [provided] [no usage info] [missing usage info prevents renaming] */
/*! export objectType [provided] [no usage info] [missing usage info prevents renaming] */
/*! export omit [provided] [no usage info] [missing usage info prevents renaming] */
/*! export oneOf [provided] [no usage info] [missing usage info prevents renaming] */
/*! export optional [provided] [no usage info] [missing usage info prevents renaming] */
/*! export partial [provided] [no usage info] [missing usage info prevents renaming] */
/*! export picked [provided] [no usage info] [missing usage info prevents renaming] */
/*! export primitive [provided] [no usage info] [missing usage info prevents renaming] */
/*! export primitiveValue [provided] [no usage info] [missing usage info prevents renaming] */
/*! export regexpPatternStringType [provided] [no usage info] [missing usage info prevents renaming] */
/*! export repeated [provided] [no usage info] [missing usage info prevents renaming] */
/*! export sequenceOf [provided] [no usage info] [missing usage info prevents renaming] */
/*! export spread [provided] [no usage info] [missing usage info prevents renaming] */
/*! export subtract [provided] [no usage info] [missing usage info prevents renaming] */
/*! export symlinkType [provided] [no usage info] [missing usage info prevents renaming] */
/*! export withConstraint [provided] [no usage info] [missing usage info prevents renaming] */
/*! export withDocComment [provided] [no usage info] [missing usage info prevents renaming] */
/*! export withForceCast [provided] [no usage info] [missing usage info prevents renaming] */
/*! export withGreaterThan [provided] [no usage info] [missing usage info prevents renaming] */
/*! export withLessThan [provided] [no usage info] [missing usage info prevents renaming] */
/*! export withMatch [provided] [no usage info] [missing usage info prevents renaming] */
/*! export withMaxLength [provided] [no usage info] [missing usage info prevents renaming] */
/*! export withMaxValue [provided] [no usage info] [missing usage info prevents renaming] */
/*! export withMeta [provided] [no usage info] [missing usage info prevents renaming] */
/*! export withMinLength [provided] [no usage info] [missing usage info prevents renaming] */
/*! export withMinValue [provided] [no usage info] [missing usage info prevents renaming] */
/*! export withMsg [provided] [no usage info] [missing usage info prevents renaming] */
/*! export withMsgId [provided] [no usage info] [missing usage info prevents renaming] */
/*! export withName [provided] [no usage info] [missing usage info prevents renaming] */
/*! export withOriginalTypeName [provided] [no usage info] [missing usage info prevents renaming] */
/*! export withRange [provided] [no usage info] [missing usage info prevents renaming] */
/*! export withRecordType [provided] [no usage info] [missing usage info prevents renaming] */
/*! export withStereotype [provided] [no usage info] [missing usage info prevents renaming] */
/*! export withTypeName [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_exports__, __webpack_require__ */
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

 // Copyright (c) 2019 Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.withMsgId = exports.withMsg = exports.withMeta = exports.withRecordType = exports.withForceCast = exports.withConstraint = exports.withStereotype = exports.withMatch = exports.withMaxLength = exports.withMinLength = exports.withLessThan = exports.withGreaterThan = exports.withMaxValue = exports.withMinValue = exports.withRange = exports.withDocComment = exports.withOriginalTypeName = exports.withTypeName = exports.withName = exports.symlinkType = exports.derived = exports.objectType = exports.enumType = exports.spread = exports.sequenceOf = exports.repeated = exports.optional = exports.primitiveValue = exports.regexpPatternStringType = exports.primitive = exports.subtract = exports.oneOf = exports.intersect = exports.partial = exports.omit = exports.picked = void 0;

const protection_1 = __webpack_require__(/*! ./lib/protection */ "./src/lib/protection.ts"); // emulate Pick<T> // ex. Pick<Foo, 'a' | 'b'>


function picked(ty, ...names) {
  switch (ty.kind) {
    case 'object':
      {
        const members = [];

        for (const name of names) {
          const member = ty.members.find(x => x[0] === name);

          if (member) {
            if (member[2]) {
              const m2 = [...member];

              if (3 < m2.length) {
                m2[2] = false;
              } else {
                m2.length = 2;
              }

              members.push(m2);
            } else {
              members.push(member);
            }
          }
        }

        return {
          kind: 'object',
          members
        };
      }

    case 'symlink':
    case 'operator':
      {
        return {
          kind: 'operator',
          operator: 'picked',
          operands: [ty, ...names]
        };
      }

    default:
      return {
        kind: 'object',
        members: []
      };
  }
}

exports.picked = picked; // emulate Omit<T> // ex. Omit<Foo, 'a' | 'b'>

function omit(ty, ...names) {
  switch (ty.kind) {
    case 'object':
      {
        const members = [];

        for (const member of ty.members) {
          if (!names.find(name => member[0] === name)) {
            if (member[2]) {
              const m2 = [...member];

              if (3 < m2.length) {
                m2[2] = false;
              } else {
                m2.length = 2;
              }

              members.push(m2);
            } else {
              members.push(member);
            }
          }
        }

        return {
          kind: 'object',
          members
        };
      }

    case 'symlink':
    case 'operator':
      {
        return {
          kind: 'operator',
          operator: 'omit',
          operands: [ty, ...names]
        };
      }

    default:
      return {
        kind: 'object',
        members: []
      };
  }
}

exports.omit = omit; // emulate Partial<T>

function partial(ty) {
  switch (ty.kind) {
    case 'object':
      {
        const members = [];

        for (const member of ty.members) {
          let m = member[1].kind === 'optional' ? member : [member[0], optional(member[1]), ...member.slice(2)];

          if (m[2]) {
            m = [...m];

            if (3 < m.length) {
              m[2] = false;
            } else {
              m.length = 2;
            }
          }

          m[1].name = m[0];
          const optTy = Object.assign({}, m[1].optional);
          m[1].optional = optTy;

          if (optTy.name && optTy.name !== optTy.typeName) {
            delete optTy.name;
          }

          if (!optTy.name && optTy.typeName) {
            optTy.name = optTy.typeName;
          }

          members.push(m);
        }

        return {
          kind: 'object',
          members
        };
      }

    case 'symlink':
    case 'operator':
      {
        return {
          kind: 'operator',
          operator: 'partial',
          operands: [ty]
        };
      }

    default:
      return ty;
  }
}

exports.partial = partial; // intersection (a & b)

function intersect(...types) {
  if (types.length === 0) {
    throw new Error(`Empty intersection type is not allowed.`);
  }

  if (0 < types.filter(x => x && typeof x === 'object' && (x.kind === 'symlink' || x.kind === 'operator')).length) {
    return {
      kind: 'operator',
      operator: 'intersect',
      operands: types.slice()
    };
  }

  let lastTy = null;
  const members = new Map();

  for (const ty of types) {
    if (ty && typeof ty === 'object') {
      if (lastTy && lastTy.kind !== ty.kind) {
        return {
          kind: 'never'
        };
      }

      lastTy = ty;

      if (ty.kind === 'object') {
        for (const m of ty.members) {
          if (m[2]) {
            const m2 = [...m];

            if (3 < m2.length) {
              m2[2] = false;
            } else {
              m2.length = 2;
            }

            members.set(m[0], m2); // Overwrite if exists
          } else {
            members.set(m[0], m); // Overwrite if exists
          }
        }
      }
    } else {
      return {
        kind: 'never'
      };
    }
  }

  if (lastTy && lastTy.kind !== 'object') {
    return lastTy;
  } else {
    return {
      kind: 'object',
      members: Array.from(members.values())
    };
  }
}

exports.intersect = intersect; // union (a | b)

function oneOf(...types) {
  if (types.length === 0) {
    throw new Error(`Empty union type is not allowed.`);
  }

  if (types.length === 1) {
    const ty = types[0];

    if (ty && typeof ty === 'object') {
      return ty;
    } else {
      return primitiveValue(ty);
    }
  }

  const ret = {
    kind: 'one-of',
    oneOf: []
  };

  for (const ty of types) {
    // TODO: remove same type
    if (ty && typeof ty === 'object') {
      if (ty.kind === 'one-of') {
        ret.oneOf = ret.oneOf.concat(ty.oneOf);
      } else {
        ret.oneOf.push(ty);
      }
    } else {
      ret.oneOf.push(primitiveValue(ty));
    }
  }

  return ret;
}

exports.oneOf = oneOf; // subtraction (a - b)

function subtract(...types) {
  if (types.length === 0) {
    throw new Error(`Empty subtraction type is not allowed.`);
  }

  if (0 < types.filter(x => x && typeof x === 'object' && (x.kind === 'symlink' || x.kind === 'operator')).length) {
    return {
      kind: 'operator',
      operator: 'subtract',
      operands: types.slice()
    };
  }

  let ret = types[0];

  if (!ret || typeof ret !== 'object' || ret.kind !== 'object') {
    throw new Error(`First parameter of subtraction type should be 'object'.`);
  }

  for (const ty of types.slice(1)) {
    if (ty && typeof ty === 'object' && ty.kind === 'object') {
      ret = omit(ret, ...ty.members.map(m => m[0]));
    }
  }

  return ret;
}

exports.subtract = subtract;

function primitive(typeName) {
  switch (typeName) {
    case 'never':
      return {
        kind: 'never'
      };

    case 'any':
      return {
        kind: 'any'
      };

    case 'unknown':
      return {
        kind: 'unknown'
      };

    case 'number': // FALL_THRU

    case 'integer': // FALL_THRU

    case 'bigint': // FALL_THRU

    case 'string': // FALL_THRU

    case 'boolean': // FALL_THRU

    case 'null': // FALL_THRU

    case 'undefined':
      return {
        kind: 'primitive',
        primitiveName: typeName
      };

    case 'never?':
      return optional({
        kind: 'never'
      });

    case 'any?':
      return optional({
        kind: 'any'
      });

    case 'unknown?':
      return optional({
        kind: 'unknown'
      });

    case 'number?': // FALL_THRU

    case 'integer?': // FALL_THRU

    case 'bigint?': // FALL_THRU

    case 'string?': // FALL_THRU

    case 'boolean?': // FALL_THRU

    case 'null?': // FALL_THRU

    case 'undefined?':
      return optional({
        kind: 'primitive',
        primitiveName: typeName.substring(0, typeName.length - 1)
      });

    default:
      throw new Error(`Unknown primitive type assertion: ${typeName}`);
  } // TODO: Function, DateStr, DateTimeStr, Funtion?, DateStr?, DateTimeStr?

}

exports.primitive = primitive;

function regexpPatternStringType(pattern) {
  return {
    kind: 'primitive',
    primitiveName: 'string',
    pattern
  };
}

exports.regexpPatternStringType = regexpPatternStringType;

function primitiveValue(value) {
  if (value === null || value === void 0) {
    return {
      kind: 'primitive-value',
      value
    };
  } else switch (typeof value) {
    case 'number': // FALL_THRU

    case 'bigint': // FALL_THRU

    case 'string': // FALL_THRU

    case 'boolean':
      return {
        kind: 'primitive-value',
        value
      };

    default:
      throw new Error(`Unknown primitive value assertion: ${value}`);
  }
}

exports.primitiveValue = primitiveValue;

function optional(ty) {
  if (ty && typeof ty === 'object' && ty.kind) {
    if (ty.kind === 'optional') {
      return ty;
    } else {
      return Object.assign({
        kind: 'optional',
        optional: ty
      }, ty.typeName ? {
        typeName: ty.typeName
      } : {});
    }
  } else {
    return {
      kind: 'optional',
      optional: primitiveValue(ty)
    };
  }
}

exports.optional = optional;

function repeated(ty, option) {
  if (ty && typeof ty === 'object' && ty.kind) {
    return {
      kind: 'repeated',
      min: option && typeof option.min === 'number' ? option.min : null,
      max: option && typeof option.max === 'number' ? option.max : null,
      repeated: ty
    };
  } else {
    return {
      kind: 'repeated',
      min: option && typeof option.min === 'number' ? option.min : null,
      max: option && typeof option.max === 'number' ? option.max : null,
      repeated: primitive(ty)
    };
  }
}

exports.repeated = repeated;

function sequenceOf(...seq) {
  return {
    kind: 'sequence',
    sequence: seq.map(ty => ty && typeof ty === 'object' && ty.kind ? ty : primitiveValue(ty))
  };
}

exports.sequenceOf = sequenceOf;

function spread(ty, option) {
  if (ty && typeof ty === 'object' && ty.kind) {
    return {
      kind: 'spread',
      min: option && typeof option.min === 'number' ? option.min : null,
      max: option && typeof option.max === 'number' ? option.max : null,
      spread: ty
    };
  } else {
    return {
      kind: 'spread',
      min: option && typeof option.min === 'number' ? option.min : null,
      max: option && typeof option.max === 'number' ? option.max : null,
      spread: primitiveValue(ty)
    };
  }
}

exports.spread = spread;

function enumType(...values) {
  const ar = values.slice();
  let value = 0;

  for (let i = 0; i < ar.length; i++) {
    if (protection_1.isUnsafeVarNames(protection_1.dummyTargetObject, ar[i][0])) {
      throw new Error(`Unsafe symbol name is appeared in enum assertion: ${ar[i][0]}`);
    }

    if (ar[i][1] === null || ar[i][1] === void 0) {
      ar[i][1] = value++;
    } else if (typeof ar[i][1] === 'number') {
      value = ar[i][1] + 1;
    }

    if (!ar[i][2]) {
      ar[i].length = 2;
    }
  }

  return {
    kind: 'enum',
    values: ar
  };
}

exports.enumType = enumType;

function objectType(...members) {
  const revMembers = members.slice().reverse();

  for (const x of members) {
    if (typeof x[0] === 'string') {
      if (protection_1.isUnsafeVarNames(protection_1.dummyTargetObject, x[0])) {
        throw new Error(`Unsafe symbol name is appeared in object assertion: ${x[0]}`);
      }

      if (members.find(m => m[0] === x[0]) !== revMembers.find(m => m[0] === x[0])) {
        throw new Error(`Duplicated member is found: ${x[0]}`);
      }
    }
  }

  const membersProps = members.filter(x => typeof x[0] === 'string').map(x => x[1] && typeof x[1] === 'object' && x[1].kind ? [x[0], withName(x[1], x[0]), x[2]] : [x[0], withName(primitiveValue(x[1]), x[0]), x[2]]).map(x => x[2] ? [x[0], x[1], false, ...x.slice(2)] : [x[0], x[1]]);
  const additionalProps = members.filter(x => typeof x[0] !== 'string').map(x => x[1] && typeof x[1] === 'object' && x[1].kind ? x : [x[0], primitiveValue(x[1]), x[2]]).map(x => x[2] ? [x[0], x[1], false, ...x.slice(2)] : [x[0], x[1]]);
  return Object.assign({
    kind: 'object',
    members: membersProps
  }, 0 < additionalProps.length ? {
    additionalProps
  } : {});
}

exports.objectType = objectType;

function checkRecursiveExtends(ty, base) {
  if (ty === base) {
    return false;
  }

  if (ty.typeName && (ty.typeName === base.typeName || base.kind === 'symlink' && ty.typeName === base.symlinkTargetName)) {
    return false;
  }

  if (base.kind === 'object' && base.baseTypes) {
    for (const z of base.baseTypes) {
      if (!checkRecursiveExtends(ty, z)) {
        return false;
      }
    }
  }

  return true;
}

function derived(ty, ...exts) {
  const ret = {
    kind: 'object',
    members: [],
    baseTypes: []
  };

  for (const ext of exts) {
    switch (ext.kind) {
      case 'object':
        if (!checkRecursiveExtends(ty, ext)) {
          throw new Error(`Recursive extend is found: ${ty.name || '(unnamed)'}`);
        }

        for (const m of ext.members) {
          if (!ret.members.find(x => x[0] === m[0])) {
            ret.members.push([m[0], m[1], true, ...m.slice(3)]);
          } // TODO: Check for different types with the same name.

        }

      // FALL_THRU

      case 'symlink':
        ret.baseTypes.push(ext);
        break;

      case 'operator':
        {
          throw new Error(`Unresolved type operator is found: ${ext.operator}`);
        }
    } // NOTE: 'symlink' base types will resolved by calling `resolveSymbols()`.
    //       `resolveSymbols()` will call `derived()` after resolve symlink exts.

  }

  ret.members = ty.members.concat(ret.members);

  if (ty.baseTypes) {
    ret.baseTypes = ty.baseTypes.filter(x => x.kind !== 'symlink').concat(ret.baseTypes);
  }

  if (ret.baseTypes.length === 0) {
    delete ret.baseTypes;
  }

  const revMembers = ret.members.slice().reverse();

  for (const x of ret.members) {
    if (ret.members.find(m => m[0] === x[0]) !== revMembers.find(m => m[0] === x[0])) {
      throw new Error(`Duplicated member is found: ${x[0]} in ${ty.name || '(unnamed)'}`);
    }
  }

  let additionalProps = [];

  if (ret.baseTypes) {
    for (const base of ret.baseTypes) {
      if (base.kind === 'object') {
        if (base.additionalProps && 0 < base.additionalProps.length) {
          additionalProps = additionalProps.concat(base.additionalProps.map(x => [x[0], x[1], true, ...x.slice(3)]));
        }
      } // NOTE: 'symlink' base types will resolved by calling `resolveSymbols()`.
      //       `resolveSymbols()` will call `derived()` after resolve symlink exts.

    }
  }

  if (ty.additionalProps && 0 < ty.additionalProps.length) {
    additionalProps = additionalProps.concat(ty.additionalProps); // TODO: concat order
  }

  if (0 < additionalProps.length) {
    ret.additionalProps = additionalProps;
  }

  return ret;
}

exports.derived = derived;

function symlinkType(name) {
  return {
    kind: 'symlink',
    symlinkTargetName: name
  };
}

exports.symlinkType = symlinkType;

function withName(ty, name) {
  if (!name) {
    return ty;
  }

  return Object.assign(Object.assign({}, ty), {
    name
  });
}

exports.withName = withName;

function withTypeName(ty, typeName) {
  if (!typeName) {
    return ty;
  }

  return Object.assign(Object.assign({}, ty), {
    typeName
  });
}

exports.withTypeName = withTypeName;

function withOriginalTypeName(ty, originalTypeName) {
  if (!originalTypeName) {
    return ty;
  }

  return Object.assign(Object.assign({}, ty), {
    originalTypeName
  });
}

exports.withOriginalTypeName = withOriginalTypeName;

function withDocComment(ty, docComment) {
  if (!docComment) {
    return ty;
  }

  return Object.assign(Object.assign({}, ty), {
    docComment
  });
}

exports.withDocComment = withDocComment;

function withRange(minValue, maxValue) {
  return ty => {
    if (typeof minValue !== 'number' && typeof minValue !== 'string') {
      throw new Error(`Decorator '@range' parameter 'minValue' should be number or string.`);
    }

    if (typeof maxValue !== 'number' && typeof maxValue !== 'string') {
      throw new Error(`Decorator '@range' parameter 'maxValue' should be number or string.`);
    }

    if (ty.kind === 'optional') {
      const opt = ty.optional;

      if (opt.kind !== 'primitive') {
        throw new Error(`Decorator '@range' cannot be applied to anything other than 'primitive'.`);
      }

      return Object.assign(Object.assign({}, ty), {
        optional: Object.assign(Object.assign({}, opt), {
          minValue,
          maxValue
        })
      });
    } else {
      if (!ty || ty.kind !== 'primitive') {
        throw new Error(`Decorator '@range' cannot be applied to anything other than 'primitive'.`);
      }

      return Object.assign(Object.assign({}, ty), {
        minValue,
        maxValue
      });
    }
  };
}

exports.withRange = withRange;

function withMinValue(minValue) {
  return ty => {
    if (typeof minValue !== 'number' && typeof minValue !== 'string') {
      throw new Error(`Decorator '@minValue' parameter 'minValue' should be number or string.`);
    }

    if (ty.kind === 'optional') {
      const opt = ty.optional;

      if (opt.kind !== 'primitive') {
        throw new Error(`Decorator '@minValue' cannot be applied to anything other than 'primitive'.`);
      }

      return Object.assign(Object.assign({}, ty), {
        optional: Object.assign(Object.assign({}, opt), {
          minValue
        })
      });
    } else {
      if (!ty || ty.kind !== 'primitive') {
        throw new Error(`Decorator '@minValue' cannot be applied to anything other than 'primitive'.`);
      }

      return Object.assign(Object.assign({}, ty), {
        minValue
      });
    }
  };
}

exports.withMinValue = withMinValue;

function withMaxValue(maxValue) {
  return ty => {
    if (typeof maxValue !== 'number' && typeof maxValue !== 'string') {
      throw new Error(`Decorator '@maxValue' parameter 'maxValue' should be number or string.`);
    }

    if (ty.kind === 'optional') {
      const opt = ty.optional;

      if (opt.kind !== 'primitive') {
        throw new Error(`Decorator '@maxValue' cannot be applied to anything other than 'primitive'.`);
      }

      return Object.assign(Object.assign({}, ty), {
        optional: Object.assign(Object.assign({}, opt), {
          maxValue
        })
      });
    } else {
      if (!ty || ty.kind !== 'primitive') {
        throw new Error(`Decorator '@maxValue' cannot be applied to anything other than 'primitive'.`);
      }

      return Object.assign(Object.assign({}, ty), {
        maxValue
      });
    }
  };
}

exports.withMaxValue = withMaxValue;

function withGreaterThan(greaterThanValue) {
  return ty => {
    if (typeof greaterThanValue !== 'number' && typeof greaterThanValue !== 'string') {
      throw new Error(`Decorator '@greaterThan' parameter 'greaterThan' should be number or string.`);
    }

    if (ty.kind === 'optional') {
      const opt = ty.optional;

      if (opt.kind !== 'primitive') {
        throw new Error(`Decorator '@greaterThan' cannot be applied to anything other than 'primitive'.`);
      }

      return Object.assign(Object.assign({}, ty), {
        optional: Object.assign(Object.assign({}, opt), {
          greaterThanValue
        })
      });
    } else {
      if (!ty || ty.kind !== 'primitive') {
        throw new Error(`Decorator '@greaterThan' cannot be applied to anything other than 'primitive'.`);
      }

      return Object.assign(Object.assign({}, ty), {
        greaterThanValue
      });
    }
  };
}

exports.withGreaterThan = withGreaterThan;

function withLessThan(lessThanValue) {
  return ty => {
    if (typeof lessThanValue !== 'number' && typeof lessThanValue !== 'string') {
      throw new Error(`Decorator '@lessThan' parameter 'lessThan' should be number or string.`);
    }

    if (ty.kind === 'optional') {
      const opt = ty.optional;

      if (opt.kind !== 'primitive') {
        throw new Error(`Decorator '@lessThan' cannot be applied to anything other than 'primitive'.`);
      }

      return Object.assign(Object.assign({}, ty), {
        optional: Object.assign(Object.assign({}, opt), {
          lessThanValue
        })
      });
    } else {
      if (!ty || ty.kind !== 'primitive') {
        throw new Error(`Decorator '@lessThan' cannot be applied to anything other than 'primitive'.`);
      }

      return Object.assign(Object.assign({}, ty), {
        lessThanValue
      });
    }
  };
}

exports.withLessThan = withLessThan;

function withMinLength(minLength) {
  return ty => {
    if (typeof minLength !== 'number') {
      throw new Error(`Decorator '@minLength' parameter 'minLength' should be number.`);
    }

    if (ty.kind === 'optional') {
      const opt = ty.optional;

      if (opt.kind !== 'primitive') {
        throw new Error(`Decorator '@minLength' cannot be applied to anything other than 'primitive'.`);
      }

      return Object.assign(Object.assign({}, ty), {
        optional: Object.assign(Object.assign({}, opt), {
          minLength
        })
      });
    } else {
      if (!ty || ty.kind !== 'primitive') {
        throw new Error(`Decorator '@minLength' cannot be applied to anything other than 'primitive'.`);
      }

      return Object.assign(Object.assign({}, ty), {
        minLength
      });
    }
  };
}

exports.withMinLength = withMinLength;

function withMaxLength(maxLength) {
  return ty => {
    if (typeof maxLength !== 'number') {
      throw new Error(`Decorator '@maxLength' parameter 'maxLength' should be number.`);
    }

    if (ty.kind === 'optional') {
      const opt = ty.optional;

      if (opt.kind !== 'primitive') {
        throw new Error(`Decorator '@maxLength' cannot be applied to anything other than 'primitive'.`);
      }

      return Object.assign(Object.assign({}, ty), {
        optional: Object.assign(Object.assign({}, opt), {
          maxLength
        })
      });
    } else {
      if (!ty || ty.kind !== 'primitive') {
        throw new Error(`Decorator '@maxLength' cannot be applied to anything other than 'primitive'.`);
      }

      return Object.assign(Object.assign({}, ty), {
        maxLength
      });
    }
  };
}

exports.withMaxLength = withMaxLength;

function withMatch(pattern) {
  return ty => {
    if (typeof pattern !== 'object') {
      throw new Error(`Decorator '@match' parameter 'pattern' should be RegExp.`);
    }

    if (ty.kind === 'optional') {
      const opt = ty.optional;

      if (opt.kind !== 'primitive') {
        throw new Error(`Decorator '@match' cannot be applied to anything other than 'primitive'.`);
      }

      return Object.assign(Object.assign({}, ty), {
        optional: Object.assign(Object.assign({}, opt), {
          pattern
        })
      });
    } else {
      if (!ty || ty.kind !== 'primitive' || ty.primitiveName !== 'string') {
        throw new Error(`Decorator '@match' cannot be applied to anything other than 'primitive'.`);
      }

      return Object.assign(Object.assign({}, ty), {
        pattern
      });
    }
  };
}

exports.withMatch = withMatch;

function withStereotype(stereotype) {
  if (typeof stereotype !== 'string') {
    throw new Error(`Decorator '@stereotype' parameter 'stereotype' should be string.`);
  }

  if (protection_1.isUnsafeVarNames(protection_1.dummyTargetObject, stereotype)) {
    throw new Error(`Unsafe symbol name is appeared in stereotype assertion: ${stereotype}`);
  }

  return ty => {
    if (ty.kind === 'optional') {
      const ret = Object.assign(Object.assign({}, ty), {
        optional: Object.assign(Object.assign({}, ty.optional), {
          stereotype
        })
      });
      return ret;
    } else {
      const ret = Object.assign(Object.assign({}, ty), {
        stereotype
      });
      return ret;
    }
  };
}

exports.withStereotype = withStereotype;

function withConstraint(name, args) {
  if (typeof name !== 'string') {
    throw new Error(`Decorator '@constraint' parameter 'name' should be string.`);
  }

  if (protection_1.isUnsafeVarNames(protection_1.dummyTargetObject, name)) {
    throw new Error(`Unsafe symbol name is appeared in constraint assertion: ${name}`);
  }

  return ty => {
    if (ty.kind === 'optional') {
      const opt = ty.optional;
      const ret = Object.assign(Object.assign({}, ty), {
        optional: Object.assign(Object.assign({}, opt), {
          customConstraints: opt.customConstraints ? opt.customConstraints.slice().push(name) : [name],
          customConstraintsArgs: opt.customConstraintsArgs ? Object.assign(Object.assign({}, opt.customConstraintsArgs), {
            [name]: args
          }) : {
            [name]: args
          }
        })
      });
      return ret;
    } else {
      const ret = Object.assign(Object.assign({}, ty), {
        customConstraints: ty.customConstraints ? ty.customConstraints.slice().push(name) : [name],
        customConstraintsArgs: ty.customConstraintsArgs ? Object.assign(Object.assign({}, ty.customConstraintsArgs), {
          [name]: args
        }) : {
          [name]: args
        }
      });
      return ret;
    }
  };
}

exports.withConstraint = withConstraint;

function withForceCast() {
  return ty => {
    if (ty.kind === 'optional') {
      const ret = Object.assign(Object.assign({}, ty), {
        optional: Object.assign(Object.assign({}, ty.optional), {
          forceCast: true
        })
      });
      return ret;
    } else {
      const ret = Object.assign(Object.assign({}, ty), {
        forceCast: true
      });
      return ret;
    }
  };
}

exports.withForceCast = withForceCast;

function withRecordType() {
  return ty => {
    if (ty.kind === 'optional') {
      const ret = Object.assign(Object.assign({}, ty), {
        optional: Object.assign(Object.assign({}, ty.optional), {
          isRecordTypeField: true
        })
      });
      return ret;
    } else {
      const ret = Object.assign(Object.assign({}, ty), {
        isRecordTypeField: true
      });
      return ret;
    }
  };
}

exports.withRecordType = withRecordType;

function withMeta(meta) {
  return ty => {
    const ret = Object.assign(Object.assign({}, ty), {
      meta
    });
    return ret;
  };
}

exports.withMeta = withMeta;

function withMsg(messages) {
  return ty => {
    if (ty.kind === 'optional') {
      if (typeof messages === 'string') {
        const ret = Object.assign(Object.assign({}, ty), {
          message: messages,
          optional: Object.assign(Object.assign({}, ty.optional), {
            message: messages
          })
        });
        delete ret.messages;
        delete ret.optional.messages;
        return ret;
      } else {
        const ret = Object.assign(Object.assign({}, ty), {
          messages,
          optional: Object.assign(Object.assign({}, ty.optional), {
            messages
          })
        });
        delete ret.message;
        delete ret.optional.message;
        return ret;
      }
    } else {
      if (typeof messages === 'string') {
        const ret = Object.assign(Object.assign({}, ty), {
          message: messages
        });
        delete ret.messages;
        return ret;
      } else {
        const ret = Object.assign(Object.assign({}, ty), {
          messages
        });
        delete ret.message;
        return ret;
      }
    }
  };
}

exports.withMsg = withMsg;

function withMsgId(messageId) {
  return ty => {
    if (ty.kind === 'optional') {
      return Object.assign(Object.assign({}, ty), {
        messageId,
        optional: Object.assign(Object.assign({}, ty.optional), {
          messageId
        })
      });
    } else {
      return Object.assign(Object.assign({}, ty), {
        messageId
      });
    }
  };
}

exports.withMsgId = withMsgId;

/***/ }),

/***/ "./src/serializer.ts":
/*!***************************!*\
  !*** ./src/serializer.ts ***!
  \***************************/
/*! flagged exports */
/*! export TynderSchemaVersion [provided] [no usage info] [missing usage info prevents renaming] */
/*! export __esModule [provided] [no usage info] [missing usage info prevents renaming] */
/*! export deserialize [provided] [no usage info] [missing usage info prevents renaming] */
/*! export deserializeFromObject [provided] [no usage info] [missing usage info prevents renaming] */
/*! export serialize [provided] [no usage info] [missing usage info prevents renaming] */
/*! export serializeToObject [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_exports__, __webpack_require__ */
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

 // Copyright (c) 2019 Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.deserialize = exports.deserializeFromObject = exports.serialize = exports.serializeToObject = exports.TynderSchemaVersion = void 0;

const resolver_1 = __webpack_require__(/*! ./lib/resolver */ "./src/lib/resolver.ts");

exports.TynderSchemaVersion = 'tynder/1.0';

function hasMetaInfo(ty) {
  let hasInfo = false;

  if (ty.messages) {
    hasInfo = true;
  }

  if (ty.message) {
    hasInfo = true;
  }

  if (ty.messageId) {
    hasInfo = true;
  }

  switch (ty.kind) {
    case 'repeated':
      if (typeof ty.min === 'number') {
        hasInfo = true;
      }

      if (typeof ty.max === 'number') {
        hasInfo = true;
      }

      break;

    case 'primitive':
      if (typeof ty.minValue === 'number') {
        hasInfo = true;
      }

      if (typeof ty.maxValue === 'number') {
        hasInfo = true;
      }

      if (typeof ty.greaterThanValue === 'number') {
        hasInfo = true;
      }

      if (typeof ty.lessThanValue === 'number') {
        hasInfo = true;
      }

      if (typeof ty.minLength === 'number') {
        hasInfo = true;
      }

      if (typeof ty.maxLength === 'number') {
        hasInfo = true;
      }

      if (ty.pattern) {
        hasInfo = true;
      }

      break;
  }

  return hasInfo;
}

function serializeInner(ty, nestLevel) {
  if (0 < nestLevel && ty.typeName && !hasMetaInfo(ty)) {
    switch (ty.kind) {
      case 'optional':
        // nothing to do.
        break;

      default:
        return Object.assign(Object.assign({
          kind: 'symlink',
          symlinkTargetName: ty.typeName,
          typeName: ty.typeName
        }, ty.name ? {
          name: ty.name
        } : {}), ty.docComment ? {
          docComment: ty.docComment
        } : {});
    }
  }

  const ret = Object.assign({}, ty);

  switch (ret.kind) {
    case 'never':
    case 'any':
    case 'unknown':
    case 'symlink':
    case 'operator':
      break;

    case 'primitive-value':
      if (typeof ret.value === 'bigint') {
        ret.value = String(ret.value);
        ret.primitiveName = 'bigint';
      }

      break;

    case 'primitive':
      if (ret.pattern) {
        ret.pattern = `/${ret.pattern.source}/${ret.pattern.flags}`;
      }

      break;

    case 'repeated':
      ret.repeated = serializeInner(ret.repeated, nestLevel + 1);
      break;

    case 'spread':
      ret.spread = serializeInner(ret.spread, nestLevel + 1);
      break;

    case 'sequence':
      ret.sequence = ret.sequence.map(x => serializeInner(x, nestLevel + 1));
      break;

    case 'one-of':
      ret.oneOf = ret.oneOf.map(x => serializeInner(x, nestLevel + 1));
      break;

    case 'optional':
      ret.optional = serializeInner(ret.optional, nestLevel + 1);
      break;

    case 'enum':
      ret.values = ret.values.slice().map(x => x[2] === null || x[2] === void 0 ? x.slice(0, 2) : x);
      break;

    case 'object':
      ret.members = ret.members.map(x => [x[0], serializeInner(x[1], nestLevel + 1), ...x.slice(2)]);

      if (ret.additionalProps) {
        ret.additionalProps = ret.additionalProps.map(x => [x[0].map(p => typeof p === 'string' ? p : `/${p.source}/${p.flags}`), serializeInner(x[1], nestLevel + 1), ...x.slice(2)]);
      }

      if (ret.baseTypes) {
        // NOTE: convert 'baseTypes' to 'symlink'.
        ret.baseTypes = ret.baseTypes.map(x => serializeInner(x, nestLevel + 1));
      }

      break;

    default:
      throw new Error(`Unknown type assertion: ${ret.kind}`);
  }

  return ret;
}

function serializeToObject(schema) {
  const ret = {
    version: exports.TynderSchemaVersion,
    ns: {}
  };
  const current = {};

  for (const ty of schema.entries()) {
    current[ty[0]] = serializeInner(ty[1].ty, 0);
  }

  ret.ns['.'] = current;
  return ret;
}

exports.serializeToObject = serializeToObject;

function serialize(schema, asTs) {
  const ret = serializeToObject(schema);

  if (asTs) {
    return `\n// tslint:disable: object-literal-key-quotes\n` + `const schema = ${JSON.stringify(ret, null, 2)};\nexport default schema;\n\n` + `export const enum Schema {\n${Object.keys(ret.ns['.']).filter(x => {
      return !(/^[0-9]/.test(x) || /[\u0000-\u001f\u007f]/.test(x) || /\s/.test(x) || /[@#$%^&+-=:;.,?!'"`/|{}()<>[\]\*\\]/.test(x));
    }).map(x => `    ${x} = '${x}',\n`).join('')}` + `}\n// tslint:enable: object-literal-key-quotes\n`;
  } else {
    return JSON.stringify(ret, null, 2);
  }
}

exports.serialize = serialize;

function deserializeRegExp(pat, errMsg) {
  const m = /^\/(.*)\/([gimsuy]*)$/s.exec(pat);

  if (m) {
    return new RegExp(m[1], m[2]);
  } else {
    throw new Error(errMsg);
  }
}

function deserializeInner(ty) {
  const ret = Object.assign({}, ty);

  switch (ret.kind) {
    case 'never':
    case 'any':
    case 'unknown':
    case 'enum':
    case 'symlink':
    case 'operator':
      // NOTE: 'symlink' and 'operator' will resolved by calling 'resolveSymbols()' in 'deserialize()'.
      break;

    case 'primitive-value':
      if (ret.primitiveName === 'bigint') {
        delete ret.primitiveName;
        ret.value = BigInt(ret.value);
      }

      break;

    case 'primitive':
      if (ret.pattern) {
        ret.pattern = deserializeRegExp(ret.pattern, `Unknown pattern match assertion: ${ret.pattern}`);
      }

      break;

    case 'repeated':
      ret.repeated = deserializeInner(ret.repeated);
      break;

    case 'spread':
      ret.spread = deserializeInner(ret.spread);
      break;

    case 'sequence':
      ret.sequence = ret.sequence.map(x => deserializeInner(x));
      break;

    case 'one-of':
      ret.oneOf = ret.oneOf.map(x => deserializeInner(x));
      break;

    case 'optional':
      ret.optional = deserializeInner(ret.optional);
      break;

    case 'object':
      ret.members = ret.members.map(x => [x[0], deserializeInner(x[1]), ...x.slice(2)]);

      if (ret.additionalProps) {
        ret.additionalProps = ret.additionalProps.map(x => [x[0].map(p => String(p).startsWith('/') ? deserializeRegExp(p, `Unknown additional props: ${p}`) : p), deserializeInner(x[1]), ...x.slice(2)]);
      } // NOTE: keep 'baseTypes' as 'symlink'.


      break;

    default:
      throw new Error(`Unknown type assertion: ${ret.kind}`);
  }

  return ret;
}

function deserializeFromObject(obj) {
  if (obj.version !== exports.TynderSchemaVersion) {
    throw new Error(`Unknown schema version: ${obj.version}`);
  }

  const schema = new Map();
  const current = obj.ns['.'];

  for (const k in current) {
    if (!Object.prototype.hasOwnProperty.call(current, k)) {
      continue;
    }

    schema.set(k, {
      ty: deserializeInner(current[k]),
      exported: false,
      isDeclare: false,
      resolved: false
    });
  }

  return resolver_1.resolveSchema(schema, {
    isDeserialization: true
  });
}

exports.deserializeFromObject = deserializeFromObject;

function deserialize(text) {
  const parsed = JSON.parse(text);
  return deserializeFromObject(parsed);
}

exports.deserialize = deserialize;

/***/ }),

/***/ "fs":
/*!*********************!*\
  !*** external "fs" ***!
  \*********************/
/*! dynamic exports */
/*! exports [maybe provided (runtime-defined)] [no usage info] */
/*! runtime requirements: module */
/***/ ((module) => {

module.exports = require("fs");;

/***/ }),

/***/ "path":
/*!***********************!*\
  !*** external "path" ***!
  \***********************/
/*! dynamic exports */
/*! exports [maybe provided (runtime-defined)] [no usage info] */
/*! runtime requirements: module */
/***/ ((module) => {

module.exports = require("path");;

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		if(__webpack_module_cache__[moduleId]) {
/******/ 			return __webpack_module_cache__[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => Object.prototype.hasOwnProperty.call(obj, prop)
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
/******/ 	// module exports must be returned from runtime so entry inlining is disabled
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__("./src/cli.ts");
/******/ })()
;
//# sourceMappingURL=tynder.js.map